;----------------------------------------------------------------
;	X68k High-speed Assembler
;		AhbVO[h̉
;		< eamode.s >
;
;	$Id: eamode.s,v 2.7  1999  3/ 1(Mon) 03:00:50 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;			  1996-99  by M.Kamada
;----------------------------------------------------------------

	.include	has.equ
	.include	cputype.equ
	.include	eamode.equ
	.include	register.equ
	.include	tmpcode.equ
	.include	symbol.equ

	.cpu	68000
	.text


;----------------------------------------------------------------
;	WX^Iyh̉
;----------------------------------------------------------------

;----------------------------------------------------------------
;	Iyh̃f[^WX^𓾂
;	in :a0=R[hꂽIyhw|C^
;	out:d0.w=Iyh0 / d1.w=WX^ԍ
;		             Ȃ-1
getdreg::
	move.w	(a0)+,d1
	cmpi.w	#OT_REGISTER|REG_D0,d1
	bcs	getdreg9
	cmpi.w	#OT_REGISTER|REG_D7,d1
	bhi	getdreg9
	andi.w	#$0007,d1
	moveq.l	#0,d0
	rts

getdreg9:
	subq.l	#2,a0
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;	Iyh̃AhXWX^𓾂
;	in :a0=R[hꂽIyhw|C^
;	out:d0.w=Iyh0 / d1.w=WX^ԍ
;		             Ȃ-1
getareg::
	move.w	(a0)+,d1
	cmpi.w	#OT_REGISTER|REG_A0,d1
	bcs	getareg9
	cmpi.w	#OT_REGISTER|REG_A7,d1
	bhi	getareg9
	andi.w	#$0007,d1
	moveq.l	#0,d0
	rts

getareg9:
	subq.l	#2,a0
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;	Iyh̃f[^EAhXWX^𓾂
;	in :a0=R[hꂽIyhw|C^
;	out:d0.w=Iyh0 / d1.w=WX^ԍ
;		             Ȃ-1
getreg::
	move.w	(a0)+,d1
	cmpi.w	#OT_REGISTER|REG_D0,d1
	bcs	getreg9
	cmpi.w	#OT_REGISTER|REG_A7,d1
	bhi	getreg9
	andi.w	#$000F,d1
	moveq.l	#0,d0
	rts

getreg9:
	subq.l	#2,a0
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;	Iyh̃f[^WX^EyA𓾂
;	in :a0=R[hꂽIyhw|C^
;	out:d0.w=Iyh0 / d1.w:d2.w=WX^ԍ
;		             Ȃ-1
getdregp::
	move.l	a0,-(sp)
	bsr	getdreg			;f[^WX^𓾂
	bmi	getdregp9
	move.w	d1,d2
	cmpi.w	#':'|OT_CHAR,(a0)+
	bne	getdregp9
	bsr	getdreg			;f[^WX^𓾂
	bmi	getdregp9
	exg.l	d1,d2
	addq.l	#4,sp
	moveq.l	#0,d0
	rts

getdregp9:
	movea.l	(sp)+,a0
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;	Iyh̃WX^ԐځEyA𓾂
;	in :a0=R[hꂽIyhw|C^
;	out:d0.w=Iyh0 / d1.w:d2.w=WX^ԍ
;		             Ȃ-1
getregpp::
	move.l	a0,-(sp)
	cmpi.w	#'('|OT_CHAR,(a0)+
	bne	getregpp9
	bsr	getreg			;WX^𓾂
	bmi	getregpp9
	move.w	d1,d2
	cmpi.w	#')'|OT_CHAR,(a0)+
	bne	getregpp9
	cmpi.w	#':'|OT_CHAR,(a0)+
	bne	getregpp9
	cmpi.w	#'('|OT_CHAR,(a0)+
	bne	getregpp9
	bsr	getreg			;WX^𓾂
	bmi	getregpp9
	cmpi.w	#')'|OT_CHAR,(a0)+
	bne	getregpp9
	exg.l	d1,d2
	addq.l	#4,sp
	moveq.l	#0,d0
	rts

getregpp9:
	movea.l	(sp)+,a0
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;	Iyh̃WX^Xg𓾂
;	in :a0=R[hꂽIyhw|C^
;	out:d0.w=Iyh0 / d1.w=WX^Xg
;		             Ȃ-1
getreglist::
	movea.l	a0,a2
	moveq.l	#0,d3			;WX^Xg
	moveq.l	#-1,d4			;w蒆̃WX^̍őԍ
	moveq.l	#0,d5			;[jOo͂邩̃tO
getreglist1:
	bsr	getreg
	bmi	getreglist99
	bset.l	d1,d3
	cmp.b	d4,d1
	bgt	getreglist2
	st.b	d5			;dw/tw
	bra	getreglist3

getreglist2:
	move.b	d1,d4

getreglist3:
	move.w	(a0)+,d0
	cmp.w	#'/'|OT_CHAR,d0
	beq	getreglist1
	cmp.w	#'-'|OT_CHAR,d0
	bne	getreglist9

	move.b	d1,d2
	bsr	getreg
	bmi	getreglist99
	move.b	d1,d0
	eor.b	d2,d0
	andi.b	#$08,d0
	sne.b	d0			;Dn,An̍
	or.b	d0,d5
	cmp.b	d2,d1
	bhi	getreglist4
	exg.l	d1,d2
	bset.l	d2,d3
	st.b	d5			;tw
	bra	getreglist5

getreglist4:
	addq.b	#1,d2
	bset.l	d2,d3
	sne.b	d0			;dw
	or.b	d0,d5
getreglist5:
	cmp.b	d2,d1
	bhi	getreglist4

	cmp.b	d4,d1
	bgt	getreglist6
	st.b	d5			;dw/tw
	bra	getreglist7

getreglist6:
	move.b	d1,d4

getreglist7:
	move.w	(a0)+,d0
	cmp.w	#'/'|OT_CHAR,d0
	beq	getreglist1

getreglist9
	subq.l	#2,a0
	move.w	d3,d1
	tst.b	d5
	beq	getreglist91
	bsr	reglwarn		;WX^Xgw̃[jO
getreglist91
	moveq.l	#0,d0
	rts

getreglist99:
	movea.l	a2,a0
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;	Iyh̐䃌WX^𓾂
;	in :a0=R[hꂽIyhw|C^
;	out:d0.w=Iyh0 / d1.w=䃌WX^ԍ
;		             Ȃ-1
getcreg::
	move.w	(a0)+,d1
	lea.l	(getctbl,pc),a1
getcreg1:
	move.w	(a1)+,d0
	beq	getcreg9		;䃌WX^Ȃ
	cmp.b	d0,d1
	beq	getcreg2
	addq.l	#4,a1
	bra	getcreg1

getcreg2:
	move.w	(a1)+,d0
	and.w	(CPUTYPE,a6),d0
	beq	getcreg9
getcreg3:
	move.w	(a1)+,d1
	moveq.l	#0,d0
	rts

getcreg9:
	subq.l	#2,a0
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;	䃌WX^R[he[u
cregtbl	.macro	num,code,mpu
	.dc.w	$FF00+num,mpu,code
	.endm

getctbl:
;ColdFireɕWŎĂ鐧䃌WX^VBR̂
	cregtbl	REG_SFC,	$0000,	C010|C020|C030|C040|C060
	cregtbl	REG_DFC,	$0001,	C010|C020|C030|C040|C060
	cregtbl	REG_CACR,	$0002,	     C020|C030|C040|C060|C520|C530|C540
	cregtbl	REG_USP,	$0800,	C010|C020|C030|C040|C060
	cregtbl	REG_VBR,	$0801,	C010|C020|C030|C040|C060|C520|C530|C540
	cregtbl	REG_CAAR,	$0802,	     C020|C030
	cregtbl	REG_MSP,	$0803,	     C020|C030|C040
	cregtbl	REG_ISP,	$0804,	     C020|C030|C040
	cregtbl	REG_TC,		$0003,		       C040|C060|C520|C530|C540
	cregtbl	REG_ITT0,	$0004,		       C040|C060|C520|C530|C540
	cregtbl	REG_ITT1,	$0005,		       C040|C060|C520|C530|C540
	cregtbl	REG_DTT0,	$0006,		       C040|C060|C520|C530|C540
	cregtbl	REG_DTT1,	$0007,		       C040|C060|C520|C530|C540
	cregtbl	REG_MMUSR,	$0805,		       C040
	cregtbl	REG_URP,	$0806,		       C040|C060
	cregtbl	REG_SRP,	$0807,		       C040|C060
	cregtbl	REG_BUSCR,	$0008,			    C060
	cregtbl	REG_PCR,	$0808,			    C060
	cregtbl	REG_PC,		$080F,				 C520|C530|C540
	cregtbl	REG_ROMBAR,	$0C00,				 C520|C530|C540
	cregtbl	REG_RAMBAR0,	$0C04,				 C520|C530|C540
	cregtbl	REG_RAMBAR1,	$0C05,				 C520|C530|C540
	cregtbl	REG_MBAR,	$0C0F,				 C520|C530|C540
	.dc.w	0

;----------------------------------------------------------------
;	Iyh̃rbgtB[hw𓾂
;	in :a0=R[hꂽIyhw|C^
;	    a1=AhbVO[h߃obt@ւ̃|C^
;	out:a0=Iyh̏Iʒuw
;	    d0.w=ꂽIyhf[^
getbitfield::
	movem.l	d1/d7/a2,-(sp)
	moveq.l	#0,d7
	clr.w	(RPNLEN1,a1)
	clr.w	(RPNLEN2,a1)
	cmp.w	#'{'|OT_CHAR,(a0)+	;ItZbg
	bne	iladrerr
	bsr	getdreg			;f[^WX^𓾂
	bmi	getbitfield1
	lsl.w	#6,d1
	or.w	d1,d7
	or.w	#$0800,d7
	bra	getbitfield5

getbitfield1:
	lea.l	(RPNBUF1,a1),a2
	bsr	getbfvalue
	bmi	getbitfield5
	cmp.l	#31,d1
	bhi	ilvalueerr		;ItZbgl0`31
	lsl.w	#6,d1
	or.w	d1,d7
	clr.w	(RPNLEN1,a1)
getbitfield5:				;
	cmp.w	#':'|OT_CHAR,(a0)+
	bne	iladrerr
	bsr	getdreg			;f[^WX^𓾂
	bmi	getbitfield6
	or.w	d1,d7
	or.w	#$0020,d7
	bra	getbitfield9

getbitfield6:
	lea.l	(RPNBUF2,a1),a2
	bsr	getbfvalue
	bmi	getbitfield9
	tst.l	d1
	beq	ilvalueerr		;1`32
	cmp.l	#32,d1
	bhi	ilvalueerr
	and.w	#31,d1
	or.w	d1,d7
	clr.w	(RPNLEN2,a1)
getbitfield9:
	cmp.w	#'}'|OT_CHAR,(a0)+
	bne	iladrerr
	move.w	d7,d0
	movem.l	(sp)+,d1/d7/a2
	rts

getbfvalue:				;rbgtB[h̒l𓾂
	cmp.w	#'#'|OT_CHAR,(a0)
	bne	getbfvalue1
	addq.l	#2,a0			;#nłnł
getbfvalue1:
	bsr	geteaexpr
	tst.w	d0
	bmi	iladrerr
	tst.b	(RPNSIZE1-RPNBUF1,a2)
	bpl	ilsizeerr		;TCYw肪΃G[
	tst.w	(RPNLEN1-RPNBUF1,a2)
	bpl	getbfvalue9		;̒lȂ
	move.l	(a2),d1
	moveq.l	#0,d0
	rts

getbfvalue9:
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;	Iyh̕_f[^WX^𓾂
;	in :a0=R[hꂽIyhw|C^
;	out:d0.w=Iyh0 / d1.w=WX^ԍ
;		             Ȃ-1
getfpreg::
	move.w	(a0)+,d1
	cmpi.w	#OT_REGISTER|REG_FP0,d1
	bcs	getfpreg9
	cmpi.w	#OT_REGISTER|REG_FP7,d1
	bhi	getfpreg9
	andi.w	#$0007,d1
	moveq.l	#0,d0
	rts

getfpreg9:
	subq.l	#2,a0
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;	Iyh̕_f[^WX^Xg𓾂
;	in :a0=R[hꂽIyhw|C^
;	out:d0.w=Iyh0 / d1.w=WX^Xg
;		             Ȃ-1
getfpreglist::
	movea.l	a0,a2
	moveq.l	#0,d3			;WX^Xg
	moveq.l	#-1,d4			;w蒆̃WX^̍őԍ
	moveq.l	#0,d5			;[jOo͂邩̃tO
getfpreglist1:
	bsr	getfpreg
	bmi	getfpreglist99
	moveq.l	#7,d0
	sub.w	d1,d0			;(rbgtȂ̂)
	bset.l	d0,d3
	cmp.b	d4,d1
	bgt	getfpreglist2
	st.b	d5			;dw/tw
	bra	getfpreglist3

getfpreglist2:
	move.b	d1,d4

getfpreglist3:
	move.w	(a0)+,d0
	cmp.w	#'/'|OT_CHAR,d0
	beq	getfpreglist1
	cmp.w	#'-'|OT_CHAR,d0
	bne	getfpreglist9

	move.b	d1,d2
	bsr	getfpreg
	bmi	getfpreglist99
	cmp.b	d2,d1
	bhi	getfpreglist4
	exg.l	d1,d2
	moveq.l	#7,d0
	sub.w	d2,d0			;(rbgtȂ̂)
	bset.l	d0,d3
	st.b	d5			;tw
	bra	getfpreglist5

getfpreglist4:
	addq.b	#1,d2
	moveq.l	#7,d0
	sub.w	d2,d0			;(rbgtȂ̂)
	bset.l	d0,d3
	sne.b	d0			;dw
	or.b	d0,d5
getfpreglist5:
	cmp.b	d2,d1
	bhi	getfpreglist4

	cmp.b	d4,d1
	bgt	getfpreglist6
	st.b	d5			;dw/tw
	bra	getfpreglist7

getfpreglist6:
	move.b	d1,d4

getfpreglist7:
	move.w	(a0)+,d0
	cmp.w	#'/'|OT_CHAR,d0
	beq	getfpreglist1

getfpreglist9
	subq.l	#2,a0
	move.w	d3,d1
	tst.b	d5
	beq	getfpreglist91
	bsr	reglwarn		;WX^Xgw̃[jO
getfpreglist91
	moveq.l	#0,d0
	rts

getfpreglist99:
	movea.l	a2,a0
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;	Iyh̕_VXe䃌WX^Xg𓾂
;	in :a0=R[hꂽIyhw|C^
;	out:d0.w=Iyh0 / d1.w=WX^Xg / d2.w=WX^-1
;		             Ȃ-1
getfpcreglist::
	movea.l	a0,a2
	moveq.l	#-1,d2			;w肳ꂽWX^
	moveq.l	#0,d3			;WX^Xg
	moveq.l	#-1,d4			;w蒆̃WX^̍őԍ
	moveq.l	#0,d5			;[jOo͂邩̃tO
getfpcreglist1:
	move.w	(a0)+,d1
	sub.w	#REG_FPCR|OT_REGISTER,d1
	bcs	getfpcreglist99
	cmp.w	#REG_FPIAR-REG_FPCR,d1
	bhi	getfpcreglist99		;IyhFPCR/FPSR/FPIARłȂ
	moveq.l	#2,d0
	sub.w	d1,d0			;(rbgtȂ̂)
	bset.l	d0,d3
	bne	getfpcreglist15
	addq.w	#1,d2
getfpcreglist15:
	cmp.b	d4,d1
	bgt	getfpcreglist2
	st.b	d5			;dw/tw
	bra	getfpcreglist3

getfpcreglist2:
	move.b	d1,d4
getfpcreglist3:
	move.w	(a0)+,d0
	cmp.w	#'/'|OT_CHAR,d0
	beq	getfpcreglist1
getfpcreglist9
	subq.l	#2,a0
	move.w	d3,d1
	ror.w	#6,d1
	tst.b	d5
	beq	getfpcreglist91
	bsr	reglwarn		;WX^Xgw̃[jO
getfpcreglist91
	moveq.l	#0,d0
	rts

getfpcreglist99:
	movea.l	a2,a0
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;	Iyhkt@N^w𓾂
;	in :a0=R[hꂽIyhw|C^
;	    d6.w=RvZbT߃[h
;	out:a0=Iyh̏Iʒuw
;	    d6.w=RvZbT߃[h
getkfactor::
	cmp.w	#'{'|OT_CHAR,(a0)+
	bne	iladrerr
	bsr	getdreg			;f[^WX^𓾂
	bmi	getkfactor1
	lsl.w	#4,d1			;Ikt@N^ {Dn}
	or.w	d1,d6
	or.w	#$1C00,d6
	bra	getkfactor9

getkfactor1:				;ÓIkt@N^ {#n}
	cmp.w	#'#'|OT_CHAR,(a0)+
	bne	iladrerr
	lea.l	(RPNBUFEX,a6),a2
	bsr	geteaexpr
	tst.w	d0
	bmi	iladrerr
	tst.b	(RPNSIZEEX,a6)
	bpl	ilsizeerr		;TCYw肪΃G[
	tst.w	(RPNLENEX,a6)
	bpl	iloprerr		;̒lȂ
	move.l	(a2),d1
	cmp.l	#-64,d1			;kt@N^-64`63
	blt	ilvalueerr
	cmp.l	#63,d1
	bgt	ilvalueerr
	and.w	#$007F,d1
	or.w	d1,d6
getkfactor9:
	cmp.w	#'}'|OT_CHAR,(a0)+
	bne	iladrerr
	rts


;----------------------------------------------------------------
;	Iyh̃AhbVO[h
;----------------------------------------------------------------

;----------------------------------------------------------------
;	t|[hL@ɕϊAobt@Ɋi[
;geteamodegetfpeamode̗Ŏg
;getfpeamodeł͓\ŏ̎𓾂邽߂ɂgp̂ŁA
;ɂׂłȂƂ̓G[Ԃ
;.q̏
;	߂SZQƂ̓G[ɂ
;	߂SZS|SZD|SZX|SZPׂĂăTCY.b/.w/lłȂƂ́A
;	G[ɂsďI(-1Ԃ)
geteaexpr::				;O`
	exg.l	a1,a2
	move.l	a0,-(sp)		;convrpn̑Oa0ۑĂ
	bsr	convrpn			;ϊ
	tst.w	d0
	bmi	geteaexpr5		;ϊłȂ
	move.b	(EXPRSIZE,a6),d0		;̃TCYw
	cmpi.b	#OT_SIZE>>8,(a0)
	bne	geteaexpr1
	move.w	(a0)+,d0		;̌ɃTCYw肪΂D
geteaexpr1:
	cmpi.b	#SZ_SHORT,d0
	blt	geteaexpr3		;.b/.w/.lȂΑfʂ
geteaexpr2:
	move.l	a3,-(sp)
	tst.l	(CMDTBLPTR,a6)
	beq	ilsizeerr		;߂ȂƂ.b/.w/.lȊO̓G[
	movea.l	(CMDTBLPTR,a6),a3
	cmpi.b	#SZ_QUAD,d0
	bne	geteaexpr6
	tst.b	(SYM_SIZE,a3)		;gȂTCỸrbg1
	bpl	geteaexpr4		;SZQ̂.q𖳎
geteaexpr6:
	moveq.l	#SZS|SZD|SZX|SZP,d0
	and.b	(SYM_SIZE,a3),d0	;gȂTCỸrbg1
	bne	ilsizeerr		;_߂ł͂Ȃ̂.b/.w/.lȊO̓G[
	move.l	(sp)+,a3
geteaexpr5:
	movea.l	(sp)+,a0		;a0𕜌
	moveq.l	#-1,d0			;ƂĂ̏𒆎~
	bra	geteaexpr9

geteaexpr4:
	movea.l	(sp)+,a3
geteaexpr3:
	addq.l	#4,sp			;convrpn̑Oa0̂Ă
	move.w	d1,(RPNLEN1-RPNBUF1,a1)	;̒
	move.b	d0,(RPNSIZE1-RPNBUF1,a1)	;TCYw𓾂
	bsr	calcrpn			;ϊvZ
	tst.w	d0
	bne	geteaexpr8
	move.l	d1,(a1)			;萔̏ꍇ
	moveq.l	#-1,d1
	move.w	d1,(RPNLEN1-RPNBUF1,a1)	;̒(萔)
geteaexpr8:
	moveq.l	#0,d0
geteaexpr9:
	exg.l	a1,a2
	rts

;----------------------------------------------------------------
;	R[hꂽIyhAhbVO[h߂
;	in :a0=R[hꂽIyhw|C^
;	    a1=AhbVO[h߃obt@ւ̃|C^
;	out:a0=Iyh̏Iʒuw
;	    d0.w=ꂽAhbVO[hrbg
geteamode_noopc::
	st.b	(ABSLTOOPCCAN,a6)
geteamode::
	clr.w	(RPNLEN1,a1)
	clr.w	(RPNLEN2,a1)
	move.w	(a0),d0
	cmp.w	#'#'|OT_CHAR,d0
	beq	getea_imm		;#xxxx
	move.w	d0,d1
	and.w	#$FF00,d1
	cmp.w	#OT_REGISTER,d1
	beq	getea_reg		;WX^
geteamode0:
	cmp.w	#'('|OT_CHAR,d0
	beq	geteamode_par		;(c
	cmp.w	#'-'|OT_CHAR,d0
	bne	geteanum

	cmp.w	#'('|OT_CHAR,(2,a0)
	bne	geteanum
	move.w	(4,a0),d1
	and.w	#$FF00,d1
	cmp.w	#OT_REGISTER,d1
	beq	getea_decadr		;-(Rnc

geteanum:
	lea.l	(RPNBUF1,a1),a2
	bsr	geteaexpr
	tst.w	d0
	bmi	geteanum_par
	cmpi.w	#'('|OT_CHAR,(a0)
	bne	getea_abslw		;xxxx
	addq.l	#2,a0			;xxxx(c
	bra	geteapar

geteanum_par:
	cmp.w	#'('|OT_CHAR,(a0)+
	beq	geteapar		;(xxxxc ?
	bra	exprerr_ea		;YAhbVO݂Ȃ

geteamode_par:
	move.w	(2,a0),d1
	and.w	#$FF00,d1
	cmp.w	#OT_REGISTER,d1
	bne	geteanum
	addq.l	#2,a0			;(Rnc
;	bra	geteapar

;----------------------------------------------------------------
;	'('Ŏn܂AhbVỎ
;	d2.w=:x[XWX^w:0/TvX:1/wς:-1
;	     :x[XWX^ԍ(0`7)/PCԐڂȂ-1
;	d3.w=:CfbNXWX^ԍ,TCY,XP[l
;	     :CfbNXWX^w:0/TvX:1/wς:-1
;	d4.w=:|XgCfbNXȂ-1/vCfbNXȂ0
;	     :ԐڃAhbVOgp:0/gp:1/w蒆:-1
geteapar:
	moveq.l	#0,d2			;x[XWX^w
	moveq.l	#0,d3			;CfbNXWX^w
	moveq.l	#0,d4			;ԐڃAhbVOȂ
geteapar1:
	move.w	(a0),d0			;AhbVO̗vf𓾂
	move.w	d0,d1
	and.w	#$FF00,d1
	cmp.w	#OT_REGISTER,d1
	beq	geteapar_reg		;WX^
	cmp.w	#'['|OT_CHAR,d0
	beq	geteapar_ind		;'['(ԐڃAhbVOwJn)
					;?
	tst.b	d4
	bmi	geteapar_bdexpr		;Ԑڎw蒆Ȃx[XfBXv[Xg
	bne	geteapar_odexpr		;ԐڎwȂAE^fBXv[Xg
	tst.w	(RPNLEN1,a1)
	bne	geteapar_bd2expr	;x[XfBXv[Xgwς

	lea.l	(RPNBUF1,a1),a2		;x[XorAE^fBXv[Xg
	bsr	geteaexpr
	tst.w	d0
	bne	exprerr_ea
	move.w	(a0)+,d0
	cmp.w	#'['|OT_CHAR,d0
	bne	geteapar_next1
	bra	geteapar_ind3		;xxxx[c (x[XfBXv[Xgm)

geteapar_bdexpr:			;x[XfBXv[Xg𓾂
	tst.w	(RPNLEN1,a1)
	bne	exprerr_ea		;łɃfBXv[Xgw肪
	lea.l	(RPNBUF1,a1),a2
	bsr	geteaexpr
	tst.w	d0
	bne	exprerr_ea
	bra	geteapar_next

geteapar_odexpr:			;AE^fBXv[Xg𓾂
	tst.w	(RPNLEN2,a1)
	bne	exprerr_ea		;łɃfBXv[Xgw肪
	lea.l	(RPNBUF2,a1),a2
	bsr	geteaexpr
	tst.w	d0
	bne	exprerr_ea
	bra	geteapar_next

geteapar_bd2expr:			;x[XfBXv[Xg𓾂
	tst.w	(RPNLEN2,a1)		;(̎w͊ʂ̊O)
	bne	exprerr_ea		;łɃfBXv[Xgw肪
	move.b	(RPNSIZE1,a1),(RPNSIZE2,a1)
	move.w	(RPNLEN1,a1),d0
	clr.w	(RPNLEN1,a1)		;x[XfBXv[Xg
	move.w	d0,(RPNLEN2,a1)		;	AE^fBXv[XgɕύX
	bpl	geteapar_bd2expr1
	move.l	(RPNBUF1,a1),(RPNBUF2,a1)
	bra	geteapar_bd2expr3

geteapar_bd2expr1:
	move.l	a1,-(sp)
	lea.l	(RPNBUF1,a1),a2
	lea.l	(RPNBUF2,a1),a1
geteapar_bd2expr2:
	move.w	(a2)+,(a1)+
	dbra	d0,geteapar_bd2expr2
	movea.l	(sp)+,a1
geteapar_bd2expr3:
	lea.l	(RPNBUF1,a1),a2
	bsr	geteaexpr
	tst.w	d0
	bne	exprerr_ea
	cmp.w	#'['|OT_CHAR,(a0)+
	bne	exprerr_ea		;ԐڃAhbVOn܂Ȃ΃G[
	bra	geteapar_ind3

geteapar_ind:				;ԐڃAhbVOJn('[')
	addq.l	#2,a0

	move.w	(RPNLEN1,a1),d0
	beq	geteapar_ind3		;x[XfBXv[Xg͎w肳ĂȂ
	move.b	(RPNSIZE1,a1),(RPNSIZE2,a1)
	clr.w	(RPNLEN1,a1)		;x[XfBXv[Xg
	move.w	d0,(RPNLEN2,a1)		;	AE^fBXv[XgɕύX
	bpl	geteapar_ind1
	move.l	(RPNBUF1,a1),(RPNBUF2,a1)
	bra	geteapar_ind3

geteapar_ind1:
	move.l	a1,-(sp)
	lea.l	(RPNBUF1,a1),a2
	lea.l	(RPNBUF2,a1),a1
geteapar_ind2:
	move.w	(a2)+,(a1)+
	dbra	d0,geteapar_ind2
	movea.l	(sp)+,a1

geteapar_ind3:
	tst.b	d4
	bne	exprerr_ea		;'['xw肳ꂽ
	moveq.l	#-1,d4			;|XgCfbNXtԐڃAhbVO
	tst.w	d2
	beq	geteapar1		;x[XWX^͂܂w肳ĂȂ
	tst.b	d2
	bmi	exprerr_ea		;PCx[XWX^wς(pc/zpc)
	tst.b	d3
	bne	exprerr_ea		;x[XWX^/CfbNXWX^Ƃwς
	addq.b	#8,d2			;x[XWX^CfbNXWX^ɕύX
	rol.b	#4,d2
	rol.w	#8,d2
	move.w	d2,d3
	bsr	indexszwarn		;CfbNXTCYw肪Ȃ
	moveq.l	#0,d2			;x[XWX^͖w
	bra	geteapar1

geteapar_reg:
	addq.l	#2,a0
	cmp.w	#REG_D7|OT_REGISTER,d0
	bls	geteapar_idxreg		;D0`D7ȂCfbNXWX^
	cmp.w	#REG_A7|OT_REGISTER,d0
	bhi	geteapar_pcreg
	tst.w	d2
	bne	geteapar_idxreg		;x[XWX^͎wς
	tst.b	d4			;(bne & bpl)
	bgt	geteapar_idxreg		;ԐڃAhbVOẘO
	move.w	(a0),d1			;A0`A7
	cmp.w	#'*'|OT_CHAR,d1		;An.?An*̓CfbNX
	beq	geteapar_idxreg		;An(CfbNX)
	cmp.w	#OT_SIZE,d1
	bcc	geteapar_idxreg
	sub.w	#REG_A0|OT_REGISTER,d0
	moveq.l	#-1,d2
	move.b	d0,d2
	bra	geteapar_next

geteapar_pcreg:
	cmp.w	#REG_ZA7|OT_REGISTER,d0
	bls	geteapar_zreg		;WX^TvX(ZD0`ZD7,ZA0`ZA7)
	tst.b	d4			;(bne & bpl)
	bgt	exprerr_ea		;ԐڃAhbVOẘO
	tst.w	d2
	beq	geteapar_pcreg1		;x[XWX^͂܂w肳ĂȂ
	tst.b	d2
	bmi	exprerr_ea		;PCx[XWX^wς(PC/ZPC)
	tst.b	d3
	bne	exprerr_ea		;x[XWX^/CfbNXWX^Ƃwς
	addq.b	#8,d2			;x[XWX^CfbNXWX^ɕύX
	rol.b	#4,d2
	rol.w	#8,d2
	move.w	d2,d3
	bsr	indexszwarn		;CfbNXTCYw肪Ȃ
geteapar_pcreg1:
	st.b	(OPTIONALPC,a1)
	moveq.l	#-1,d2			;PCԐڎw
	cmp.w	#REG_OPC|OT_REGISTER,d0
	beq	geteapar_next
	sf.b	(OPTIONALPC,a1)
	cmp.w	#REG_PC|OT_REGISTER,d0
	beq	geteapar_next
	move.w	#$01FF,d2		;PCԐڃx[XWX^TvX(ZPC)
	cmp.w	#REG_ZPC|OT_REGISTER,d0
	beq	geteapar_next
	bra	regerr			;PC,ZPCłȂ΃G[

geteapar_zreg:
	cmp.w	#REG_ZD7|OT_REGISTER,d0
	bls	geteapar_zidxreg	;ZD0`ZD7ȂCfbNXWX^
	tst.w	d2
	bne	geteapar_zidxreg	;x[XWX^͎wς
	tst.b	d4			;(bne & bpl)
	bgt	geteapar_zidxreg	;ԐڃAhbVOẘO
	move.w	(a0),d1			;A0`A7
	cmp.w	#'*'|OT_CHAR,d1		;An.?An*̓CfbNX
	beq	geteapar_zidxreg	;An(CfbNX)
	cmp.w	#OT_SIZE,d1
	bcc	geteapar_zidxreg
	sub.w	#REG_ZA0|OT_REGISTER-$0100,d0
	move.w	d0,d2
	bra	geteapar_next

geteapar_zidxreg:
	tst.b	d3
	bne	exprerr_ea		;CfbNXWX^͎wς
	and.w	#$000F,d0
	ror.w	#4,d0
	move.w	d0,d3			;CfbNXWX^
	move.b	#$01,d3
	bra	geteapar_idxreg0

geteapar_idxreg:
	tst.b	d3
	bne	exprerr_ea		;CfbNXWX^͎wς
	and.w	#$000F,d0
	ror.w	#4,d0
	move.w	d0,d3			;CfbNXWX^
	st.b	d3
geteapar_idxreg0:
	tst.b	d4
	bpl	geteapar_idxreg1
	move.w	#$00FF,d4		;ԐڃAhbVOȂvCfbNX
geteapar_idxreg1:
	move.w	(a0)+,d0
	cmp.w	#SZ_WORD|OT_SIZE,d0	;Rn.w
	beq	geteapar_idxreg3
	cmp.w	#SZ_LONG|OT_SIZE,d0	;Rn.l
	beq	geteapar_idxreg2
	bsr	indexszwarn		;CfbNXTCYw肪Ȃ
	bra	geteapar_idxreg4	;[hTCYŊm

geteapar_idxreg2:
	ori.w	#EXW_IDXL,d3		;CfbNXTCY
geteapar_idxreg3:
	move.w	(a0)+,d0
geteapar_idxreg4:
	cmpi.w	#'*'|OT_CHAR,d0		;Rn.?*
	bne	geteapar_next1		;XP[l͂Ȃ
	bra68	d1,exprerr_cannotscale	;68000ɂ̓XP[l͂Ȃ
	lea.l	(RPNBUFEX,a6),a2	;Rn.?*n
	bsr	geteaexpr		;XP[l𓾂
	tst.w	d0
	bne	exprerr_scalefactor	;Ȃ΃G[
	tst.b	(RPNSIZEEX,a6)
	bpl	ilsizeerr		;TCYw肪΃G[
	tst.w	(RPNLENEX,a6)
	bpl	exprerr_scalefactor	;萔łȂ΃G[
	move.l	(RPNBUFEX,a6),d0
	moveq.l	#8,d1
	cmp.l	d1,d0
	bhi	exprerr_scalefactor	;1`8łȂ΃G[
	tst.b	(CPUTYPE2,a6)
	beq	geteapar_idxreg41
	moveq.l	#4,d1
	cmp.l	d1,d0
	bhi	exprerr_scalefactor	;ColdFire1`4łȂ΃G[
geteapar_idxreg41:
	add.w	d0,d0
	move.w	(geteaindex_tbl,pc,d0.w),d0
	bmi	exprerr_scalefactor
	or.w	d0,d3			;XP[t@N^

geteapar_next:
	move.w	(a0)+,d0
geteapar_next1:
	cmp.w	#','|OT_CHAR,d0
	beq	geteapar1
	cmp.w	#')'|OT_CHAR,d0
	beq	geteapm			;AhbVOwI
	cmp.w	#']'|OT_CHAR,d0
	bne	exprerr_ea
	neg.b	d4			;ԐڃAhbVOwI
	bgt	geteapar_next
	bra	exprerr_ea		;ԐڃAhbVOł͂Ȃ

geteaindex_tbl:				;XP[t@N^le[u
	.dc.w	-1,EXW_SCALE1,EXW_SCALE2,-1,EXW_SCALE4,-1,-1,-1,EXW_SCALE8

;----------------------------------------------------------------
;	ꂽAhbVO̗vf烂[h𓾂
geteapm:
	move.b	(RPNSIZE1,a1),(OPTSIZESET,a6)	;TCYw肳ꂽǂۑ
	tst.b	d4
	bmi	exprerr_ea		;ԐڃAhbVOw蒆
	bne	geteapm_idx		;ԐڃAhbVOgp
	tst.b	d3
	bne	geteapm_idx		;CfbNXWX^gp
	tst.w	d2
	bpl	geteapm_idx		;x[XWX^TvX
	tst.b	d2
	bmi	geteapm1		;PCԐ( (PC)/(PC)+Ȃ )
	move.w	(RPNLEN1,a1),d0		;x[XfBXv[XgȂ
	beq	getea_adr		; AhXWX^Ԑڌ` (An)/(An)+
	bpl	geteapm2
	tst.l	(RPNBUF1,a1)
	bne	geteapm2		;fBXv[Xg0łȂ
	move.b	(RPNSIZE1,a1),d1
	bpl	geteapm3		;TCYw肪
	tst.b	(NONULDISP,a6)
	beq	getea_adr1		;(0,An)  (An)
	bra	geteapm9		;ϊsȂ

geteapm1:
	move.w	(RPNLEN1,a1),d0
	beq	geteapm_idx		;x[XfBXv[XgȂ (PC)
geteapm2:
	move.b	(RPNSIZE1,a1),d1
	bmi	geteapm5
geteapm3:
	cmpi.b	#SZ_WORD,d1
	beq	geteapm9		;fBXv[Xgt (d,An)/(d,PC)
	cmpi.b	#SZ_LONG,d1
	beq	geteapm_idx
	bra	ilsizeerr		;TCYȂ,.w,.l̂łȂ΃G[

geteapm5:				;TCYw肪ȗꂽꍇ
	tst.w	d0
	bpl	geteapm99		;̒lȂꍇ
	sf.b	(OPTIONALPC,a1)		;萔̏ꍇOPC͖
	bra68	d1,geteapm8		;68000/68010͏.w(m)
	tst.b	(CPUTYPE2,a6)
	bne	geteapm8		;ColdFire͏.w(m)
	move.l	(RPNBUF1,a1),d0
	move.w	d0,d1
	ext.l	d1
	cmp.l	d0,d1
	bne	geteapm_idx		;[hfBXv[Xg͈̔͊O
geteapm8:
	move.b	#SZ_WORD,(RPNSIZE1,a1)
geteapm9:
	tst.b	d2
	bpl	getea_dspadr		;fBXv[XgtAhXWX^Ԑ
	bra	getea_dsppc		;fBXv[XgtPCԐ

geteapm99:				;fBXv[XgTCYm̏ꍇ
	tst.b	d2
	bmi	geteapm99pc
;	bra68	d1,getea_dspadrw	;68000/68010Ȃ.w
;					;(TvXꍇ̂Ŋm肵Ȃ)
	st.b	(DSPADRCODE,a6)		;(AhXύX̂ߖ߃R[hۑ)
	tst.b	(EXTSIZEFLG,a6)
	beq	getea_dspadr		;ftHgTCY.w
	move.w	#EAC_BDADR,d0		;(ɍœKEAC_DSPADRɕύXꍇ)
	bra	getea_dspadr0

geteapm99pc:				;PCԐڂ̏ꍇ
	move.b	(LONGABS,a6),d1
	or.b	d1,(OPTIONALPC,a1)
	bne	geteapm99pc1		;(d,PC)xxxx.l̕ϊsꍇ
	tst.b	(PCTOABSL,a6)
	bne	geteapm99pc2
	bra68	d1,getea_dsppcw		;68000/68010Ȃ.w
	tst.b	(CPUTYPE2,a6)
	bne	getea_dsppcw		;ColdFireȂ.w
	st.b	(DSPADRCODE,a6)		;(AhXύX̂ߖ߃R[hۑ)
	tst.b	(EXTSIZEFLG,a6)
	beq	getea_dsppc		;ftHgTCY.w
	move.w	#EAC_BDPC,(EACODE,a1)	;(ɍœKEAC_DSPPCɕύXꍇ)
	bra	getea_dsppc0

geteapm99pc1:
;(d,pc)ŃTCYwȂŎ̒lȂƂ
	tst.b	(PCTOABSL,a6)
	beq	geteapm99pc4
geteapm99pc2:
	tst.b	(PCTOABSLCAN,a6)
	bne	geteapm99pc3
;΃OŊm肷
	sf.b	(OPTIONALPC,a1)
	move.b	#EAD_ABSLW,(EADTYPE,a1)
	move.b	#SZ_LONG,(OPTSIZESET,a1)
	bra	getea_absl

geteapm99pc3:
	st.b	(OPTIONALPC,a1)
geteapm99pc4:
	st.b	(DSPADRCODE,a6)		;(AhXύX̂ߖ߃R[hۑ)
	tst.b	(EXTSHORT,a6)		;(68000/68010łL)
	beq	getea_dsppc		;ftHgTCY.w
	move.w	#EAC_ABSL,(EACODE,a1)	;(ɍœKEAC_DSPPCɕύXꍇ)
	bra	getea_dsppc0

geteapm_idx:
	tst.b	d3			;CfbNXWX^
	bmi	geteapm_idx1
	clr.b	d3			;CfbNXWX^TvX(ttH[}bg)
	ori.w	#(EXW_IS.xor.$FF)|EXW_FULL,d3
	ext.w	d4			;(CfbNXʒurbg0ɂ)
geteapm_idx1:
	not.b	d3
	tst.w	d2
	bmi	geteapm_idx2
	ori.w	#EXW_BS|EXW_FULL,d3	;x[XWX^TvX(ttH[}bg)
geteapm_idx2:
	tst.b	d4
	bne	geteapm_od		;ԐڃAhbVO
	btst.l	#EXWB_FORMAT,d3
	bne	geteapm_bd		;ttH[}bg̏ꍇ
	move.w	(RPNLEN1,a1),d0
	beq	geteapm_idx3		;x[XfBXv[XgȂ
	move.b	(RPNSIZE1,a1),d1
	bmi	geteapm_idx5
	cmpi.b	#SZ_WORD,d1		;.w/.lw肳ꂽttH[}bg
	beq	geteapm_bd
	cmpi.b	#SZ_LONG,d1
	beq	geteapm_bd
	bra	geteapm_idx8		;CfbNXt (d,An,Rn)/(d,PC,Rn)

geteapm_idx3:
	move.w	#-1,(RPNLEN1,a1)	;(An,Rn)  (0.s,An,Rn) / (PC,Rn)  (0.s,PC,Rn)
	clr.l	(RPNBUF1,a1)
	bra	geteapm_idx8

geteapm_idx5:				;TCYw肪ȗꂽꍇ
	bra68	d1,geteapm_idx8		;68000/68010Ȃ.s
	tst.b	(CPUTYPE2,a6)
	bne	geteapm_idx8		;ColdFireȂ.s
	tst.w	d0
	bpl	geteapm_idx9		;̒lȂꍇ
	move.l	(RPNBUF1,a1),d0
	move.b	d0,d1
	ext.w	d1
	ext.l	d1
	cmp.l	d0,d1
	bne	geteapm_bd		;8bitfBXv[Xg͈̔͊O
geteapm_idx8:
	move.b	#SZ_SHORT,(RPNSIZE1,a1)
geteapm_idx9:
	tst.b	d2
	bpl	getea_idxadr		;CfbNXtAhXWX^Ԑ
	bra	getea_idxpc		;CfbNXtPCԐ

geteapm_bd:
	bra68	d0,exprerr_fullformat	;68000/68010ɂ̓ttH[}bg͂Ȃ
	tst.b	(CPUTYPE2,a6)
	bne	exprerr_fullformat	;ColdFireɂ̓ttH[}bg͂Ȃ
	ori.w	#EXW_FULL,d3		;ttH[}bg
	move.w	(RPNLEN1,a1),d0
	beq	geteapm_bdnul		;x[XfBXv[XgȂ
	move.b	(RPNSIZE1,a1),d1
	bmi	geteapm_bd5
	cmpi.b	#SZ_WORD,d1
	beq	geteapm_bdw
	cmpi.b	#SZ_LONG,d1
	beq	geteapm_bdl
	bra	ilsizeerr		;TCYȂ,.w,.l̂łȂ΃G[

geteapm_bd5:				;TCYw肪ȗꂽꍇ
	tst.w	d0
	bpl	geteapm_bd99		;̒lȂꍇ
	move.l	(RPNBUF1,a1),d0
	bne	geteapm_bd6
	clr.w	(RPNLEN1,a1)		;x[XfBXv[Xgl0
geteapm_bdnul:
	or.w	#EXW_BDNUL,d3
	bra	geteapm_bd8

geteapm_bd6:
	move.w	d0,d1
	ext.l	d1
	cmp.l	d0,d1
	bne	geteapm_bd7
	move.b	#SZ_WORD,(RPNSIZE1,a1)
geteapm_bdw:
	or.w	#EXW_BDW,d3
	bra	geteapm_bd8

geteapm_bd7:				;[hfBXv[Xg͈̔͊O
	move.b	#SZ_LONG,(RPNSIZE1,a1)
geteapm_bdl:
	or.w	#EXW_BDL,d3
geteapm_bd8:
	tst.b	d4
	bne	geteapm_bd9		;ԐڃAhbVO
	tst.b	d2
	bpl	getea_bdadr		;x[XfBXv[XgtAhXWX^Ԑ
	bra	getea_bdpc		;x[XfBXv[XgtPCԐ

geteapm_bd9:
	tst.b	d2
	bpl	getea_memadr		;|Xg/vCfbNXtԐ
	bra	getea_mempc		;|Xg/vCfbNXtPCԐ

geteapm_bd99:				;fBXv[XgTCYm̏ꍇ
	tst.b	(EXTSIZEFLG,a6)
	beq	geteapm_bdw		;ftHgTCY.w
	bra	geteapm_bdl		;ftHgTCY.l

geteapm_od:
	bra68	d0,exprerr_fullformat	;68000/68010ɂ̓ttH[}bg͂Ȃ
	tst.b	(CPUTYPE2,a6)
	bne	exprerr_fullformat	;ColdFireɂ̓ttH[}bg͂Ȃ
	tst.w	d4
	bpl	geteapm_od1		;vCfbNX or CfbNXWX^TvX
	ori.w	#EXW_POSTIDX,d3		;|XgCfbNX
geteapm_od1:
	move.w	(RPNLEN2,a1),d0
	beq	geteapm_odnul		;AE^fBXv[XgȂ
	move.b	(RPNSIZE2,a1),d1
	bmi	geteapm_od5
	cmpi.b	#SZ_WORD,d1
	beq	geteapm_odw
	cmpi.b	#SZ_LONG,d1
	beq	geteapm_odl
	bra	ilsizeerr		;TCYȂ,.w,.l̂łȂ΃G[

geteapm_od5:
	tst.w	d0
	bpl	geteapm_od99		;̒lȂꍇ
	move.l	(RPNBUF2,a1),d0
	bne	geteapm_od6
	clr.w	(RPNLEN2,a1)		;AE^fBXv[Xgl0
geteapm_odnul:
	or.w	#EXW_ODNUL,d3
	bra	geteapm_bd

geteapm_od6:
	move.w	d0,d1
	ext.l	d1
	cmp.l	d0,d1
	bne	geteapm_od7
	move.b	#SZ_WORD,(RPNSIZE2,a1)
geteapm_odw:
	or.w	#EXW_ODW,d3
	bra	geteapm_bd

geteapm_od7:				;[hfBXv[Xg͈̔͊O
	move.b	#SZ_LONG,(RPNSIZE2,a1)
geteapm_odl:
	or.w	#EXW_ODL,d3
	bra	geteapm_bd		;x[XfBXv[Xg̏

geteapm_od99:				;fBXv[XgTCYm̏ꍇ
	tst.b	(EXTSIZEFLG,a6)
	beq	geteapm_odw		;ftHgTCY.w
	bra	geteapm_odl		;ftHgTCY.l

;----------------------------------------------------------------
;	Dn/An		f[^/AhXWX^ڌ`
getea_reg:
	addq.l	#2,a0
	ext.w	d0
	cmp.w	#REG_A7,d0
	bhi	regerr			;D0`D7,A0`A7łȂ΃G[
	move.w	d0,(EACODE,a1)
	move.b	#EAD_NONEREG,(EADTYPE,a1)	;f[^͕sv
	cmp.w	#REG_A0,d0
	bcc	getea_reg1
	move.w	#EA_DN,d0		;f[^WX^
	rts

getea_reg1:
	tst.b	(CMDOPSIZE,a6)		;cmpi.b #SZ_BYTE,(CMDOPSIZE,a6)
	beq	ilsizeerr		;Iy[VTCY.bȂG[
	move.w	#EA_AN,d0		;AhXWX^
	rts

;----------------------------------------------------------------
;	(An)		AhXWX^Ԑڌ`
getea_adr:
	cmp.w	#'+'|OT_CHAR,(a0)	;'+'?
	beq	getea_incadr		;|XgCNg`
getea_adr1:
	move.w	#EAC_ADR,d0
	or.b	d2,d0			;(x[XWX^)
	move.w	d0,(EACODE,a1)
	move.b	#EAD_NONE,(EADTYPE,a1)	;f[^͕sv
	move.w	#EA_ADR,d0
	rts

;----------------------------------------------------------------
;	(An)+		|XgCNgEAhXWX^Ԑڌ`
getea_incadr:
	addq.l	#2,a0
	move.w	#EAC_INCADR,d0
	or.b	d2,d0			;(x[XWX^)
	move.w	d0,(EACODE,a1)
	move.b	#EAD_NONE,(EADTYPE,a1)	;f[^͕sv
	move.w	#EA_INCADR,d0
	rts

;----------------------------------------------------------------
;	-(An)		vfNgEAhXWX^Ԑڌ`
getea_decadr:
	addq.l	#4,a0
	move.w	(a0)+,d0
	cmp.w	#REG_A0|OT_REGISTER,d0	;A0`A7?
	bcs	regerr
	cmp.w	#REG_A7|OT_REGISTER,d0
	bhi	regerr
	cmp.w	#')'|OT_CHAR,(a0)+	;')'?
	bne	exprerr_ea
	sub.w	#REG_A0|OT_REGISTER,d0
	or.w	#EAC_DECADR,d0
	move.w	d0,(EACODE,a1)
	move.b	#EAD_NONE,(EADTYPE,a1)	;f[^͕sv
	move.w	#EA_DECADR,d0
	rts

;----------------------------------------------------------------
;	(d,An)		fBXv[XgtAhXWX^Ԑڌ`
getea_dspadrw:
	move.b	#SZ_WORD,(RPNSIZE1,a1)
getea_dspadr:
	move.w	#EAC_DSPADR,d0		;(ɍœKEAC_BDADRɕύXꍇ)
getea_dspadr0:
	or.b	d2,d0			;(x[XWX^)
	move.w	d0,(EACODE,a1)
	move.b	#EAD_DSPADR,(EADTYPE,a1)
	move.w	#EA_DSPADR,d0
	rts

;----------------------------------------------------------------
;	(d,An,Rn)	CfbNXtAhXWX^Ԑڌ`
getea_idxadr:
	move.w	#EAC_IDXADR,d0
	or.b	d2,d0			;(x[XWX^)
	move.w	d0,(EACODE,a1)
	move.w	d3,(EXTCODE,a1)
	move.b	#EAD_IDXADR,(EADTYPE,a1)
	move.w	#EA_IDXADR,d0
	rts

;----------------------------------------------------------------
;	(bd,An,Rn)	x[XfBXv[XgtAhXWX^Ԑڌ`
getea_bdadr:
	move.w	#EAC_BDADR,d0
	or.b	d2,d0			;(x[XWX^)
	move.w	d0,(EACODE,a1)
	move.w	d3,(EXTCODE,a1)
	move.b	#EAD_BDADR,(EADTYPE,a1)
	move.w	#EA_BDADR,d0
	rts

;----------------------------------------------------------------
;	([bd,An,Rn],od)	|Xg/vCfbNXtԐ
getea_memadr:
	move.w	#EAC_MEMADR,d0
	or.b	d2,d0			;(x[XWX^)
	move.w	d0,(EACODE,a1)
	move.w	d3,(EXTCODE,a1)
	move.b	#EAD_MEMADR,(EADTYPE,a1)
	move.w	#EA_MEMADR,d0
	rts

;----------------------------------------------------------------
;	xxxx		΃V[g/OAhX`
getea_abslw:
	move.b	#EAD_ABSLW,(EADTYPE,a1)
	move.b	(RPNSIZE1,a1),d1
	move.b	d1,(OPTSIZESET,a6)	;TCYw肳ꂽǂۑ
	bmi	getea_abslw1
	cmp.b	#SZ_LONG,d1		;.l
	beq	getea_absl
	cmp.b	#SZ_WORD,d1		;.w
	beq	getea_absw
	bra	ilsizeerr		;TCYw肪

getea_abslw1:
	tst.b	(NOABSSHORT,a6)		;TCYw肪Ȃ
	bne	getea_absl
	tst.w	(RPNLEN1,a1)		;΃V[gΉ[h̏ꍇ
	bpl	getea_absl1		;萔łȂ
	move.l	(RPNBUF1,a1),d1
	move.w	d1,d2
	ext.l	d2
	cmp.l	d2,d1
	bne	getea_absl		;΃V[g͈̔͊O
getea_absw:				;΃V[g
	move.b	#SZ_WORD,(RPNSIZE1,a1)
	move.w	#EAC_ABSW,(EACODE,a1)
	move.w	#EA_ABSW,d0
	rts

getea_absl1:				;΃O/TCY
	tst.b	(ABSLTOOPC,a6)
	bne	getea_absltoopc
getea_absl:				;΃O/TCY
	move.b	#SZ_LONG,(RPNSIZE1,a1)
	move.w	#EAC_ABSL,(EACODE,a1)
	move.w	#EA_ABSL,d0
	rts

getea_absltoopc:
	tst.b	(ABSLTOOPCCAN,a6)
	bne	getea_absl
	st.b	(OPTIONALPC,a1)
	moveq.l	#-1,d2			;PCԐڎw
	bra	geteapm99pc1

;----------------------------------------------------------------
;	(d,PC)		fBXv[XgtPCԐڌ`
getea_dsppcw:
	move.b	#SZ_WORD,(RPNSIZE1,a1)
getea_dsppc:
	move.w	#EAC_DSPPC,(EACODE,a1)	;(ɍœKEAC_BDPCɕύXꍇ)
getea_dsppc0:
	move.b	#EAD_DSPPC,(EADTYPE,a1)
	move.w	#EA_DSPPC,d0
	rts

;----------------------------------------------------------------
;	(d,PC,Rn)	CfbNXtPCԐڌ`
getea_idxpc:
	tst.b	(OPTIONALPC,a1)
	bne	regerr_opc		;(d,PC)ȊOOPC̓G[
	move.w	#EAC_IDXPC,(EACODE,a1)
	move.w	d3,(EXTCODE,a1)
	move.b	#EAD_IDXPC,(EADTYPE,a1)
	move.w	#EA_IDXPC,d0
	rts

;----------------------------------------------------------------
;	(bd,PC,Rn)	x[XfBXv[XgtPCԐڌ`
getea_bdpc:
	tst.b	(OPTIONALPC,a1)
	bne	regerr_opc		;(d,PC)ȊOOPC̓G[
	move.w	#EAC_BDPC,(EACODE,a1)
	move.w	d3,(EXTCODE,a1)
	move.b	#EAD_BDPC,(EADTYPE,a1)
	move.w	#EA_BDPC,d0
	rts

;----------------------------------------------------------------
;	([bd,PC,Rn],od)	|Xg/vCfbNXtPCԐ
getea_mempc:
	tst.b	(OPTIONALPC,a1)
	bne	regerr_opc		;(d,PC)ȊOOPC̓G[
	move.w	#EAC_MEMPC,(EACODE,a1)
	move.w	d3,(EXTCODE,a1)
	move.b	#EAD_MEMPC,(EADTYPE,a1)
	move.w	#EA_MEMPC,d0
	rts

;----------------------------------------------------------------
;	#xxxx		C~fBGCg`
getea_imm:
	addq.l	#2,a0
	lea.l	(RPNBUF1,a1),a2
	bsr	geteaexpr
	tst.w	d0
	bmi	exprerr_immediate	;ϊɎs
	cmpi.b	#SZ_SHORT,(RPNSIZE1,a1)
	beq	ilsizeerr		;.s̓G[
	move.w	#EAC_IMM,(EACODE,a1)
	move.b	#EAD_IMM,(EADTYPE,a1)
	move.w	#EA_IMM,d0
	rts

;----------------------------------------------------------------
;	_AhbVO[h߂
;	in :a0=R[hꂽIyhw|C^
;	    a1=AhbVO[h߃obt@ւ̃|C^
;	out:a0=Iyh̏Iʒuw
;	    d0.w=ꂽAhbVO[hrbg
getfpeamode_noopc::
	st.b	(ABSLTOOPCCAN,a6)
getfpeamode::
	cmpi.b	#SZ_LONG,(CMDOPSIZE,a6)	;.lʈ(fmove/fmovem΍)
	bcs	geteamode		;TCYȂgeteamodeƓ
	clr.w	(RPNLEN1,a1)
	clr.w	(RPNLEN2,a1)
	move.w	(a0),d0
	cmp.w	#'#'|OT_CHAR,d0
	beq	getfpea_imm
	move.w	d0,d1
	and.w	#$FF00,d1
	cmp.w	#OT_REGISTER,d1
	bne	geteamode0		;ق̃AhX`geteamodeƓ

;----------------------------------------------------------------
;	Dn/An		f[^/AhXWX^ڌ`
getfpea_reg:
	cmpi.b	#SZ_SHORT,(CMDOPSIZE,a6)
	ble	getea_reg		;TCY.b/.w/.l/.s/ȗȂgeteamodeƓ
	bra	ilsizeerr		;.d/.x/.p̓G[

;----------------------------------------------------------------
;	#xxxx		C~fBGCg`
getfpea_imm::
	addq.l	#2,a0
	clr.w	(RPNLENEX,a6)

	lea.l	(RPNBUF1,a1),a2
	bsr	geteaexpr		;\ŏ̎𓾂
	tst.w	d0
	bmi	getfpea_immfp		;ϊɎs_\L
	movea.l	a0,a3
	moveq.l	#1-1,d3
	cmpi.w	#','|OT_CHAR,(a0)+
	bne	getfpea_imm9
	cmpi.w	#'#'|OT_CHAR,(a0)
	bne	getfpea_imm1
	addq.l	#2,a0
getfpea_imm1:				;#xxxx,#xxxx / #xxxx,xxxx
	lea.l	(RPNBUF2,a1),a2
	bsr	geteaexpr		;2ڂ̎𓾂
	tst.w	d0
	bmi	getfpea_imm9		;ϊɎs
	movea.l	a0,a3
	moveq.l	#2-1,d3
	cmpi.w	#','|OT_CHAR,(a0)+
	bne	getfpea_imm9
	cmpi.w	#'#'|OT_CHAR,(a0)
	bne	getfpea_imm2
	addq.l	#2,a0
getfpea_imm2:				;#xxxx,#xxxx,#xxxx / #xxxx,xxxx,xxxx
	lea.l	(RPNBUFEX,a6),a2
	bsr	geteaexpr		;3ڂ̎𓾂
	tst.w	d0
	bmi	getfpea_imm9		;ϊɎs
	movea.l	a0,a3
	moveq.l	#3-1,d3
getfpea_imm9:
	movea.l	a3,a0
	move.b	d3,(EAIMMCNT,a1)
	move.w	#EAC_IMM,(EACODE,a1)
	move.b	#EAD_IMM,(EADTYPE,a1)
	move.w	#EA_IMM,d0
	rts

getfpea_immfp:				;_\L𓾂
	cmpi.b	#SZ_LONG,(CMDOPSIZE,a6)
	bls	exprerr			;.b/.w/.lȂG[
	bsr	calcfexpr		;_𓾂
	move.l	d0,(RPNBUF1,a1)
	move.l	d1,(RPNBUF2,a1)
	move.l	d2,(RPNBUFEX,a6)
	moveq.l	#-1,d0
	move.w	d0,(RPNLEN1,a1)
	move.w	d0,(RPNLEN2,a1)
	move.w	d0,(RPNLENEX,a6)
	move.b	d0,(EAIMMCNT,a1)
	move.w	#EAC_IMM,(EACODE,a1)
	move.b	#EAD_IMM,(EADTYPE,a1)
	move.w	#EA_IMM,d0
	rts


;----------------------------------------------------------------
	.end


;----------------------------------------------------------------
;	$Log: eamode.s,v $
;	Revision 2.7  1999  3/ 1(Mon) 03:00:50 M.Kamada
;	+82 G[bZ[W{ꉻ
;	+82 geteapar_idxreg2̒OɂsmbnebraɕύX
;
;	Revision 2.6  1999  2/28(Sun) 03:53:19 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 2.5  1999  2/20(Sat) 20:12:59 M.Kamada
;	+80 ColdFireΉ
;
;	Revision 2.4  1998  8/ 2(Sun) 16:28:24 M.Kamada
;	+71 -1̂ƂFMOVE FPn,<label>G[ɂȂ
;
;	Revision 2.3  1998  3/31(Tue) 03:13:34 M.Kamada
;	+63 jmp/jsrœK
;
;	Revision 2.2  1998  1/ 5(Mon) 00:50:31 M.Kamada
;	+55 -b[n]
;
;	Revision 2.1  1997 10/29(Wed) 19:44:21 M.Kamada
;	+52 PMOVE.D #imm,CRPAZułȂs
;	+52 _̃TCYw\ɂ
;
;	Revision 2.0  1997  9/15(Mon) 16:35:21 M.Kamada
;	+46 SZ_BYTE=0ōœK
;
;	Revision 1.9  1997  7/20(Sun) 01:56:08 M.Kamada
;	+41 XP[t@N^̏̃oOC
;
;	Revision 1.8  1997  7/ 9(Wed) 02:30:26 M.Kamada
;	+39 -1̋C
;
;	Revision 1.7  1997  4/ 5(Sat) 18:42:57 M.Kamada
;	+28 LEAœK
;
;	Revision 1.6  1997  3/14(Fri) 22:58:28 M.Kamada
;	+18 TCYŵȂ萔łȂ΃O(d,OPC)ɂ
;	+19 -1̋C
;	+20 -1̋C
;
;	Revision 1.5  1996 11/13(Wed) 15:25:30 M.Kamada
;	+02 68060Ή
;		䃌WX^̃e[uύXBUSCR,PCRǉ
;
;	Revision 1.4  1994/07/11  14:23:52  nakamura
;	኱̃oOtBbNX
;
;	Revision 1.3  1994/04/12  15:10:38  nakamura
;	-m68000/68010(d,An)œKȂƂoOCB
;
;	Revision 1.2  1994/03/06  03:09:22  nakamura
;	zd0`zd7,za0`za7,opcWX^̏ǉ
;
;	Revision 1.1  1994/02/13  11:44:56  nakamura
;	Initial revision
;
;
