;----------------------------------------------------------------
;	X68k High-speed Assembler
;		C[`
;		< main.s >
;
;	$Id: main.s,v 3.7  1999 10/ 8(Fri) 17:33:03 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;			  1996-99  by M.Kamada
;----------------------------------------------------------------

	.include	doscall.mac
	.include	has.equ
	.include	symbol.equ
	.include	register.equ
	.include	cputype.equ
	.include	error2.equ

	.cpu	68000
	.text


;----------------------------------------------------------------
;	CvO
;----------------------------------------------------------------
asmmain::
		bra	@f
		.dc.b	'#HUPAIR',0
@@:
		movea.l	(8,a0),a1
		move.l	#STACKBTM-asmmain,d0
		suba.l	a4,a1
		cmpa.l	d0,a1
		bcs	nomemabort
		lea	(asmmain,pc,d0.l),sp	;lea (STACKBTM,pc),sp
		move.l	#WORKBEGIN-asmmain,d0
		lea	(asmmain,pc,d0.l),a6	;lea (WORKBEGIN,pc),a6

	bsr	meminit			;̈̊m
	bsr	workinit		;[NGȀ
	bsr	defressym		;\ς݃V{̏
	bsr	cpuinit			;CPU[h̏
	bsr	makeprndate		;̍쐬
	bsr	docmdline		;R}hC̉
	bsr	predefinesymbol		;vft@CV{̒`
	tst.b	(DISPTITLE,a6)
	beq	asmmain0
	lea.l	(title_msg,pc),a0
	bsr	printmsg
asmmain0:
	lea.l	(SOURCEPTR,a6),a0
	move.l	a0,(INPFILPTR,a6)
	movea.l	(SOURCEFILE,a6),a0
	bsr	readopen		;\[Xt@CI[v
	tst.l	d0
	bmi	filopenabort
	tst.b	(MAKEPRN,a6)
	beq	asmmain1
	movea.l	(PRNFILE,a6),a0
	bsr	prnopen			;PRNt@CI[v
	move.w	d0,(PRNHANDLE,a6)
asmmain1:
	bsr	asmpass1		;pX1
	bsr	asmpass2		;pX2
	bsrl	asmpass3,d0		;pX3
	bsr	tempdelete		;e|t@C̍폜
	tst.w	(NUMOFERR,a6)
	beq	asmmain2
	move.w	#1,-(sp)		;G[ꍇ̏IR[h
	move.l	(OBJFILE,a6),-(sp)
	DOS	_DELETE			;IuWFNgt@C폜
	addq.l	#4,sp
	lea.l	(beep_msg,pc),a0
	bsr	printmsg		;r[v炷
	lea.l	(LINEBUF,a6),a0
	lea.l	(fatal_msg1,pc),a1
	bsr	strcpy
	move.w	(NUMOFERR,a6),d0
	ext.l	d0
	moveq.l	#0,d1			;(l)
	bsr	convdec
	lea.l	(fatal_msg2,pc),a1
	bsr	strcpy
	clr.b	(a0)
	lea.l	(LINEBUF,a6),a0
	bra	asmmain3

asmmain2:
	clr.w	-(sp)			;G[Ȃꍇ̏IR[h
	lea.l	(no_msg,pc),a0
	tst.b	(DISPTITLE,a6)
	beq	asmmain4
asmmain3:
	bsr	printmsg
asmmain4:
	tst.b	(MAKEPRN,a6)
	beq	asmmain6
	tst.b	(ISPRNSTDOUT,a6)
	bne	asmmain6
	bsr	prnlout
	tst.b	(NOPAGEFF,a6)
	bne	asmmain5
	st.b	(NOPAGEFF,a6)
	lea.l	(pageff_msg,pc),a0
	bsr	prnlout
asmmain5:
	move.w	(PRNHANDLE,a6),-(sp)
	DOS	_CLOSE			;PRNt@C̃N[Y
	addq.l	#2,sp
asmmain6:
	st.b	(NOPAGEFF,a6)
	tst.b	(MAKESYM,a6)
	beq	asmmain9
	move.l	(SYMFILE,a6),d1
	beq	asmmain8		;t@CȗWo͂
	movea.l	d1,a0
	bsr	prnopen			;V{t@CI[v
	move.w	d0,(PRNHANDLE,a6)
	movea.l	(SOURCEFILE,a6),a0
	bsr	getfilename
	movea.l	a1,a0
	bsr	prnlout
	lea.l	(main_crlf_msg,pc),a0
	bsr	prnlout
	bsrl	makesymfile,d0		;V{t@C̍쐬
	move.w	d0,-(sp)
	DOS	_CLOSE			;V{t@C̃N[Y
	addq.l	#2,sp
	bra	asmmain9

asmmain8:
	move.w	#STDOUT,(PRNHANDLE,a6)

	bsrl	makesymfile,d0		;V{t@CWo͂֏o
asmmain9:
	DOS	_EXIT2


;----------------------------------------------------------------
;	AZu̕\bZ[W
;----------------------------------------------------------------
main_crlf_msg:
	.dc.b	CRLF,0

.ifdef	PATCHLEVEL
title_msg::	.dc.b	PROGRAM,' version ',version,PATCHLEVEL,TYPE
ver_msg_end:	.dc.b	' Copyright 1990-94/96-99 Y.Nakamura/M.Kamada'
		.dc.b	', ',PATCHDATE,' ',PATCHAUTHOR,'.',CRLF,0
.else
title_msg::
	.dc.b	'X68k High-speed Assembler v',version
ver_msg_end:
	.dc.b	' Copyright 1990-94/96-99 Y.Nakamura/M.Kamada',CRLF,0
.endif	/* !PATCHLEVEL */

usage_msg:
	mes	'gp@: '
	.dc.b	PROGNAME
	mes	' [IvV] t@C'
	.dc.b	CRLF
	.dc.b	TAB,'-1',TAB,TAB
	mes	'΃OPCԐ(-b1-e𔺂)'
	.dc.b	CRLF
	.dc.b	TAB,'-8',TAB,TAB
	mes	'V{̎ʒ8oCgɂ'
	.dc.b	CRLF
;-a ΃V[gAhX`Ή(-c2̂ݗL)
	.dc.b	TAB,'-b[n]',TAB,TAB
	mes	'PCԐځ΃O(0=[֎~],[1]=68000,2=MEM,3=1+2,4=ALL,5=1+4)'
	.dc.b	CRLF
	.dc.b	TAB,'-c[n]',TAB,TAB
	mes	'œK(0=֎~(-k1𔺂),1=(d,An)֎~,[2]=v2݊,3=[v3݊],4=)'
	.dc.b	CRLF
	.dc.b	TAB,'-c<mnemonic>',TAB
	mes	'software emulation̖߂WJ(FScc/MOVEP)'
	.dc.b	CRLF
	.dc.b	TAB,'-d',TAB,TAB
	mes	'ׂẴV{O`ɂ'
	.dc.b	CRLF
	.dc.b	TAB,'-e',TAB,TAB
	mes	'OQƃItZbg̃ftHgO[hɂ'
	.dc.b	CRLF
	.dc.b	TAB,'-f[f,m,w,p]',TAB
	mes	'Xgt@C̃tH[}bgw'
	.dc.b	CRLF
	.dc.b	TAB,TAB,TAB,TAB
	mes	'(y[W[1],}NWJ[0],[136],y[Ws[58])'
	.dc.b	CRLF
	.dc.b	TAB,'-g',TAB,TAB
	mes	'SCDpfobȌo'
	.dc.b	CRLF
	.dc.b	TAB,'-i <path>',TAB
	mes	'CN[hpXw'
	.dc.b	CRLF
	.dc.b	TAB,'-j[n]',TAB,TAB
	mes	'V{̏㏑֎~̋(bit0:[1]=SET,bit1:[1]=OFFSYM)'
	.dc.b	CRLF
	.dc.b	TAB,'-k[n]',TAB,TAB
	mes	'68060̃Gb^΍(0=[](-n͖),[1]=Ȃ)'
	.dc.b	CRLF
	.dc.b	TAB,'-l',TAB,TAB
	mes	'NɃ^Cg\'
	.dc.b	CRLF
	.dc.b	TAB,'-m <680x0|5x00>',TAB
	mes	'AZuΏCPU̎w([68000]`68060/5200`5400)'
	.dc.b	CRLF
	.dc.b	TAB,'-n',TAB,TAB
	mes	'pX1ŊmłȂTCY̍œKȗ(-k1𔺂)'
	.dc.b	CRLF
	.dc.b	TAB,'-o <name>',TAB
	mes	'IuWFNgt@C'
	.dc.b	CRLF
	.dc.b	TAB,'-p [file]',TAB
	mes	'Xgt@C쐬'
	.dc.b	CRLF
;-q NCbNC~fBGCg`ւ̕ϊ֎~(-c2̂ݗL)
;-r ΃ZNV߂̋(p~)
	.dc.b	TAB,'-s <n>',TAB,TAB
	mes	'[Jx̍ő包̎w([1]`4)'
	.dc.b	CRLF
	.dc.b	TAB,'-s <symbol>[=n]',TAB
	mes	'V{̒`'
	.dc.b	CRLF
	.dc.b	TAB,'-t <path>',TAB
	mes	'e|pXw'
	.dc.b	CRLF
	.dc.b	TAB,'-u',TAB,TAB
	mes	'`V{OQƂɂ'
	.dc.b	CRLF
	.dc.b	TAB,'-w[n]',TAB,TAB
	mes	'xx̎w(0=S},1,[2],3,4=[Sʒm])'
	.dc.b	CRLF
	.dc.b	TAB,'-x [file]',TAB
	mes	'V{̏o'
	.dc.b	CRLF
	.dc.b	TAB,'-y[n]',TAB,TAB
	mes	'vft@CV{(0=[֎~],[1]=)'
	.dc.b	CRLF
;-z HASg@\̃[jO֎~(p~)
	mes	'    ϐ '
	.dc.b	ENVNAME
	mes	' ̓eR}hC̎Oɑ}܂'
	.dc.b	CRLF
.if 0
	mes	'    ϐ HAS ̐擪 '
	.dc.b	"'*'"
	mes	' ̂Ƃ '
	.dc.b	"'/'"
	mes	' XCb`ƌȂ܂'
	.dc.b	CRLF
.endif
	.dc.b	0

no_msg:		mes	'G[͂܂'
		.dc.b	CRLF
		.dc.b	0
fatal_msg1:	mes	'G[ '
		.dc.b	0
fatal_msg2:	mes	' ܂DAZu𒆎~܂'
		.dc.b	CRLF
		.dc.b	0
env_has:	.dc.b	ENVNAME,0	;R}hCɒǉϐ
nulstr:		.dc.b	0

str_help:	.dc.b	'help',0
str_version:	.dc.b	'version',0
str_fscc:	.dc.b	'fscc',0
str_movep:	.dc.b	'movep',0
str_all:	.dc.b	'all',0
	.even


;----------------------------------------------------------------
;	̈̊m
;----------------------------------------------------------------
meminit:					;lea.l $10(a0),a0
	move.l	#STACKBTM-asmmain+$F0,-(sp)	;suba.l a0,a1
	pea.l	($10,a0)			;movem.l a0-a1,-(sp)
	DOS	_SETBLOCK		;ubN
	addq.l	#8,sp
	tst.l	d0
	bmi	nomemabort
;CMDLINEPTR(a6)̍XV_SETBLOCK̃G[`FbNɍs
	addq.l	#1,a2
	move.l	a2,(CMDLINEPTR,a6)	;R}hCւ̃|C^
	move.l	#$FFFFFF,-(sp)
	DOS	_MALLOC			;őm
		move.l	d0,(sp)+
	bpl	meminit1		;(ȂƂ͂肦Ȃc)

		move.l	#$ffffff,-(sp)
		DOS	_MALLOC			;őm
		move.l	d0,(MEMPTR,a6)
		bpl	meminit1		;(ȂƂ͂肦Ȃc)

		and.l	d0,(sp)
		DOS	_MALLOC			;邾̃m
		move.l	d0,(MEMPTR,a6)		;gp̈̊JnAhX
		bmi	nomemabort		;SmۏoȂ
meminit1:
		add.l	(sp)+,d0
	sub.l	#$400,d0
	move.l	d0,(MEMLIMIT,a6)
	rts


;----------------------------------------------------------------
;	[NGȀ
;----------------------------------------------------------------
workinit:
	lea.l	(WORKCLRST,a6),a0
	move.w	#(WORKSIZE-WORKCLRST)/2-1,d0
workinit1:
	clr.w	(a0)+
	dbra	d0,workinit1
	move.l	(MEMPTR,a6),(TEMPPTR,a6)

	clr.l	(INCLUDEPATH,a6)
	lea.l	(nulstr,pc),a0
	move.l	a0,(TEMPPATH,a6)
	move.l	a0,(PRNTITLE,a6)
	move.l	a0,(PRNSUBTTL,a6)

	move.w	#136,(PRNWIDTH,a6)
	move.w	#58,(PRNPAGEL,a6)
	move.w	#1,(PRNMPAGE,a6)
	lea.l	(REQFILPTR,a6),a0
	move.l	a0,(REQFILEND,a6)
	move.l	#6,(NUMOFSECT,a6)
	move.b	#-1,(WARNLEVEL,a6)

	move.w	#1<<9,(FPCPID,a6)

	move.w	#1,(LOCALLENMAX,a6)
	move.w	#10000,(LOCALNUMMAX,a6)

	move.l	#SYMHASHTBL,d0
	lea.l	(a6,d0.l),a0
	move.l	a0,(SYMHASHPTR,a6)
	move.l	#CMDHASHTBL,d0
	lea.l	(a6,d0.l),a0
	move.l	a0,(CMDHASHPTR,a6)

	clr.w	(SYMTBLCOUNT,a6)
	lea.l	(SYMTBLBEGIN,a6),a0
	clr.l	(a0)
	move.l	a0,(SYMTBLCURBGN,a6)

	move.l	(TEMPPTR,a6),d0
	doeven	d0			;O[hEɍ킹
	move.l	(MEMLIMIT,a6),d1
	sub.l	d0,d1			;d1=gp̈̃TCY
	move.l	d1,d2
;	lsr.l	#2,d2			;(gp̈1/4)
	lsr.l	#1,d2			;(gp̈1/2)
	sub.l	d2,d1
	and.l	#$FFFFE000,d1		;d1=t@Cobt@Ɏgp郁
	cmp.l	#8192,d1
	bcc	workinit2
	move.l	#8192,d1		;sĂꍇɍŒmۂobt@
workinit2:
	lsr.l	#2,d1			;1/4
	move.l	d1,d2
	lsr.l	#1,d1			;1/8
	add.l	d1,d2			;t@Cobt@3/8\[Xpɏ[Ă
	move.l	d0,(F_BUFPTR+SOURCEPTR,a6)	;\[Xt@Cobt@
	move.l	d2,(F_BUFLEN+SOURCEPTR,a6)
	add.l	d2,d0
	move.l	d0,(F_BUFPTR+TEMPFILPTR,a6)	;e|t@Cobt@
	move.l	d2,(F_BUFLEN+TEMPFILPTR,a6)
	add.l	d2,d0
	move.l	d0,(F_BUFPTR+INCLDPTR,a6)	;CN[ht@Cobt@
	move.l	d1,(F_BUFLEN+INCLDPTR,a6)
	add.l	d1,d0
	move.l	d0,(F_BUFPTR+OBJFILPTR,a6)	;IuWFNgt@Cobt@
	move.l	d1,(F_BUFLEN+OBJFILPTR,a6)
	add.l	d1,d0
	move.l	d0,(TEMPPTR,a6)		;ȍ~V{E}No^p[N

	bra	memcheck
**	rts


;----------------------------------------------------------------
;	vft@CV{̏
;----------------------------------------------------------------
predefinesymbol:
	tst.b	(PREDEFINE,a6)
	beq	predefinesymbol99

	lea.l	(symbol_cpu,pc),a0
	moveq.l	#ST_VALUE,d2		;lV{
	bsr	defstrsymbol		;Vo^
	tst.b	(SYM_TYPE,a1)		;cmpi.b #ST_VALUE,(SYM_TYPE,a1)
					;V{̃^Cv
	bne	predefinesymbol1	;`łȂ(Ô)
	move.l	a1,(CPUSYMBOL,a6)
	move.b	#SA_PREDEFINE,(SYM_ATTRIB,a1)	;vft@CV{
	clr.b	(SYM_SECTION,a1)	;ZNVԍ
	move.b	(CPUTYPE2,a6),d0
	beq	predefinesymbol00
	movea.l	#5200,a0
	lsr.b	#1,d0
	bcs	predefinesymbol0
	lea.l	(5300-5200,a0),a0
	lsr.b	#1,d0
	bcs	predefinesymbol0
	lea.l	(5400-5300,a0),a0
	bra	predefinesymbol0

predefinesymbol00:
	move.b	(CPUTYPE,a6),d0		;CPUTYPE珉l肷
	movea.l	#68000,a0
	lsr.b	#1,d0
	bcs	predefinesymbol0
		moveq	#10,d1
		adda.l	d1,a0		;68010
	lsr.b	#1,d0
	bcs	predefinesymbol0
		adda.l	d1,a0		;68020
	lsr.b	#1,d0
	bcs	predefinesymbol0
		adda.l	d1,a0		;68030
	lsr.b	#1,d0
	bcs	predefinesymbol0
		adda.l	d1,a0		;68040
	lsr.b	#1,d0
	bcs	predefinesymbol0
	lea.l	(68060-68040,a0),a0
predefinesymbol0:
	move.l	a0,(SYM_VALUE,a1)	;CPU
	move.l	a0,(STARTCPU,a6)
predefinesymbol1:

	pea.l	(symbol_date,pc)
	moveq.l	#$07,d0
	and.w	(ASSEMBLEDATE,a6),d0	;|........|........|........|.....www|
	lsl.w	#5,d0			;|........|........|........|www.....|
	swap.w	d0			;|........|www.....|........|........|
	move.w	(ASSEMBLEDATE+2,a6),d0	;|........|www.....|yyyyyyym|mmmddddd|
	add.l	#1980<<9,d0		;|........|wwwYYYYY|YYYYYYYm|mmmddddd|
	lsl.l	#7,d0			;|.wwwYYYY|YYYYYYYY|mmmmdddd|d.......|
	lsr.w	#4,d0			;|.wwwYYYY|YYYYYYYY|....mmmm|ddddd...|
	lsr.b	#3,d0			;|.wwwYYYY|YYYYYYYY|....mmmm|...ddddd|
	move.l	d0,-(sp)
	bsr	def_predefinesymbol
	pea.l	(symbol_time,pc)
	move.l	(ASSEMBLETIM2,a6),-(sp)
	bsr	def_predefinesymbol
	lea.l	(8+8,sp),sp

	pea.l	(symbol_has,pc)
	pea.l	(verno).w		;309
	bsr	def_predefinesymbol
	pea.l	(symbol_has060,pc)
	pea.l	(verno060).w		;69`
	bsr	def_predefinesymbol
	lea.l	(8+8,sp),sp

predefinesymbol99:
	rts

;<4(sp).l:l
;<8(sp).l:
def_predefinesymbol:
	movea.l	(8,sp),a0		;
	moveq.l	#ST_VALUE,d2		;lV{
	bsr	defstrsymbol		;Vo^
	tst.b	(SYM_TYPE,a1)		;cmpi.b #ST_VALUE,(SYM_TYPE,a1)
					;V{̃^Cv
	bne	def_predefinesymbol_9	;`łȂ(Ô)
	move.b	#SA_PREDEFINE,(SYM_ATTRIB,a1)	;vft@CV{
	clr.b	(SYM_SECTION,a1)	;ZNVԍ
	move.l	(4,sp),(SYM_VALUE,a1)	;l
def_predefinesymbol_9:
	rts

symbol_cpu:	.dc.b	'CPU',0
symbol_date:	.dc.b	'__DATE__',0
symbol_time:	.dc.b	'__TIME__',0
symbol_has:	.dc.b	'__HAS__',0
symbol_has060:	.dc.b	'__HAS060__',0
	.even


;----------------------------------------------------------------
;	CPU[h̏
;----------------------------------------------------------------
cpuinit:
	sf.b	(F43GTEST,a6)
cpuinit1:
	move.l	#~~cpu_68000-cpuinit1,d0
	jmp	(cpuinit1,pc,d0.l)


;----------------------------------------------------------------
;	HUPAIR decoder
;----------------------------------------------------------------

GetArgChar_p:	.dc.l	0
GetArgChar_c:	.dc.b	0
GetArgChar_b:	.dc.b	0
		.even

GetArgChar:
		movem.l	d1/a0-a1,-(sp)
		moveq	#0,d0
		lea	(GetArgChar_p,pc),a0
		movea.l	(a0)+,a1
		move.b	(a0),d0
		bmi	GetArgChar_noarg
GetArgChar_quate:
		move.b	d0,d1
GetArgChar_next:
		move.b	(a1)+,d0
		beq	GetArgChar_endarg
		tst.b	d1
		bne	GetArgChar_inquate
		cmpi.b	#' ',d0
		beq	GetArgChar_separate
		cmpi.b	#"'",d0
		beq	GetArgChar_quate
		cmpi.b	#'"',d0
		beq	GetArgChar_quate
GetArgChar_end:
		move.b	d1,(a0)
		move.l	a1,-(a0)
GetArgChar_abort:
		movem.l	(sp)+,d1/a0-a1
		rts
GetArgChar_endarg:
		st	(a0)
		bra	GetArgChar_abort
GetArgChar_noarg:
		moveq	#1,d0
		ror.l	#1,d0
		bra	GetArgChar_abort

GetArgChar_inquate:
		cmp.b	d0,d1
		bne	GetArgChar_end
		clr.b	d1
		bra	GetArgChar_next

GetArgChar_separate:
		cmp.b	(a1)+,d0
		beq	GetArgChar_separate
		moveq	#0,d0
		tst.b	-(a1)
		beq	GetArgChar_endarg
		bra	GetArgChar_end

GetArgCharInit:
		movem.l	a0-a1,-(sp)
		movea.l	(12,sp),a1
GetArgCharInit_skip:
		cmpi.b	#' ',(a1)+
		beq	GetArgCharInit_skip
		tst.b	-(a1)
		lea	(GetArgChar_c,pc),a0
		seq	(a0)
		move.l	a1,-(a0)
		movem.l	(sp)+,a0-a1
		rts

*  HUPAIR ɏ].
* in	a0.l	
*	a1.l	WJobt@(TEMPPTR)
* out	a1.l	̍Ō̃AhX+1(XV TEMPPTR)
* break	d0
* l:	a1.l ̂܂܂ a0.l ɕĎXƌĂяo΁A
*	IɊeAꂽԂɂȂ.

* ̈\
*	.dc.b	'foo',0
*	.dc.b	'bar',0
* <- a1.l

decode_argument:
		move.l	a0,-(sp)
		bsr	GetArgCharInit
		addq.l	#4,sp
**		lea	(a1),a0
decode_arg_loop:
		bsr	GetArgChar
		tst.l	d0
		beq	decode_arg_loop
		bmi	decode_arg_end

		move.b	d0,(a1)+
@@:
		bsr	GetArgChar
		move.b	d0,(a1)+
		bne	@b
		tst.l	d0
		beq	decode_arg_loop
decode_arg_end:
		rts


;----------------------------------------------------------------
;	R}hC̉߂s
;----------------------------------------------------------------
docmdline:
	movea.l	(TEMPPTR,a6),a1
;ϐHASR}hC̎Oɓ
	clr.b	(a1)
	move.l	a1,-(sp)
	clr.l	-(sp)
	pea.l	(env_has,pc)
.ifdef	HUMAN_V3
	DOS	_GETENV
.else
	bsr	getenv
.endif
	lea.l	(12,sp),sp
.ifndef	NO_SLASH
	cmpi.b	#'*',(a1)
	bne	docmdline1
	move.b	#' ',(a1)
	st.b	(SWITCHCHAR,a6)		;ϐ̐擪'*''/'XCb`ɂȂ
docmdline1:
.endif	/* !NO_SLASH */
		move.l	(CMDLINEPTR,a6),d2
		movea.l	d2,a0
@@:		tst.b	(a0)+
		bne	@b
		suba.l	d2,a0
		add.l	a1,a0
		cmpa.l	(TEMPPTR,a6),a0
		bcs	nomemabort

		lea	(a1),a0			;obt@ɏ㏑
		move.l	a0,-(sp)
		bsr	decode_argument		;$HAS𕪊
		movea.l	d2,a0
		bsr	decode_argument		;R}hC𕪊
		clr.b	(a1)+
		move.l	a1,(TEMPPTR,a6)
		bsr	memcheck
		movea.l	(sp)+,a0		;
docmdline3:
	bsr	optionsw
	beq	docmdline10

	move.l	(SOURCEFILE,a6),d0
	beq	docmdline39
	cmp.l	(PRNFILE,a6),d0
	beq	docmdline39
	cmp.l	(SYMFILE,a6),d0
	bne	usage			;\[Xt@C2
docmdline39:
	move.l	a0,(SOURCEFILE,a6)
@@:		tst.b	(a0)+
		bne	@b
	bra	docmdline3

docmdline10:				;R}hCI
	move.l	(SOURCEFILE,a6),d2
	beq	usage			;\[Xt@C̎w肪Ȃ̂Ŏgp@\
	movea.l	d2,a0
	cmp.l	(PRNFILE,a6),d2
	bne	docmdline11
	clr.l	(PRNFILE,a6)		;-p [file]̌`Ń\[Xt@Cw肳ꂽ
docmdline11:
	cmp.l	(SYMFILE,a6),d2
	bne	docmdline12
	clr.l	(SYMFILE,a6)		;-x [file]̌`Ń\[Xt@Cw肳ꂽ
docmdline12:
	bsr	getfilename
		tst.b	(a1)+
		beq	docmdline13
docmdline122:
	move.b	(a1)+,d0
	beq	docmdline13
	cmp.b	#'.',d0
	bne	docmdline122
	bra	docmdline14

docmdline13:				;gqȗꂽꍇ
	movea.l	d2,a1
	movea.l	(TEMPPTR,a6),a0
	move.l	a0,(SOURCEFILE,a6)
	clr.w	-(sp)			;'r'
	pea.l	(a0)
	bsr	strcpy
	move.b	#'.',(a0)+
	move.b	#'h',(a0)+
	move.b	#'a',(a0)+
	move.b	#'s',(a0)+
	clr.b	(a0)+
	DOS	_OPEN			;gq'.has'ŃI[vĂ݂
	addq.l	#6,sp
	tst.l	d0
	bmi	docmdline135
	move.w	d0,-(sp)
	DOS	_CLOSE			;t@ĈŃN[Y
	addq.l	#2,sp
	bra	docmdline139

docmdline135:				;'.has'̃t@CȂ̂Ŋgq'.s'
		subq.l	#4,a0			;"has\0?"
		move.b	#'s',(a0)+		; ^ <- ^
		clr.b	(a0)+
docmdline139
	move.l	a0,(TEMPPTR,a6)
docmdline14:
	movea.l	(SOURCEFILE,a6),a0
	bsr	getfilename		;a1=\[Xt@Cւ̃|C^
	lea.l	(SOURCENAME,a6),a0
	bsr	tfrfilename
	tst.l	(OBJFILE,a6)
	bne	docmdline15
	movea.l	(TEMPPTR,a6),a0		;IuWFNgt@C̎w肪Ȃ
	move.l	a0,(OBJFILE,a6)
	bsr	tfrfilename
	move.b	#'.',(a0)+
	move.b	#'o',(a0)+
	clr.b	(a0)+
	move.l	a0,(TEMPPTR,a6)
docmdline15:
	tst.l	(PRNFILE,a6)
	bne	docmdline99
	movea.l	(TEMPPTR,a6),a0		;PRNt@C̎w肪Ȃ
	move.l	a0,(PRNFILE,a6)
	bsr	tfrfilename
	move.b	#'.',(a0)+
	move.b	#'p',(a0)+
	move.b	#'r',(a0)+
	move.b	#'n',(a0)+
	clr.b	(a0)+
	move.l	a0,(TEMPPTR,a6)
docmdline99:
	tst.b	(COMPATMODE,a6)
	beq	docmdline999
	move.b	(COMPATSWA,a6),d0	;HAS v2.x݊[h̏ꍇ,-a/-qXCb`F
	not.b	d0
	move.b	d0,(NOABSSHORT,a6)
	move.b	(COMPATSWQ,a6),(NOQUICK,a6)
docmdline999:
	rts

;----------------------------------------------------------------
;	IvVXCb`̏
not_option:
		move.b	-(a0),d0	;t@C܂ NUL
		rts
optionsw:
		move.b	(a0)+,d0
.ifndef	NO_SLASH
		tst.b	(SWITCHCHAR,a6)
		bne	@f			;'/'XCb`ɎgpȂꍇ
		cmp.b	#'/',d0
		beq	option_next
@@:
.endif	/* !NO_SLASH */
		cmpi.b	#'-',d0
		bne	not_option
option_next:
		move.b	(a0)+,d0
		beq	optionsw

		pea	(option_next,pc)
		cmpi.b	#'-',d0
		beq	option_long
		cmpi.b	#'?',d0
		beq	option_help
		cmpi.b	#'1',d0
		beq	option_1
		cmpi.b	#'8',d0
		beq	option_8

		andi	#$df,d0			;啶
		subi	#'A',d0
		cmpi	#'Z'-'A',d0
		bhi	usage

		add	d0,d0
		move	(optjp_tbl,pc,d0.w),d0
		jmp	(optjp_tbl,pc,d0.w)

;----------------------------------------------------------------
;	IvVXCb`̃Wve[u
optjp_tbl:
	.irpc	char,abcdefghijklmnopqrstuvwxyz
		.dc	option_&char-optjp_tbl
	.endm

;----------------------------------------------------------------
;	OIvṼ`FbN
option_long:
		pea	(a0)
		pea	(str_help,pc)
		bsr	is_str_equ
		beq	option_help

		addq.l	#4,sp
		pea	(str_version,pc)
		bsr	is_str_equ
		beq	option_version
		bra	usage

is_str_equ:
		movem.l	a0-a1,-(sp)
		movem.l	(12,sp),a0-a1
is_str_equ_loop:
		cmpm.b	(a0)+,(a1)+
		bne	is_str_equ_end
		tst.b	(-1,a0)
		bne	is_str_equ_loop
is_str_equ_end:
		movem.l	(sp)+,a0-a1
		rts

;----------------------------------------------------------------
;	-t path		e|pXw
option_t:
		bsr	getargstring
		move.l	a0,(TEMPPATH,a6)
		bra	skipstring

skipstring:
		tst.b	(a0)+
		bne	skipstring
		subq.l	#1,a0
		rts

getargstring:
		tst.b	(a0)
		bne	@f
		addq.l	#1,a0
		tst.b	(a0)
		beq	usage
@@:		rts

;----------------------------------------------------------------
;	-i path		CN[hpXw
option_i:
		bsr	getargstring
	lea.l	(INCLUDEPATH,a6),a1
		bra	@f
option_i1:
		movea.l	d0,a1
@@:		move.l	(a1),d0		;pX`FC1ǂ
		bne	option_i1
	move.l	(TEMPPTR,a6),d0		;`FC̏I[
	addq.l	#1,d0
	bclr.l	#0,d0
	move.l	d0,(a1)			;1`FCǉ
	move.l	d0,a1
		clr.l	(a1)+
		bra	copystring	;pX𓾂

copystring:
		move.b	(a0)+,(a1)+
		bne	copystring
		subq.l	#1,a0
		move.l	a1,(TEMPPTR,a6)
		rts

;----------------------------------------------------------------
;	-o name		IuWFNgt@C
option_o:
		bsr	getargstring
		movea.l	(TEMPPTR,a6),a1
		move.l	a1,(OBJFILE,a6)
		bsr	copystring

	move.l	a0,-(sp)		;pXXLbvĂ'.'
		movea.l	(OBJFILE,a6),a0
	bsr	getfilename
	movea.l	(sp)+,a0
option_o1:
	move.b	(a1)+,d0
	beq	option_o2
	cmp.b	#'.',d0
	bne	option_o1
	rts

option_o2:				;gqȗꂽ.o
	move.b	#'.',(-1,a1)
	move.b	#'o',(a1)+
	clr.b	(a1)+
	move.l	a1,(TEMPPTR,a6)
	rts

;----------------------------------------------------------------
;	-p [file]	Xgt@C쐬
option_p:
	st.b	(MAKEPRN,a6)
	lea.l	(PRNFILE,a6),a2
option_p1:
		move.b	(a0),d0
		bne	option_pf		;-pfile

		addq.l	#1,a0
		move.b	(a0),d0
		beq	option_p9		;-p
	cmp.b	#'-',d0
	beq	option_p9			;-p -opt
.ifndef	NO_SLASH
	tst.b	(SWITCHCHAR,a6)
	bne	option_p4		;'/'XCb`ɎgpȂꍇ
	cmp.b	#'/',d0
	beq	option_p9
option_p4:
.endif	/* !NO_SHASH */
;-p file (\[Xt@C̉\L)
		tst.l	(SOURCEFILE,a6)
		bne	option_pf
		move.l	a0,(SOURCEFILE,a6)
option_pf:
		move.l	a0,(a2)			;-pfile
		bra	skipstring

option_p9:
	subq.l	#1,a0
	rts

;----------------------------------------------------------------
;	-x [file]	V{t@C쐬
option_x:
	st.b	(MAKESYM,a6)
	lea.l	(SYMFILE,a6),a2
	bra	option_p1

;----------------------------------------------------------------
;	-s symbol[=num]	V{̒`
option_s:
		bsr	getargstring
	bsr	getcmdnum
	bmi	option_s02
;V{̐擪1`4ȊÔƂ̓G[
	move.l	d1,d0
	beq	usage			;0
	subq.l	#4,d1
	bhi	usage			;5ȏ
	cmpi.b	#'=',(a0)
	beq	usage
	move.w	d0,(LOCALLENMAX,a6)	;ő包
	add.w	d0,d0
	move.w	(option_s01-2,pc,d0.w),(LOCALNUMMAX,a6)	;őԍ+1
	rts

option_s01:
	.dc.w	10,100,1000,10000

option_s02:
	cmpi.b	#'=',(a0)
	beq	usage
		lea	(a0),a2		;a2 = symbol name
		moveq	#0,d1
		moveq	#0,d2
@@:
		tst.b	(a0)
		beq	option_s1	;-s symbol
		cmpi.b	#'=',(a0)+
		bne	@b

		clr.b	(-1,a0)		;-s symbol=num
		cmpi.b	#'-',(a0)	;a0 = num
		seq	d7
		bne	option_s0
		addq.l	#1,a0		;-s symbol=-num
option_s0:
	bsr	getcmdnum
	bmi	usage			;lȂ
	tst.b	d7
	beq	option_s1
	neg.l	d1
option_s1:
	move.l	a0,-(sp)
	move.l	d1,-(sp)
	movea.l	a2,a0
	moveq.l	#ST_VALUE,d2		;lV{
	bsr	defstrsymbol		;Vo^
	tst.b	(SYM_TYPE,a1)		;cmpi.b #ST_VALUE,(SYM_TYPE,a1)
					;V{̃^Cv
	bne	usage			;^Cv̈قȂV{ƏdĂ
	move.b	#SA_DEFINE,(SYM_ATTRIB,a1)	;`σV{
	clr.b	(SYM_SECTION,a1)	;ZNVԍ
	move.l	(sp)+,(SYM_VALUE,a1)	;V{l
	movea.l	(sp)+,a0
	rts

;----------------------------------------------------------------
;	-f		Xgt@C̃tH[}bgw
option_f:
	movea.l	a0,a1
	bsr	getcmdnum
	beq	option_f1
	cmpi.b	#',',(a0)
	beq	option_f2
	st.b	(NOPAGEFF,a6)		;-f ݂̂Ȃy[WO֎~
	rts

option_f1:
	tst.l	d1
	seq.b	(NOPAGEFF,a6)		;y[WO[h
option_f2:
	bsr	getnextnum
	tst.w	d0
	bmi	option_f3
	tst.l	d1
	sne.b	(ISLALL,a6)		;}NWJ[h
option_f3:
	bsr	getnextnum
	tst.w	d0
	bmi	option_f4
	cmp.l	#256,d1
	bcc	usage
	cmp.w	#80,d1
	bcs	usage
	and.w	#$FFF8,d1
	move.w	d1,(PRNWIDTH,a6)	;\
option_f4:
	bsr	getnextnum
	tst.w	d0
	bmi	option_f5
	cmp.l	#256,d1
	bcc	usage
	cmp.w	#10,d1
	bcs	usage
	move.w	d1,(PRNPAGEL,a6)	;y[Ws
option_f5:
	rts

;----------------------------------------------------------------
;	-w [level]	[jOo̓x̎w
option_w:
	bsr	getcmdnum
	beq	option_w1
	move.b	#2,(WARNLEVEL,a6)	;-w ̂݁c[jOo̓x2
	rts

option_w1:
	cmp.l	#4,d1
	bhi	usage
	move.b	d1,(WARNLEVEL,a6)
	rts

;----------------------------------------------------------------
;	-n		œK̋֎~
option_n:
	st.b	(OPTIMIZE,a6)
	st.b	(IGNORE_ERRATA,a6)
	sf.b	(F43GTEST,a6)
	rts

;----------------------------------------------------------------
;	-u		`V{OQƂɂ
option_u:
	st.b	(ALLXREF,a6)
	rts

;----------------------------------------------------------------
;	-d		ׂẴV{O`ɂ
option_d:
	st.b	(ALLXDEF,a6)
	rts

;----------------------------------------------------------------
;	-8		V{̎ʒ8oCgɂ
option_8:
	st.b	(SYMLEN8,a6)
	rts

;----------------------------------------------------------------
;	-l		NɃ^Cg\
option_l:
	st.b	(DISPTITLE,a6)
	rts

;----------------------------------------------------------------
;	-e		OQƃItZbg̃ftHgO[hɂ
option_e:
	st.b	(EXTSHORT,a6)
	bra68	d0,option_e1		;68000/68010ȂtOZbĝ
	st.b	(EXTSIZEFLG,a6)
	move.b	#SZ_LONG,(EXTSIZE,a6)
	move.l	#4,(EXTLEN,a6)
option_e1:
	rts

;----------------------------------------------------------------
;	-g		SCD.XpfobOo͂
option_g:
	st.b	(MAKESYMDEB,a6)
	rts

;----------------------------------------------------------------
;	-c		HAS v2.xƌ݊̂œKs
option_c:
	bsr	getcmdnum
	bmi	option_c_x		;-c̒オłȂ
	subq.l	#1,d1
	bcs	option_c_0
	beq	option_c_1
	subq.l	#2,d1
	bcs	option_c_2
	beq	option_c_3
	subq.l	#2,d1
	bcc	usage			;0`4łȂ
;-c4 ׂĂ̍œK
option_c_4:
	sf.b	(OPTIMIZE,a6)		;OQƂ̍œK
;gꂽœK
	st.b	(OPTCLR,a6)		;CLRœK
	st.b	(OPTMOVEA,a6)		;MOVEAœK
	st.b	(OPTADDASUBA,a6)	;ADDA/CMPA/SUBAœK
	st.b	(OPTCMPA,a6)		;ADDA/CMPA/SUBAœK
	st.b	(OPTLEA,a6)		;LEAœK
	st.b	(OPTASL,a6)		;ASLœK
	st.b	(OPTCMP0,a6)		;CMP.bwl #0,DnTST.bwl Dn
	st.b	(OPTMOVE0,a6)		;MOVE.bw #0,DnCLR.bw Dn
	st.b	(OPTCMPI0,a6)		;CMPI.bwl #0,<ea>TST.bwl <ea>
	st.b	(OPTSUBADDI0,a6)	;ADDI/SUBI #d3,<ea>ADDQ/SUBQ #d3,<ea>
	st.b	(OPTBSR,a6)		;ւbsrpeaɂ
	st.b	(OPTJMPJSR,a6)		;jmp/jsrœK
;v2݊
option_c_2off:
	sf.b	(COMPATMODE,a6)		;v2݊
	sf.b	(NOABSSHORT,a6)		;΃V[gւ̕ϊ
	sf.b	(NOQUICK,a6)		;NCbNC~fBGCgւ̕ϊ
	sf.b	(NONULDISP,a6)		;fBXv[Xg̍폜
	sf.b	(NOBRACUT,a6)		;򖽗߂̍폜
	rts

;-c3 v3݊
option_c_3:
	bsr	option_c_2off		;v2݊
	bra	option_c_exoff		;gꂽœK֎~

;-c2 v2݊
option_c_2:
	st.b	(COMPATMODE,a6)		;NOABSSHORTNOQUICK-a-qŌ肷
	st.b	(NONULDISP,a6)
	st.b	(NOBRACUT,a6)
	bra	option_c_exoff		;gꂽœK֎~

;-c1 (d,An)̍œK֎~
option_c_1:
	st.b	(NONULDISP,a6)
	rts

;-c0 ׂĂ̍œK֎~
option_c_0:
	st.b	(OPTIMIZE,a6)		;OQƂ̍œK֎~
	st.b	(IGNORE_ERRATA,a6)
	sf.b	(F43GTEST,a6)
	sf.b	(COMPATMODE,a6)		;v2݊
	st.b	(NOABSSHORT,a6)		;΃V[gւ̕ϊ֎~
	st.b	(NOQUICK,a6)		;NCbNC~fBGCgւ̕ϊ֎~
	st.b	(NONULDISP,a6)		;fBXv[Xg̍폜֎~
	st.b	(NOBRACUT,a6)		;򖽗߂̍폜֎~
;gꂽœK֎~
option_c_exoff:
	sf.b	(OPTCLR,a6)		;CLRœK
	sf.b	(OPTMOVEA,a6)		;MOVEAœK
	sf.b	(OPTADDASUBA,a6)	;ADDA/CMPA/SUBAœK
	sf.b	(OPTCMPA,a6)		;ADDA/CMPA/SUBAœK
	sf.b	(OPTLEA,a6)		;LEAœK
	sf.b	(OPTASL,a6)		;ASLœK
	sf.b	(OPTCMP0,a6)		;CMP.bwl #0,DnTST.bwl Dn
	sf.b	(OPTMOVE0,a6)		;MOVE.bw #0,DnCLR.bw Dn
	sf.b	(OPTCMPI0,a6)		;CMPI.bwl #0,<ea>TST.bwl <ea>
	sf.b	(OPTSUBADDI0,a6)	;ADDI/SUBI #d3,<ea>ADDQ/SUBQ #d3,<ea>
	sf.b	(OPTBSR,a6)		;ւbsrpeaɂ
	sf.b	(OPTJMPJSR,a6)		;jmp/jsrœK
	rts

option_c_x::
	tst.b	(a0)
	beq	option_c_2
option_c_x0:
		lea	(a0),a1		;a1.l = ̐擪
option_c_x1:
		move.b	(a0)+,d0
	cmp.b	#'0',d0
	blo	option_c_x2
	cmp.b	#'9',d0
	bls	option_c_x1
		ori.b	#$20,d0		;
	cmp.b	#'a',d0
	blo	option_c_x2
	cmp.b	#'z',d0
	bhi	option_c_x2
option_c_x11:
		move.b	d0,(-1,a0)
	bra	option_c_x1

option_c_x2:
		move.b	-(a0),d1		;̕
		clr.b	(a0)+
;-cfscc[=6]
		pea	(a1)
		pea	(str_fscc,pc)
		bsr	is_str_equ
;FSccFBcc
	lea.l	(X_FSCC,a6),a1		;FSccWJ
		beq	option_c_y

option_c_x3:
;-cmovep[=6]
		addq.l	#4,sp
		pea	(str_movep,pc)
		bsr	is_str_equ
;MOVEPMOVE
	lea.l	(X_MOVEP,a6),a1
		bne	option_c_x4
option_c_y:
		addq.l	#8,sp
	st.b	(a1)			;ׂēWJ
		cmp.b	#'=',d1
	bne	option_c_x96
	cmpi.b	#'6',(a0)+
	bne	usage
		move.b	(a0)+,d1
	move.w	#C060,(a1)		;68060̂ƂWJ
	bra	option_c_x99

option_c_x4:

;-cfximm
;F<op>.X #imm,FPn(d,PC)

;-cfmovecr
;FMOVECR.X #imm,FPn(d,PC)

;-call[=6]
		addq.l	#4,sp
		pea	(str_all,pc)
		bsr	is_str_equ
		addq.l	#8,sp
		bne	usage
;ALL
	st.b	d0			;moveq.l #-1,d0͕s
		cmpi.b	#'=',d1
	bne	option_c_x95
	cmpi.b	#'6',(a0)+
	bne	usage
		move.b	(a0)+,d1
	move.w	#C060,d0		;68060̂Ƃ
option_c_x95:
	move.w	d0,(X_FSCC,a6)		;FSccWJ
	move.w	d0,(X_MOVEP,a6)		;MOVEPWJ
option_c_x99:
option_c_x96:
		tst.b	d1
		beq	option_c_x97		;0܂ނ̂a0fNgĂI
		cmp.b	#',',d1
		beq	option_c_x0
		bra	usage

option_c_x97:
	subq.l	#1,a0
option_c_x98:
	rts

;----------------------------------------------------------------
;	-b[n]		PCԐځ΃O([1]=68000,2=mem,3=1+2,4=all,5=1+4)
;				0	[֎~]
;				[1]	(bd,PC)/Bcc.L	68000R[h
;				2	(d,PC)<mem>	i-cache(lea/peaȊO)
;				3	1+2
;				4	(d,PC)<all>	fobOp
;				5	1+4
option_b:
	bsr	getcmdnum
	bmi	option_b1
	subq.l	#1,d1
	bcs	option_b0
	beq	option_b1
	subq.l	#2,d1
	bcs	option_b2
	beq	option_b3
	subq.l	#2,d1
	bcs	option_b4
	bne	usage			;0`5łȂ
option_b5:
	bsr	option_b4_1
	bsr	option_b2_1		;57(allmem܂)
option_b1_1:
	st.b	(LONGABS,a6)
	st.b	(BRATOJBRA,a6)
	rts

option_b4:
	bsr	option_b2_1		;46(allmem܂)
	bsr	option_b1_0
option_b4_1:
	sf.b	(PCTOABSLNOTALL,a6)
	rts

option_b3:
	bsr	option_b4_0
	bsr	option_b1_1
option_b2_1:
	st.b	(PCTOABSL,a6)
	rts

option_b2:
	bsr	option_b4_0
	bsr	option_b2_1
option_b1_0:
	sf.b	(LONGABS,a6)
	sf.b	(BRATOJBRA,a6)
	rts

option_b1:
	bsr	option_b4_0
	bsr	option_b1_1
option_b2_0:
	sf.b	(PCTOABSL,a6)
	rts

option_b0:
	bsr	option_b2_0
	bsr	option_b1_0
option_b4_0:
	st.b	(PCTOABSLNOTALL,a6)
	rts

;----------------------------------------------------------------
;	-m nn		CPU[h̎w
option_m:
		bsr	getargstring
	bsr	getcmdnum
	bmi	usage
	cmp.l	#5200,d1
	beq	~~cpu_5200
	cmp.l	#5300,d1
	beq	~~cpu_5300
	cmp.l	#5400,d1
	beq	~~cpu_5400
		subi.l	#68000,d1
		beq	~~cpu_68000
		moveq	#10,d0
		sub.l	d0,d1
		beq	~~cpu_68010
		sub.l	d0,d1
		beq	~~cpu_68020
		sub.l	d0,d1
		beq	~~cpu_68030
		sub.l	d0,d1
		beq	~~cpu_68040
		moveq	#20,d0
		sub.l	d0,d1
		beq	~~cpu_68060
		bra	usage

;----------------------------------------------------------------
;	-j[n]
option_j:
	bsr	getcmdnum
	bpl	option_j_1
	moveq.l	#-1,d1
option_j_1:
	lsr.l	#1,d1
	scs.b	(OWSET,a6)
	lsr.l	#1,d1
	scs.b	(OWOFFSYM,a6)
;ȃrbg̓G[ł͂Ȃ
	rts

;----------------------------------------------------------------
;	-k	Gb^̑΍֎~
option_k:
	bsr	getcmdnum
	bmi	option_k_1
	subq.l	#1,d1
	bhi	usage
	beq	option_k_1
option_k_0:
	sf.b	(IGNORE_ERRATA,a6)
	sf.b	(OPTIMIZE,a6)
	rts

option_k_1:
	st.b	(IGNORE_ERRATA,a6)
	sf.b	(F43GTEST,a6)
	rts

;----------------------------------------------------------------
;	-1		΃Ooptional PCԐڂɂ
option_1:
	st.b	(ABSLTOOPC,a6)		;΃Ooptional PCԐڂɂ
	bsr	option_e
	bra	option_b1

;----------------------------------------------------------------
;	-y[n]		vft@CV{(0=[֎~],[1]=)
option_y:
	bsr	getcmdnum
	bmi	option_y_1
	subq.l	#1,d1
	bcs	option_y_0
	bne	usage
option_y_1:
	st.b	(PREDEFINE,a6)
	rts

option_y_0:
	sf.b	(PREDEFINE,a6)
	rts


;----------------------------------------------------------------
;	(_~[̃IvVXCb`)

;	-a		΃V[gAhX`Ή[h
option_a:
	st.b	(COMPATSWA,a6)
	rts

;	-q		NCbNC~fBGCg`ւ̕ϊ֎~
option_q:
	st.b	(COMPATSWQ,a6)
;	-z		HASg@\̃[jO֎~
.if 0
option_z:
;	-r		΃ZNV߂
option_r:
	rts
.endif

;----------------------------------------------------------------
;	R}hC̐l𓾂
getcmdnum:
	movem.l	a0-a1,-(sp)
	bsrl	getnum,d0
	beq	getcmdnum9
	movem.l	(sp)+,a0-a1
	moveq.l	#-1,d0
	rts

getcmdnum9:
	addq.l	#4,sp
	movea.l	(sp)+,a1
	moveq.l	#0,d0
	rts

;----------------------------------------------------------------
;	R}hC̎̐l𓾂
getnextnum:
	cmpi.b	#',',(a0)+
	beq	getcmdnum
	subq.l	#1,a0
	addq.l	#4,sp
	rts				;ĂяoTu[`^[

;----------------------------------------------------------------
;	gq菜t@C]
tfrfilename:
	move.l	a1,-(sp)
		move.b	(a1)+,(a0)+
		beq	@f
tfrfilename1:
	move.b	(a1)+,d0
	beq	tfrfilename9
	cmp.b	#'.',d0
	beq	tfrfilename9
	move.b	d0,(a0)+
	bra	tfrfilename1

tfrfilename9:
	clr.b	(a0)
@@:	move.l	(sp)+,a1
	rts

;----------------------------------------------------------------
;	-v / --version
option_v:
option_version:
		lea	(ver_msg_end,pc),a0
  .if UNIX_NEWLINE=0
		move.b	#CR,(a0)+
  .endif
		move.b	#LF,(a0)+
		clr.b	(a0)
		pea	(title_msg,pc)
		DOS	_PRINT
		DOS	_EXIT

;----------------------------------------------------------------
;	-? / -h / --help
option_h:
option_help:
		pea	(title_msg,pc)
		DOS	_PRINT
		pea	(usage_msg,pc)
		DOS	_PRINT
		DOS	_EXIT

;----------------------------------------------------------------
;	gp@\ďI
option_r:
option_z:
usage:
	lea.l	(title_msg,pc),a0
	bsr	printmsg
	lea.l	(usage_msg,pc),a0
	bsr	printmsg
	move.w	#1,-(sp)
	DOS	_EXIT2


;----------------------------------------------------------------
	.end	asmmain

;----------------------------------------------------------------
;	$Log: main.s,v $
;	Revision 3.8  1999 10/ 8(Fri) 17:33:03 M.Kamada
;	+86 sR[h̕ύXɑΉ
;	+86 EUCΉ
;
;	Revision 3.7  1999  3/19(Fri) 16:18:43 M.Kamada
;	+83 -o./foôƂ.o⊮Ȃ
;	+83 "vI"
;	+83 gp@ɊϐHAS̐擪'*'̏ꍇɂċLq
;	+83 [Jx̍ő包4܂őI\
;
;	Revision 3.6  1999  3/ 3(Wed) 14:39:51 M.Kamada
;	+82 wvbZ[W̃XCb`̕яύX
;	+82 Fatal error(s)bZ[W{ꉻ
;	+82 gp@ -f  -w ̕\ύX
;	+82 doevendoquad
;
;	Revision 3.5  1999  2/27(Sat) 23:42:45 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 3.4  1999  2/25(Thu) 05:02:40 M.Kamada
;	+80 Copyright\-98ɂȂĂ
;	+80 ColdFireΉ
;	+80 .offsym <l>,<V{>
;	+80 setsetȊOŒ`ꂽV{̏㏑֎~
;
;	Revision 3.3  1999  2/13(Sat) 20:35:01 M.Kamada
;	+79 .R`ɂƃɒ[ɕsĂƂ̃ubNj󂷂\
;	+79 ɒ[ɕsĂƂoXG[o\
;	+79 R}hC'='Ŏn܂PꂪƃnOAbv
;	+79 \[Xt@C2ƂG[ɂ
;
;	Revision 3.2  1998 11/19(Thu) 23:46:21 M.Kamada
;	+78 -k0-n𕹗pƌ듮삷邽ߌォw肵Lɂ
;
;	Revision 3.1  1998  7/14(Tue) 02:43:56 M.Kamada
;	+69 vft@CV{__HAS____HAS060__ǉ
;	+69 crlf_msg
;
;	Revision 3.0  1998  5/24(Sun) 18:28:43 M.Kamada
;	+66 -y[n]nƏ-y0ɂȂsC
;
;	Revision 2.9  1998  4/13(Mon) 04:51:03 M.Kamada
;	+64 Gb^̑΍֎~XCb`ǉ
;
;	Revision 2.8  1998  3/31(Tue) 02:09:02 M.Kamada
;	+63 jmp/jsrœK
;
;	Revision 2.7  1998  1/25(Sun) 21:53:31 M.Kamada
;	+58 tjjbNelifǉ
;
;	Revision 2.6  1998  1/ 9(Fri) 22:22:27 M.Kamada
;	+56 -f43g폜
;
;	Revision 2.5  1998  1/ 5(Mon) 01:10:43 M.Kamada
;	+55 -b[n]
;	+55 -1g2asɍ킹
;	+55 wv̖߂啶
;
;	Revision 2.4  1997 10/28(Tue) 02:53:25 M.Kamada
;	+52 -call̒1'='łȂƖs
;
;	Revision 2.3  1997 10/13(Mon) 02:12:15 M.Kamada
;	+51 ւbsrpea
;	+52 JMP/JSRœK
;
;	Revision 2.2  1997  9/28(Sun) 19:56:57 M.Kamada
;	+49 -m̌ɃXy[XƃG[ɂȂ
;	+49 -cmnemonicw肷ƃAhXG[o邱Ƃ
;	+49 -cmnemonic-c<mnemonic>,̃XCb`<>ň͂ł݂
;	+49 -up,-dpp~,-y[n]gp
;
;	Revision 2.1  1997  9/23(Tue) 03:32:58 M.Kamada
;	+47 movepfscc̃G~[Vg[
;
;	Revision 2.0  1997  9/15(Mon) 16:01:22 M.Kamada
;	+46 error.s𕪗,ST_VALUE=0ōœK
;
;	Revision 1.9  1997  9/17(Wed) 22:36:55 M.Kamada
;	+43 -c0łׂĂ̍œK֎~
;	+44 software emulation̖߂WJ
;
;	Revision 1.8  1997  7/ 9(Wed) 02:36:17 M.Kamada
;	+39 -1̋C
;
;	Revision 1.7  1997  6/26(Thu) 22:09:48 M.Kamada
;	+33 vft@CV{CPUɑΉ
;	+34 vft@CV{__DATE__,__TIME__ɑΉ
;	+35 CMP.bwl #0,DnTST.bwl Dn
;	+36 MOVE.bw #0,DnCLR.bw Dn
;	+37 -up,-dpŃvft@CV{̋֎~,
;	+38 CMPI.bwl #0,<ea>TST.bwl <ea>
;
;	Revision 1.6  1997  3/29(Sat) 21:25:18 M.Kamada
;	+24 MOVEAœK
;	+25 CLRœK
;	+26 ADDA/CMPA/SUBAœK
;	+27 -c4ŊgœK
;	+28 LEAœK
;	+29 ASLœK
;
;	Revision 1.5  1997  3/14(Fri) 02:46:08 M.Kamada
;	+18 TCYŵȂ萔łȂ΃O(d,OPC)ɂ
;
;	Revision 1.4  1997  2/ 2(Sun) 17:03:15 M.Kamada
;	+15 -c1ȂNONULDISPZbg
;		-wlevel̊Ԃ̋󔒂F߂Ȃ
;		-ff,m,w,p̊Ԃ̋󔒂F߂Ȃ
;
;	Revision 1.3  1996 11/13(Wed) 15:27:30 M.Kamada
;	+00 DEBUGǉ
;		e|t@C폜Ȃ
;	+99 ^CgύX
;	+02 68060Ή
;		wvbZ[WύX
;	+05 ftHg̃^[QbgMPU68000ɂ
;		ftHg̃^[QbgMPU68000ɂ
;		wvbZ[WύX
;	+06 ϐHASR}hC̑Oɑ}
;		ϐHASR}hC̑Oɑ}
;		wvbZ[WύX
;
;	Revision 1.2  1994/03/06  03:16:24  nakamura
;	IvVXCb`̒ǉ̑
;
;	Revision 1.1  1994/02/16  15:38:18  nakamura
;	Initial revision
;
;
