;----------------------------------------------------------------
;	X68k High-speed Assembler
;		ėpTu[`/A{[g
;		< misc.s >
;
;	$Id: misc.s,v 2.1  1999 10/ 8(Fri) 21:50:20 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;			  1996-99  by M.Kamada
;----------------------------------------------------------------

	.include	doscall.mac
	.include	has.equ
	.include	register.equ

	.cpu	68000
	.text


;----------------------------------------------------------------
;	DOSR[ԍړ΍
.ifndef	HUMAN_V3
getenv::
	link	a6,#0
	move.l	(16,a6),-(sp)
	move.l	(12,a6),-(sp)
	move.l	(8,a6),-(sp)
	DOS	_VERNUM
	cmp.w	#$020F,d0
	bcc	getenv1
	.dc.w	$FF53			;DOS _GETENV (`v2.03)
	bra	getenv9

getenv1:
	.dc.w	$FF83			;DOS _GETENV (v2.15`)
getenv9:
	unlk	a6
	rts
.endif	/* !HUMAN_V3 */


;----------------------------------------------------------------
;	P[VJE^
;----------------------------------------------------------------

;----------------------------------------------------------------
;	P[VJE^Zbg
;	in :---
;	out:---
resetlocctr::
	movem.l	d0/a0,-(sp)
	lea.l	(LOCCTRBUF,a6),a0
	move.w	#N_SECTIONS-1,d0
resetlocctr1:
	clr.l	(a0)+			;P[VJE^NA
	dbra	d0,resetlocctr1
	move.w	#N_SECTIONS-1,d0
resetlocctr2:
	clr.l	(a0)+			;œKP[VItZbgNA
	dbra	d0,resetlocctr2
	move.w	#N_SECTIONS-1,d0
resetlocctr3:
	clr.b	(a0)+			;orgZNVԍNA
	dbra	d0,resetlocctr3
	clr.l	(LOCATION,a6)
	clr.l	(LOCOFFSET,a6)
	clr.b	(ORGNUM,a6)
	move.b	#SECT_TEXT,(SECTION,a6)	;textZNVɂ
	sf.b	(OFFSYMMOD,a6)
	movem.l	(sp)+,d0/a0
	rts

;----------------------------------------------------------------
;	ZNV؂ւ
;	in :d0.b=؂ւZNVԍ
;	out:---
chgsection::
	movem.l	d0/a0,-(sp)
	move.b	(SECTION,a6),d0
	beq	chgsection1		;܂܂offsetZNV
	lea.l	(ORGNUMBUF,a6),a0
	move.b	(ORGNUM,a6),(-1,a0,d0.w)
	add.w	d0,d0
	add.w	d0,d0
	lea.l	(LOCCTRBUF,a6),a0
	move.l	(LOCATION,a6),(-4,a0,d0.w)	;ZNṼJE^Ҕ
	move.l	(LOCOFFSET,a6),(LOCOFFSETBUF-LOCCTRBUF-4,a0,d0.w)
chgsection1:
	move.w	(2,sp),d0
	move.b	d0,(SECTION,a6)
	beq	chgsection2		;ꂩoffsetZNVɕύX
	lea.l	(ORGNUMBUF,a6),a0
	move.b	(-1,a0,d0.w),(ORGNUM,a6)
	add.w	d0,d0
	add.w	d0,d0
	lea.l	(LOCCTRBUF,a6),a0
	move.l	(-4,a0,d0.w),(LOCATION,a6)	;VZNṼJE^o
	move.l	(LOCOFFSETBUF-LOCCTRBUF-4,a0,d0.w),(LOCOFFSET,a6)
chgsection2:
	movem.l	(sp)+,d0/a0
	rts


;----------------------------------------------------------------
;	f[^TCY
;----------------------------------------------------------------

;----------------------------------------------------------------
;	f[^^̃TCY𓾂
;	in :d0.b=f[^^
;	out:d0.l=f[^̐߂TCY
getdtsize::
	and.l	#3,d0
	move.b	(dtsize_tbl,pc,d0.w),d0
	rts

dtsize_tbl:
	.dc.b	2,2,4,1
	.even


;----------------------------------------------------------------
;	񑀍
;----------------------------------------------------------------

;----------------------------------------------------------------
;	Xy[XE^uXLbv
;	in :a0=ւ̃|C^
;	out:a0=ւ̃|C^
skipspc::
	move.w	d0,-(sp)
skipspc1:
	move.b	(a0)+,d0
	beq	skipspc2
	cmp.b	#' ',d0
	bls	skipspc1
skipspc2:
	subq.l	#1,a0
	move.w	(sp)+,d0
skipspc9:
	rts

;----------------------------------------------------------------
;	̒𓾂
;	in :a0=ւ̃|C^
;	out:d1.w=̒-1
strlen::
	move.l	a0,-(sp)
	moveq.l	#-2,d1
strlen1:
	addq.w	#1,d1
	tst.b	(a0)+
	bne	strlen1
	move.l	(sp)+,a0
	rts

;----------------------------------------------------------------
;	Rs[
;	in :a1=Rs[ւ̃|C^/a0=Rs[敶ւ̃|C^
;	out:a0=Rs[̏Iʒu
strcpy::
	move.b	(a1)+,(a0)+
	bne	strcpy
	subq.l	#1,a0
	rts

;----------------------------------------------------------------
;	hCu+pXRs[
;	in :a1=Rs[ւ̃|C^/a0=Rs[敶ւ̃|C^
;	out:a0=Rs[̏Iʒu
pathcpy::
	move.w	d0,-(sp)
	tst.b	(a1)
	beq	pathcpy9
pathcpy1:
	tst.b	(a1)
	beq	pathcpy5
	moveq.l	#0,d0
	move.b	(a1)+,d0
	move.b	d0,(a0)+
	bpl	pathcpy1
  .if EUCSRC=0
	cmp.b	#$E0,d0
	bcc	pathcpy2
	cmp.b	#$A0,d0
	bcc	pathcpy1		;pJȉꍇ
  .else
	bra	pathcpy1		;EUC
  .endif
pathcpy2:
	lsl.w	#8,d0
	move.b	(a1)+,d0		;2oCg2oCg
	beq	pathcpy5
	move.b	d0,(a0)+
	bra	pathcpy1

pathcpy5:
	cmp.w	#'\',d0
	beq	pathcpy9
	cmp.w	#'/',d0
	beq	pathcpy9
	cmp.w	#':',d0
	beq	pathcpy9
pathcpy8:
	move.b	#'\',(a0)+		;pX̋؂ǉ
pathcpy9:
	move.w	(sp)+,d0
	rts

;----------------------------------------------------------------
;	hCu+pXt@Ĉ݂o
;	in :a0=hCuEpXtt@Cւ̃|C^
;	out:a1=t@Ĉ݂ւ̃|C^
getfilename::
	move.w	d0,-(sp)
getfilename1:
	movea.l	a0,a1
	bra	getfilename25
getfilename2:
	cmp.b	#':',d0
	beq	getfilename1
	cmp.b	#'\',d0
	beq	getfilename1
	cmp.b	#'/',d0
	beq	getfilename1
getfilename25:
	move.b	(a0)+,d0
	bmi	getfilename4
	bne	getfilename2
getfilename3:
	move.w	(sp)+,d0
	rts

getfilename4:
  .if EUCSRC=0
	cmp.b	#$E0,d0
	bcc	getfilename5
	cmp.b	#$A0,d0
	bcc	getfilename25		;pJȉꍇ
  .else
	bra	getfilename25		;EUC
  .endif
getfilename5:
	tst.b	(a0)+
	bne	getfilename25
	bra	getfilename3


;----------------------------------------------------------------
;	vIG[ɂA{[g
;----------------------------------------------------------------

;----------------------------------------------------------------
;	gpʂ邩`FbN
;	in :---
;	out:---(sȂvO𒆒f)
memcheck::
	move.l	d0,-(sp)
	move.l	(MEMLIMIT,a6),d0
	cmp.l	(TEMPPTR,a6),d0
	bcs	nomemabort
	move.l	(sp)+,d0
	rts

;----------------------------------------------------------------
;	s
nomemabort::
	lea.l	(nomem_msg,pc),a0
	bra	abort

;----------------------------------------------------------------
;	݂Ɏs
devfulabort::
	lea.l	(devful_msg,pc),a0
	bra	abort

;----------------------------------------------------------------
;	OV{̐32767𒴂
toomanyexabort::
	lea.l	(toomanyex_msg,pc),a0
	bra	abort

;----------------------------------------------------------------
;	e|t@CI[vɎs
tmpopenabort::
	lea.l	(temp_msg,pc),a0

;----------------------------------------------------------------
;	t@CI[vɎs(a0=t@Cւ̃|C^)
filopenabort::
	bsr	printmsg
	lea.l	(openerr_msg,pc),a0
abort:					;vOf
	bsr	printmsg
	DOS	_ALLCLOSE		;St@CN[Y
	lea.l	(beep_msg,pc),a0
	bsr	printmsg
	move.w	#1,-(sp)
	DOS	_EXIT2

nomem_msg:	mes	'Abort: sĂ܂'
		.dc.b	CRLF,0
devful_msg:	mes	'Abort: fBXNςł'
		.dc.b	CRLF,0
toomanyex_msg:	mes	'Abort: OV{܂'
		.dc.b	CRLF,0
temp_msg:	mes	'e|t@C'
		.dc.b	0
openerr_msg:	mes	'I[vł܂'
		.dc.b	CRLF,0
beep_msg::	.dc.b	BELL,0
	.even


;----------------------------------------------------------------
;	lϊ
;----------------------------------------------------------------

;----------------------------------------------------------------
;	d0.l16i8̕ɕϊ
;	in :d0.l=ϊ鐔l/a0=ϊi[obt@
;	out:a0=ϊ̍Ōw
convhex8::
	swap.w	d0
	bsr	convhex4
	swap.w	d0

;----------------------------------------------------------------
;	d0.w16i4̕ɕϊ
;	in :d0.l=ϊ鐔l/a0=ϊi[obt@
;	out:a0=ϊ̍Ōw
convhex4::
	rol.w	#8,d0
	bsr	convhex2
	rol.w	#8,d0

;----------------------------------------------------------------
;	d0.b16i2̕ɕϊ
;	in :d0.l=ϊ鐔l/a0=ϊi[obt@
;	out:a0=ϊ̍Ōw
convhex2::
	move.w	d0,-(sp)		;8
	lsr.w	#4,d0			;14
	bsr	convhex21		;18+61
	move.w	(sp),d0			;8
	bsr	convhex21		;18+61
	move.w	(sp)+,d0		;8
					;196
	rts

convhex21:
	and.w	#$0F,d0			;8
	add.w	#'0',d0			;8
	cmp.w	#'9',d0			;8
	bls	convhex22		;8|10
	addq.w	#7,d0			;8|0
convhex22:
	move.b	d0,(a0)+		;8
	rts				;16
					;61

;----------------------------------------------------------------
;	d0.l10iɕϊ
;	in :d0.l=ϊ鐔l/a0=ϊi[obt@
;	   :d1.w=ϊ(̐Ȃ[TvXȂ/0Ȃ獶l)
;	out:a0=ϊ̍Ōw
convdec::
	movem.l	d0-d3/a1-a2,-(sp)
	moveq.l	#' ',d2
	tst.w	d1
	beq	convdec9		;l
	bpl	convdec1
	moveq.l	#'0',d2
	neg.w	d1
convdec1:
	subq.w	#1,d1
	move.w	d1,d3
convdec2:				;ϊXy[Xm
	move.b	d2,(a0)+
	dbra	d3,convdec2
	link	a5,#-12
	lea.l	(-12,a5),a1
	clr.b	(a1)+
	bsr	convdecs		;l߂ŕϊ
	movea.l	a0,a2
convdec3:				;E[猅i[Ă䂭
	move.b	-(a1),d0
	beq	convdec4
	move.b	d0,-(a2)
	dbra	d1,convdec3
convdec4:
	unlk	a5
	movem.l	(sp)+,d0-d3/a1-a2
	rts

convdec9:				;l߂̏ꍇ
	movea.l	a0,a1
	bsr	convdecs
	movea.l	a1,a0
	movem.l	(sp)+,d0-d3/a1-a2
	rts

convdecs:				;d0.l(a1)獶l߂ŕϊ
	lea.l	(dectable,pc),a2
convdecs1:
	move.l	(a2)+,d2
	beq	convdecs9
	cmp.l	d0,d2
	bhi	convdecs1
convdecs2:
	moveq.l	#'0'-1,d3
convdecs3:
	addq.b	#1,d3
	sub.l	d2,d0
	bcc	convdecs3
	move.b	d3,(a1)+
	add.l	d2,d0
	move.l	(a2)+,d2
	bne	convdecs2
	rts

convdecs9:
	move.b	#'0',(a1)+
	rts

dectable:				;10iϊpe[u
	.dc.l	1000000000,100000000,10000000,1000000,100000,10000,1000,100,10,1,0


;----------------------------------------------------------------
;	bZ[Wo
;----------------------------------------------------------------

;----------------------------------------------------------------
;	WG[o͂ɃbZ[Wo͂
;	in :a0=\ւ̃|C^
;	out:---
printmsg::
	move.w	#STDERR,-(sp)
	pea.l	(a0)
	DOS	_FPUTS
	addq.l	#6,sp
	rts

;----------------------------------------------------------------
;	WóEPRNt@CɃbZ[Wo͂
;	in :a0=\ւ̃|C^
;	out:---
prnstdout::
	tst.b	(MAKEPRN,a6)
	beq	prnstdout1
	tst.b	(ISPRNSTDOUT,a6)
	bne	prnlout
	bsr	prnlout
prnstdout1:
	move.l	d0,-(sp)
	move.w	#STDOUT,-(sp)
	pea.l	(a0)
	DOS	_FPUTS
	addq.l	#6,sp
	move.l	(sp)+,d0
	rts

;----------------------------------------------------------------
;	PRNt@CɃbZ[Wo͂
;	in :a0=\ւ̃|C^
;	out:---
prnlout::
	tst.b	(NOPAGEFF,a6)
	bne	prnlout1
	bsr	prnpaging
prnlout1:
	move.l	d0,-(sp)
	move.w	(PRNHANDLE,a6),-(sp)
	pea.l	(a0)
	DOS	_FPUTS
	addq.l	#6,sp
	tst.l	d0
	beq	prnlout9
prnlout2:
	move.l	(sp)+,d0
	rts

prnlout9:
	tst.b	(a0)
	beq	prnlout2
	bra	devfulabort

;----------------------------------------------------------------
;	PRNt@C̉y[WsȂ
;	in :d0.w=y[Ŵ݂Ȃ0/Cy[W𑝂₷Ȃ1/V{y[WȂ-1
;	out:---
prnnextpage::
	tst.w	d0
	beq	prnnextpage9
	bmi	prnnextpage1
	addq.w	#1,(PRNMPAGE,a6)
	bra	prnnextpage2

prnnextpage1:
	clr.w	(PRNMPAGE,a6)
prnnextpage2:
	clr.w	(PRNSPAGE,a6)
prnnextpage9:
	move.w	#1,(PRNCOUNT,a6)
	rts

;----------------------------------------------------------------
;	KvȂPRNt@C̃y[WOsȂ
;	in :---
;	out:---
prnpaging:
	subq.w	#1,(PRNCOUNT,a6)
	bcs	prnpaging1
	bne	prnpaging9
	move.l	a0,-(sp)
	lea.l	(pageff_msg,pc),a0
	bsr	prnlout1		;y[WR[ho
	movea.l	(sp)+,a0
prnpaging1:
	link	a5,#-80
	movem.l	d0-d1/a0-a1,-(sp)
	addq.w	#1,(PRNSPAGE,a6)
	move.w	(PRNPAGEL,a6),d0
	subq.w	#4,d0
	move.w	d0,(PRNCOUNT,a6)
	lea.l	(title_msg,pc),a0
	bsr	prnlout1		;^Cgso
	movea.l	(PRNTITLE,a6),a1
	bsr	tfrtitle
	lea.l	(PRNDATE,a6),a1
	bsr	strcpy
	lea.l	(crlf_msg,pc),a1
	bsr	strcpy
	lea.l	(-80,a5),a0
	bsr	prnlout1		;^CgE\
	movea.l	(PRNSUBTTL,a6),a1
	bsr	tfrtitle
	move.w	(PRNMPAGE,a6),d0
	beq	prnpaging2
	lea.l	(page_msg,pc),a1
	bsr	strcpy
	ext.l	d0
	moveq.l	#0,d1			;(l)
	bsr	convdec
	move.b	#'-',(a0)+
	bra	prnpaging3

prnpaging2
	lea.l	(sym_msg,pc),a1
	bsr	strcpy
prnpaging3:
	move.w	(PRNSPAGE,a6),d0
	ext.l	d0
	moveq.l	#0,d1			;(l)
	bsr	convdec
	lea.l	(crlf_msg,pc),a1
	bsr	strcpy
	lea.l	(-80,a5),a0
	bsr	prnlout1		;Tu^CgEy[W\
	lea.l	(crlf_msg,pc),a0
	bsr	prnlout1
	cmpi.w	#1,(PRNSPAGE,a6)
	bne	prnpaging4
	tst.w	(PRNMPAGE,a6)
	beq	prnpaging4
	bsr	prnlout1
	subq.w	#1,(PRNCOUNT,a6)
prnpaging4:
	movem.l	(sp)+,d0-d1/a0-a1
	unlk	a5
prnpaging9:
	rts

tfrtitle:
	lea.l	(-80,a5),a0
	moveq.l	#56-1,d0
tfrtitle1:
	move.b	(a1)+,(a0)+
	dbeq	d0,tfrtitle1
	bne	tfrtitle9
	subq.l	#1,a0
tfrtitle2:
	move.b	#' ',(a0)+
	dbra	d0,tfrtitle2
tfrtitle9:
	move.b	#' ',(a0)+
	move.b	#' ',(a0)+
	rts

pageff_msg::	.dc.b	FF,0
page_msg:	.dc.b	'Page ',0
sym_msg:	.dc.b	'Symbols-',0
month_name:	.dc.b	'JanFebMarAprMayJunJulAugSepOctNovDec'
	.even

;----------------------------------------------------------------
;	PRNt@Cy[WOp̓쐬
;	in :---
;	out:---
makeprndate::
	DOS	_GETDATE
	move.l	d0,(ASSEMBLEDATE,a6)	;(j(0=)<<16)+((N-1980)<<9)+(<<5)+
	DOS	_GETTIM2
	move.l	d0,(ASSEMBLETIM2,a6)	;(<<16)+(<<8)+b

	lea.l	(PRNDATE,a6),a0
	move.l	(ASSEMBLEDATE,a6),d0
	move.w	d0,d2
	lsr.w	#5,d0
	and.w	#$0F,d0			;
	mulu.w	#3,d0
	lea.l	(month_name-3,pc,d0.w),a1
	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a0)+
	move.b	#'/',(a0)+
	move.w	d2,d0
	and.w	#$1F,d0			;
	bsr	makeprndec
	move.b	#'/',(a0)+
	move.w	d2,d0
	rol.w	#7,d0
	and.w	#$7F,d0			;N
	add.w	#1980,d0
	bsr	makeprndec
	move.b	#' ',(a0)+
	move.l	(ASSEMBLETIM2,a6),d0
	move.w	d0,d2
	swap.w	d0
	and.w	#$1F,d0			;
	bsr	makeprndec
	move.b	#':',(a0)+
	move.w	d2,d0
	lsr.w	#8,d0
	and.w	#$3F,d0			;
	bsr	makeprndec
	move.b	#':',(a0)+
	move.w	d2,d0
	and.w	#$3F,d0			;b
	bsr	makeprndec
	clr.b	(a0)
	rts

makeprndec:				;d0.w10i2̕ɕϊ
	ext.l	d0
	moveq.l	#-2,d1			;(2Ń[TvXȂ)
	bra	convdec

crlf_msg:	.dc.b	CRLF,0
	.even

;----------------------------------------------------------------
;	_f[^𓾂
;	in :d0.b=f[^^
;	out:d1.w=f[^(O[h)-1
getfplen::
	ext.w	d0
	bpl	getfplen1
	moveq.l	#SZ_EXTEND,d0		;TCYȗ.x
getfplen1:
	moveq.l	#0,d1
	move.b	(fsize_tbl,pc,d0.w),d1
	rts

fsize_tbl:
	.dc.b	-1,-1,-1		;(.b/.w/.l)
	.dc.b	(1-1),(2-1),(3-1),(3-1)	;.s/.d/.x/.p
	.even


;----------------------------------------------------------------
	.end

;----------------------------------------------------------------
;	$Log: misc.s,v $
;	Revision 2.1  1999 10/ 8(Fri) 21:50:20 M.Kamada
;	+86 sR[h̕ύXɑΉ
;	+86 EUCΉ
;
;	Revision 2.0  1999  3/ 2(Tue) 20:19:49 M.Kamada
;	+82 skiphasspcp~
;
;	Revision 1.9  1999  2/27(Sat) 23:43:05 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 1.8  1999  2/24(Wed) 19:44:39 M.Kamada
;	+80 .offsym <l>,<V{>
;
;	Revision 1.7  1998  7/14(Tue) 02:03:58 M.Kamada
;	+69 getfplenAhXɂ
;
;	Revision 1.6  1998  5/25(Mon) 01:58:08 M.Kamada
;	+66 encode.smisc.sgetfplen͂Ȃ
;
;	Revision 1.5  1998  5/14(Thu) 16:03:12 M.Kamada
;	+65 hasŃAZułȂ
;
;	Revision 1.4  1997 10/29(Wed) 21:23:10 M.Kamada
;	+52 crlf_msg
;
;	Revision 1.3  1997  9/14(Sun) 16:06:33 M.Kamada
;	+45 l16iϊ
;
;	Revision 1.2  1997  6/25(Wed) 02:35:32 M.Kamada
;	+34 vft@CV{__DATE__,__TIME__ɑΉ
;	+37 -up,-dpŃvft@CV{̋֎~,
;
;	Revision 1.1  1994/02/16  15:44:18  nakamura
;	Initial revision
;
;
