;----------------------------------------------------------------
;	X68k High-speed Assembler
;		pX2(OQƂ̍œK)
;		< optimize.s >
;
;	$Id: optimize.s,v 2.5  1999  3/ 2(Tue) 17:04:08 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;		          1996-99  by M.Kamada
;----------------------------------------------------------------

	.include	has.equ
	.include	symbol.equ
	.include	register.equ
	.include	tmpcode.equ
	.include	cputype.equ
	.include	eamode.equ
	.include	error2.equ

	.cpu	68000
	.text


;----------------------------------------------------------------
;	pX2(OQƂ̍œK)
;----------------------------------------------------------------
asmpass2::
	move.b	#2,(ASMPASS,a6)
	tst.b	(OPTIMIZE,a6)
	bne	asmpass29		;/n̎w肪̂ŉȂ

	clr.b	(OPTCOUNT,a6)
	move.b	#SZ_LONG|ESZ_OPT,(OPTMOREFLG,a6)
asmpass21:
	move.l	(CPUSYMBOL,a6),d0
	beq	asmpass219
	movea.l	d0,a1
	move.l	(STARTCPU,a6),(SYM_VALUE,a1)
asmpass219:
	addq.b	#1,(OPTCOUNT,a6)
	sf.b	(OPTFLAG,a6)
	lea.l	(TEMPFILPTR,a6),a1
	bsr	frewind			;e|t@C擪Ɉړ
	bsr	resetlocctr		;P[VJE^̏

	suba.l	a5,a5			;(LOCATION,a6)
	suba.l	a4,a4			;(LOCOFFSET,a6)
	bsr	dopass2			;œKs
	move.l	a5,(LOCATION,a6)
	move.l	a4,(LOCOFFSET,a6)
	moveq.l	#SECT_TEXT,d0
	bsr	chgsection		;textZNVɖ߂
	move.b	#SZ_LONG,(OPTMOREFLG,a6)
	tst.b	(OPTFLAG,a6)
	bne	asmpass21
asmpass29:
	rts

;----------------------------------------------------------------
dopass2:
	bsr	tmpreadd0w
	move.w	d0,d1
	beq	dopass29		;e|t@CI
dopass21:
	clr.b	d1
	sub.w	d1,d0
	ror.w	#6,d1
	jsr	(pass2_tbl-4,pc,d1.w)
	bsr	tmpreadd0w
	move.w	d0,d1
	bne	dopass21
dopass29:
	rts

;----------------------------------------------------------------
;	e|t@CR[hAhX
pass2_tbl:
	bra.w	linetop		;01	1sJn
	bra.w	symdata		;02	V{l
	bra.w	rpndata		;03	t|[h

	bra.w	dispadr		;04	(d,An)
	bra.w	disppc		;05	(d,PC)
	bra.w	indexadr	;06	(d,An,Rn)
	bra.w	indexpc		;07	(d,PC,Rn)
	bra.w	extcode		;08	g[h
	bra.w	bdadr		;09	AhXWX^Ԑڃx[XfBXv[Xg
	bra.w	bdpc		;0A	PCԐڃx[XfBXv[Xg
	bra.w	odisp		;0B	AE^fBXv[Xg

	bra.w	bracmd		;0C	bra/bsr/b<cc>.s/.w/.l
	bra.w	cpbracmd	;0D	cpb<cc>.w/.l
	bra.w	dspcode		;0E	(d,An)/(d,PC)̖߃R[h
	bra.w	coderpn		;0F	߃R[hߍݎf[^
	bra.w	constdata	;10	AhXˑf[^
	bra.w	bitfield	;11	rbgtB[hf[^
	bra.w	dscmd		;12	.ds
	bra.w	dcbcmd		;13	.dcb
	bra.w	aligncmd	;14	ACg̒
	bra.w	sectchg		;15	ZNVύX
	bra.w	ofstcmd		;16	.offset
	bra.w	equconst	;17	萔.equ/.set
	bra.w	equexpr		;18	EAhX.equ/.set
	bra.w	xdefcmd		;19	.xdef
	bra.w	prnctrl		;1A	Xgo͐
	bra.w	pagecmd		;1B	.page
	bra.w	subttlcmd	;1C	.subttl
	bra.w	orgcmd		;1D	.org
	bra.w	endcmd		;1E	.end
	bra.w	incldopen	;1F	includet@CJn
	bra.w	incldend	;20	includet@CI
	bra.w	macdef		;21	}N`Jn
	bra.w	macext		;22	}NWJJn
	bra.w	exitmcmd	;23	.exitm
	bra.w	reptcmd		;24	.reptWJJn
	bra.w	irpcmd		;25	.irp/.irpcWJJn
	bra.w	mdefbgn		;26	}N`Jn
	bra.w	mdefend		;27	}N`I
	bra.w	lncmd		;28	.ln
	bra.w	valcmd		;29	.val
	bra.w	tagcmd		;2A	.tag
	bra.w	scdshort	;2B	.endef(Z`)
	bra.w	scdlong		;2C	.endef(`)
	bra.w	funcend		;2D	.scl -1(֐`I)

	bra.w	fequset		;2E	.fequ/.fset
	bra.w	symdef		;2F	V{`
	bra.w	fdcbcmd		;30	.dcb(_)
	bra.w	jbracmd		;31	jbra/jbsr/jb<cc>
	bra.w	dispopc		;32	(d,OPC)
	bra.w	linkcmd		;33	link.w/.l

	bra.w	nopdeath	;34	폜ׂNOP
	bra.w	nopalive	;35	}ꂽNOP

	bra.w	prnadv		;36	PRNt@Cւ̐so

	bra.w	offsymcmd	;37	.offsym

	bra.w	error		;38	G[

	bra.w	cpucmd		;39	.cpu

.ifdef	DO_CDTOR
	bra.w	ctorcmd		;3a	.ctor
	bra	dtorcmd		;3b	.dtor
.endif	/* DO_CDTOR */

;----------------------------------------------------------------
cpucmd:					;39xx .cpu
	bsr	tmpreadd0w
	move	d0,(CPUTYPE,a6)
	rts

;----------------------------------------------------------------
nopdeath:				;34xx 폜ׂNOP
	GETFPTR	TEMPFILPTR,d3		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w		;NOP
	cmp.w	#$4E71,d0
	beq	nopdeath_nul
	rts

nopdeath_nul:
;NOP͏ł̂ŃP[VJE^𑝂₳ȂĂ悢
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#2,a4			;œKɂČoCg
	clr.w	d0
	move.l	d3,d1
	bra	fmodify

nopalive:
	bra	constdata

;----------------------------------------------------------------
prnctrl:				;1Axx Xgo͐
pagecmd:				;1Bxx .page
incldend:				;20xx includet@CI
exitmcmd:				;23xx .exitm
mdefbgn:				;26xx }N`Jn
mdefend:				;27xx }N`I
funcend:				;2Dxx .scl -1(֐`I)
prnadv:					;36xx PRNt@Cւ̐so
	rts				;Ȃ

;----------------------------------------------------------------
detequ:					;17xx l̊m肵Ă.equ
xdefcmd:				;19xx .xdef
subttlcmd:				;1Cxx .subttl
incldopen:				;1Fxx includet@CJn
tagcmd:					;2Axx .tag
error:					;38xx G[
	moveq.l	#2*2,d0
	bra	tempskip		;2[hǂݔ΂

;----------------------------------------------------------------
macext:					;22xx }NWJJn
reptcmd:				;24xx .reptWJJn
	moveq.l	#3*2,d0
	bra	tempskip		;3[hǂݔ΂

;----------------------------------------------------------------
macdef:					;21xx }N`Jn
	moveq.l	#4*2,d0
	bra	tempskip		;4[hǂݔ΂

;----------------------------------------------------------------
irpcmd:					;25xx .irp/.irpcWJJn
	moveq.l	#5*2,d0
	bra	tempskip		;5[hǂݔ΂

;----------------------------------------------------------------
scdshort:				;2Bxx .endef(Z`)
	moveq.l	#6*2,d0
	bra	tempskip		;6[hǂݔ΂

;----------------------------------------------------------------
fequset:				;2Exx .fequ/.fset
	moveq.l	#8*2,d0
	bra	tempskip		;8[hǂݔ΂

;----------------------------------------------------------------
scdlong:				;2Cxx .endef(`)
	moveq.l	#12*2,d0
	bra	tempskip		;12[hǂݔ΂

;----------------------------------------------------------------
linetop:				;01xx sJnR[h
	move.l	a5,(LTOPLOC,a6)
	rts

;----------------------------------------------------------------
symdata:				;02xx V{l
	bsr	getdtsize
	add.l	d0,a5
	moveq.l	#2*2,d0
	bra	tempskip

;----------------------------------------------------------------
rpndata:				;03xx t|[h
	bsr	getdtsize
	add.l	d0,a5
rpndata1:
	bsr	tmpreadd0w
	addq.w	#1,d0
	add.w	d0,d0
	bra	tempskip		;ǂݔ΂

;----------------------------------------------------------------
lncmd:					;28xx .ln
	moveq.l	#1*2,d0
	bsr	tempskip		;߃R[hǂݔ΂
;	bra	skipexpr

;----------------------------------------------------------------
endcmd:					;1Exx .end
valcmd:					;29xx .val
.ifdef	DO_CDTOR
ctorcmd:				;3600 .ctor
dtorcmd:				;3700 .dtor
.endif	/* DO_CDTOR */
skipexpr:				;㑱̃V{l/ǂݔ΂
	bsr	tmpreadd0w
skipexpr1:
	and.w	#$FF00,d0
	cmp.w	#T_SYMBOL,d0
	bne	rpndata1		;ꍇ
	moveq.l	#2*2,d0			;V{lꍇ
	bra	tempskip

;----------------------------------------------------------------
constdata:				;10xx AhXˑf[^
	addq.w	#1,d0
	ext.l	d0
	add.l	d0,a5
	addq.w	#1,d0
	bclr.l	#0,d0
	bra	tempskip		;Ƃɑf[^ǂݔ΂

;----------------------------------------------------------------
bitfield:				;11xx rbgtB[hf[^
	move.w	d0,d1
	addq.l	#2,a5
	moveq.l	#1*2,d0
	bsr	tempskip		;߃R[hǂݔ΂
	cmp.b	#TBF_OFWD,d1
	bne	skipexpr		;㑱̎1̏ꍇ
	bsr	skipexpr
	bra	skipexpr

;----------------------------------------------------------------
dscmd:					;12xx .ds
	bsr	tmpreadd0l		;ǂݏo
	add.l	d0,a5
	rts

;----------------------------------------------------------------
dcbcmd:					;13xx .dcb
	bsr	tmpreadd0w		;ǂݏo
	move.w	d0,d1
	bsr	tmpreadd0w
	move.w	d0,d2
	bsr	getdtsize
	addq.w	#1,d1
	mulu.w	d0,d1			;f[^̃TCY
	add.l	d1,a5
	move.w	d2,d0
	bra	skipexpr1

;----------------------------------------------------------------
fdcbcmd:				;30xx .dcb(_)
	move.w	d0,d1			;f[^
	bsr	tmpreadd0w		;ǂݏo
	ext.l	d0
	addq.l	#1,d0
	add.l	d0,d0
	add.l	d0,d0
	moveq.l	#0,d2
fdcbcmd1:
	add.l	d0,d2
	dbra	d1,fdcbcmd1
	add.l	d2,a5
	moveq.l	#6*2,d0
	bra	tempskip		;6[hǂݔ΂

;----------------------------------------------------------------
symdef:					;2Fxx V{`
	bsr	tmpreadd0l		;V{ւ̃|C^
	move.l	d0,a0
	move.l	(LTOPLOC,a6),(SYM_VALUE,a0)
	move.b	(OPTCOUNT,a6),(SYM_OPTCOUNT,a0)
	rts

;----------------------------------------------------------------
equconst:				;17xx 萔.equ/.set
	bsr	tmpreadd0l		;V{ւ̃|C^
	move.l	d0,a0
	bsr	tmpreadd0l		;V{l
	move.l	d0,(SYM_VALUE,a0)
	clr.w	(SYM_SECTION,a0)	;(SYM_ORGNUM)
	move.b	#SA_DEFINE,(SYM_ATTRIB,a0)
	rts

;----------------------------------------------------------------
equexpr:				;18xx EAhX.equ/.set
	bsr	tmpreadd0l		;V{ւ̃|C^
	move.l	d0,a0
	bsr	tmpreadd0w
	bsr	calctmpexpr		;㑱̎̒l𓾂
	cmp.w	#$00FF,d0
	bcc	equexpr9		;V{lm肵Ȃ
	move.b	d0,(SYM_SECTION,a0)
	move.l	d1,(SYM_VALUE,a0)
	move.b	#SA_DEFINE,(SYM_ATTRIB,a0)
	move.b	(OPTCOUNT,a6),(SYM_OPTCOUNT,a0)
equexpr9:
	rts

;----------------------------------------------------------------
aligncmd:				;14xx ACg̒
	moveq.l	#1,d1
	lsl.l	d0,d1
	subq.l	#1,d1			;d1=2^d0 - 1
	move.l	a5,d2
	move.l	d2,d3
	add.l	d1,d2
	not.l	d1
	and.l	d1,d2
	movea.l	d2,a5
	sub.l	d3,d2
	bsr	tmpreadd0w		;pfBO[h͓ǂݔ΂
	GETFPTR	TEMPFILPTR,d1		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w		;ÕpfBOǂݏo
	sub.w	d2,d0			;œKɂČoCg
	adda.w	d0,a4
	move.w	d2,d0
	bra	fmodify			;P[VJE^lC

;----------------------------------------------------------------
sectchg:				;15xx ZNVύX
;offsymŃV{Ȃ̂Ƃ0ɂȂĂ܂
;pX2ȍ~ł͓d`G[͏oȂ͂Ȃ̂Ŗ
	sf.b	(OFFSYMMOD,a6)
	move.l	a5,(LOCATION,a6)
	move.l	a4,(LOCOFFSET,a6)
	bsr	chgsection
	movea.l	(LOCATION,a6),a5
	movea.l	(LOCOFFSET,a6),a4
	rts

;----------------------------------------------------------------
offsymcmd:				;37xx .offsym
	move.l	a5,(LOCATION,a6)
	move.l	a4,(LOCOFFSET,a6)
	moveq.l	#0,d0
	bsr	chgsection
	bsr	tmpreadd0l		;lǂݏo
	move.l	d0,(OFFSYMVAL,a6)
	bsr	tmpreadd0l		;V{ǂݏo
	move.l	d0,(OFFSYMSYM,a6)
	bsr	tmpreadd0l		;V{ǂݏo
	move.l	d0,(OFFSYMTMP,a6)
	move.b	#1,(OFFSYMMOD,a6)	;offsymŃV{
	suba.l	a5,a5
	suba.l	a4,a4
	rts

;----------------------------------------------------------------
ofstcmd:				;16xx .offset
	move.l	a5,(LOCATION,a6)
	move.l	a4,(LOCOFFSET,a6)
	moveq.l	#0,d0
	bsr	chgsection
	bsr	tmpreadd0l		;ItZbglǂݏo
	move.l	d0,a5
	suba.l	a4,a4
	rts

;----------------------------------------------------------------
orgcmd:					;1Dxx .org
	bsr	tmpreadd0l		;P[VJE^lǂݏo
	move.l	d0,a5
	suba.l	a4,a4
	addq.b	#1,(ORGNUM,a6)
	rts

;----------------------------------------------------------------
extcode:				;08xx g[h
	addq.l	#2,a5
	GETFPTR	TEMPFILPTR,d0		;݂̃t@C|C^ʒu𓾂
	move.l	d0,(OPTEXTPOS,a6)
	bsr	tmpreadd0w		;g[hǂݏo
	move.w	d0,(OPTEXTCODE,a6)
	rts

;----------------------------------------------------------------
dspcode:				;0Exx (d,An)/(d,PC)̖߃R[h
	addq.l	#2,a5
	GETFPTR	TEMPFILPTR,d0		;݂̃t@C|C^ʒu𓾂
	move.l	d0,(OPTDSPPOS,a6)
	bsr	tmpreadd0w		;߃R[hǂݏo
	move.w	d0,(OPTDSPCODE,a6)
	rts

;----------------------------------------------------------------
coderpn:				;0Fxx ߃R[hߍݎf[^
	addq.l	#2,a5
	GETFPTR	TEMPFILPTR,d0		;݂̃t@C|C^ʒu𓾂
	move.l	d0,(OPTDSPPOS,a6)
	bsr	tmpreadd0w		;߃R[hǂݏo
	move.w	d0,(OPTDSPCODE,a6)
	bra	skipexpr

;----------------------------------------------------------------
dispadr:				;04xx (d,An)
	move.b	d0,d5			;(movefXeBl[VȂtrue)
	GETFPTR	TEMPFILPTR,d3		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w
	move.w	d0,d2
	tst.b	d0
	bmi	dispadr5		;œKΏۃR[h̏ꍇ
	beq	skipexpr1		;(fBXv[Xg̓TvXĂ)
	bsr	skipexpr1		;œKΏۂłȂ̂Ō㑱̎ǂݔ΂
dispadr1:
	cmpi.b	#SZ_WORD,d2
	bne	dispadr2
	addq.l	#2,a5			;fBXv[XgTCY.w̏ꍇ
	rts

dispadr2:
	addq.l	#6,a5			;			     .l̏ꍇ
dispadr9:
	rts

dispadr8:				;œKłȂꍇ
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	bra	dispadr1

dispadr5:				;œKΏۃR[h
	bsr	calctmpexpr		;㑱̎̒lvZ
	tst.b	d0
	beq	dispadr6
	cmp.b	#SECT_RDATA,d0
	bcc	dispadr8		;萔łȂꍇ͍œKłȂ
	bra	dispadr5_l

dispadr6:
	move.l	d1,d0			;(tst.l d1 & move.w d1,d0)
	beq	dispadr5_nul
	bra68	d4,dispadr5_w		;68000/68010Ȃ0łȂ.w
	tst.b	(CPUTYPE2,a6)
	bne	dispadr5_w
	ext.l	d0
	cmp.l	d0,d1
	beq	dispadr5_w
dispadr5_l:
	addq.l	#6,a5
	cmp.b	#SZ_LONG|ESZ_OPT,d2
	beq	dispadr9		;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	subq.l	#4,a4			;(.w.l̂)
	move.w	d2,d0
	move.b	(OPTMOREFLG,a6),d0	;(ŏ̂ESZ_OPT)
	move.l	d3,d1
	bsr	fmodify
	move.w	(OPTDSPCODE,a6),d0	;(d,An)(bd,An)̕ύXs
	move.l	(OPTDSPPOS,a6),d1
	tst.b	d5
	bne	dispadr5_l1
	and.w	#.not.$0038,d0
	or.w	#EAC_BDADR,d0
	move.w	d0,(OPTDSPCODE,a6)
	bra	fmodify

dispadr5_l1:				;movẽfXeBl[VAhX
	and.w	#.not.$01C0,d0
	or.w	#EAC_BDADR<<3,d0
	bra	fmodify

dispadr5_w:
	addq.l	#2,a5
	moveq.l	#SZ_WORD|ESZ_OPT,d0
	cmp.b	d0,d2
	beq	dispadr9		;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#4,a4			;(.l.ŵ)
	move.b	d0,d2			;(ŐLтꍇ)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	move.w	(OPTDSPCODE,a6),d0	;(bd,An)(d,An)̕ύXs
	move.l	(OPTDSPPOS,a6),d1
	tst.b	d5
	bne	dispadr5_w1
	and.w	#.not.$0038,d0
	or.w	#EAC_DSPADR,d0
	move.w	d0,(OPTDSPCODE,a6)
	bra	fmodify

dispadr5_w1:				;movẽfXeBl[VAhX
	and.w	#.not.$01C0,d0
	or.w	#EAC_DSPADR<<3,d0
	bra	fmodify

dispadr5_nul:
	tst.b	(NONULDISP,a6)
	bne	dispadr5_w
	st.b	(OPTFLAG,a6)		;œKsꂽ
	cmp.b	#SZ_WORD|ESZ_OPT,d2
	beq	dispadr5_nul1
	addq.l	#6,a4			;.l0̏ꍇ
	bra	dispadr5_nul2

dispadr5_nul1:
	addq.l	#2,a4			;.w0̏ꍇ
dispadr5_nul2:
	move.w	d2,d0
	clr.b	d0			;fBXv[XgTvXm
	move.l	d3,d1
	bsr	fmodify
	move.w	(OPTDSPCODE,a6),d0	;(bd,An)/(d,An)(An)̕ύXs
	move.l	(OPTDSPPOS,a6),d1
	tst.b	d5
	bne	dispadr5_nul5
	and.w	#.not.$0038,d0
	or.w	#EAC_ADR,d0
	move.w	d0,(OPTDSPCODE,a6)
	bra	fmodify

dispadr5_nul5:				;movẽfXeBl[VAhX
	and.w	#.not.$01C0,d0
	or.w	#EAC_ADR<<3,d0
	bra	fmodify

;----------------------------------------------------------------
disppc:					;05xx (d,PC)
	GETFPTR	TEMPFILPTR,d3		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w
	move.w	d0,d2
	tst.b	d0
	bmi	disppc5			;œKΏۃR[h̏ꍇ
	bsr	skipexpr1		;œKΏۂłȂ̂Ō㑱̎ǂݔ΂
disppc1:
	cmpi.b	#SZ_WORD,d2
	bne	disppc2
	addq.l	#2,a5			;fBXv[XgTCY.w̏ꍇ
	rts

disppc2:
	addq.l	#6,a5			;			     .l̏ꍇ
disppc9:
	rts

disppc8:				;œKłȂꍇ
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	bra	disppc1

disppc5:				;œKΏۃR[h
	bsr	calctmpexpr		;㑱̎̒lvZ
	tst.b	d0
	bmi	disppc8			;lȂ̂ōœKłȂ
	bne	disppc6
	move.w	d1,d0			;萔̏ꍇ
	ext.l	d0
	cmp.l	d0,d1
	beq	disppc5_w
	bra	disppc5_l

disppc6:				;AhXl̏ꍇ
	cmp.b	(SECTION,a6),d0
	bne	disppc8			;ZNVႤ̂ōœKłȂ
	sub.l	a5,d1			;݂̃AhX̑Βl
	move.w	d1,d0
	ext.l	d0
	cmp.l	d0,d1
	beq	disppc5_w
	cmp.b	#SZ_WORD|ESZ_OPT,d2
	beq	disppc5_l		;$8000ȏȂ.w.l
	cmp.l	#$8004,d1
	bcs	disppc5_w		;$8004Ȃ.l.w
	addq.l	#6,a5
	rts

disppc5_l:
	addq.l	#6,a5
	cmp.b	#SZ_LONG|ESZ_OPT,d2
	beq	disppc9			;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	subq.l	#4,a4			;(.w.l̂)
	move.w	d2,d0
	move.b	(OPTMOREFLG,a6),d0	;(ŏ̂ESZ_OPT)
	move.l	d3,d1
	bsr	fmodify
	move.w	(OPTDSPCODE,a6),d0	;(d,PC)(bd,PC)̕ύXs
	move.l	(OPTDSPPOS,a6),d1
	and.w	#.not.$003F,d0
	or.w	#EAC_BDPC,d0
	bra	fmodify

disppc5_w:
	addq.l	#2,a5
	moveq.l	#SZ_WORD|ESZ_OPT,d0
	cmp.b	d0,d2
	beq	disppc9			;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#4,a4			;(.l.ŵ)
	move.b	d0,d2			;(ŐLтꍇ)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	move.w	(OPTDSPCODE,a6),d0	;(bd,An)(d,An)̕ύXs
	move.l	(OPTDSPPOS,a6),d1
	and.w	#.not.$003F,d0
	or.w	#EAC_DSPPC,d0
	bra	fmodify

;----------------------------------------------------------------
dispopc:				;32xx (d,OPC)
	GETFPTR	TEMPFILPTR,d3		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w
	move.w	d0,d2
	tst.b	d0
	bmi	dispopc5		;œKΏۃR[h̏ꍇ
	bsr	skipexpr1		;œKΏۂłȂ̂Ō㑱̎ǂݔ΂
dispopc1:
	cmpi.b	#SZ_WORD,d2
	bne	dispopc2
	addq.l	#2,a5			;fBXv[XgTCY.w̏ꍇ
	rts

dispopc2:
	addq.l	#4,a5			;-2			     .l̏ꍇ
dispopc9:
	rts

dispopc8:				;œKłȂꍇ
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	bra	dispopc1

dispopc5:				;œKΏۃR[h
	bsr	calctmpexpr		;㑱̎̒lvZ
	tst.b	d0
	bmi	dispopc8		;lȂ̂ōœKłȂ
	bne	dispopc6
	move.w	d1,d0			;萔̏ꍇ
	ext.l	d0
	cmp.l	d0,d1
	beq	dispopc5_w
	bra	dispopc5_l

dispopc6:				;AhXl̏ꍇ
	cmp.b	(SECTION,a6),d0
	bne	dispopc8		;ZNVႤ̂ōœKłȂ
	sub.l	a5,d1			;݂̃AhX̑Βl
	move.w	d1,d0
	ext.l	d0
	cmp.l	d0,d1
	beq	dispopc5_w
	cmp.b	#SZ_WORD|ESZ_OPT,d2
	beq	dispopc5_l		;$8000ȏȂ.w.l
	cmp.l	#$8002,d1		;-2
	bcs	dispopc5_w		;$8002Ȃ.l.w
	addq.l	#4,a5			;-2
	rts

dispopc5_l:
	addq.l	#4,a5			;-2
	cmp.b	#SZ_LONG|ESZ_OPT,d2
	beq	dispopc9		;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	subq.l	#2,a4			;-2(.w.l̂)
	move.w	d2,d0
	move.b	(OPTMOREFLG,a6),d0	;(ŏ̂ESZ_OPT)
	move.l	d3,d1
	bsr	fmodify
	move.w	(OPTDSPCODE,a6),d0	;(d,PC)xxxx.l̕ύXs
	move.l	(OPTDSPPOS,a6),d1
	and.w	#.not.$003F,d0
	or.w	#EAC_ABSL,d0		;-2
	bra	fmodify

dispopc5_w:
	addq.l	#2,a5
	moveq.l	#SZ_WORD|ESZ_OPT,d0
	cmp.b	d0,d2
	beq	dispopc9		;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#2,a4			;-2(.l.ŵ)
	move.b	d0,d2			;(ŐLтꍇ)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	move.w	(OPTDSPCODE,a6),d0	;(bd,An)(d,An)̕ύXs
	move.l	(OPTDSPPOS,a6),d1
	and.w	#.not.$003F,d0
	or.w	#EAC_DSPPC,d0
	bra	fmodify

;----------------------------------------------------------------
indexadr:				;06xx (d,An,Rn)
	bsr	tmpreadd0w		;g[h͓ǂݔ΂(pass 3ŕύX)
	GETFPTR	TEMPFILPTR,d3		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w
	move.w	d0,d2
	tst.b	d0
	bmi	indexadr5		;œKΏۃR[h̏ꍇ
indexadr0:
	bsr	skipexpr1		;œKΏۂłȂ̂Ō㑱̎ǂݔ΂
indexadr1:
	ext.w	d2
	move.b	(indexadr_tbl,pc,d2.w),d2
	adda.w	d2,a5
indexadr9:
	rts

indexadr_tbl:	.dc.b	-1,4,6,2

indexadr8:				;œKłȂꍇ
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	bra	indexadr1

indexadr5:				;œKΏۃR[h
	bsr	calctmpexpr		;㑱̎̒lvZ
	tst.b	d0
	beq	indexadr6
	cmp.b	#SECT_RDATA,d0
	bcc	indexadr8		;萔łȂꍇ͍œKłȂ
	bra	indexadr5_l

indexadr6:				;萔̏ꍇ
	move.b	d1,d0
	ext.w	d0
	ext.l	d0
	cmp.l	d0,d1
	beq	indexadr5_s
	move.w	d1,d0
	ext.l	d0
	cmp.l	d0,d1
	beq	indexadr5_w
indexadr5_l:
	addq.l	#6,a5
	cmp.b	#SZ_LONG|ESZ_OPT,d2
	beq	indexadr9		;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	subq.l	#2,a4			;.w.l
	cmp.b	#SZ_WORD|ESZ_OPT,d2
	beq	indexdar5_l1
	subq.l	#2,a4			;.s.l
indexdar5_l1:
	move.w	d2,d0
	move.b	(OPTMOREFLG,a6),d0	;(ŏ̂ESZ_OPT)
	move.l	d3,d1
	bra	fmodify

indexadr5_w:
	addq.l	#4,a5
	move.w	d2,d0
	move.l	d3,d1
	cmp.b	#SZ_WORD|ESZ_OPT,d2
	beq	indexadr9		;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	cmp.b	#SZ_LONG|ESZ_OPT,d2
	beq	indexadr5_w1
	subq.l	#2,a4			;.s.w̏ꍇ
	move.b	#SZ_WORD,d0		;(TCYLтĂ܂ꍇ͂ȏœKȂ)
	tst.b	(OPTMOREFLG,a6)
	bpl	fmodify
	move.b	#SZ_WORD|ESZ_OPT,d0	;ŏ1Ȃ炳ɍœKł
	bra	fmodify

indexadr5_w1:
	addq.l	#2,a4			;.l.w̏ꍇ
	move.b	#SZ_WORD|ESZ_OPT,d0	;(ŐLтꍇ)
	bra	fmodify

indexadr5_s:
	addq.l	#2,a5
	cmp.b	#SZ_SHORT|ESZ_OPT,d2
	beq	indexadr9		;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	move.b	d2,d0
	bsr	getdtsize
	add.l	d0,a4
	move.w	d2,d0
	move.b	#SZ_SHORT|ESZ_OPT,d0	;(ŐLтꍇ)
	move.l	d3,d1
	bra	fmodify

;----------------------------------------------------------------
indexpc:				;07xx (d,PC,Rn)
	bsr	tmpreadd0w		;g[h͓ǂݔ΂(pass 3ŕύX)
	GETFPTR	TEMPFILPTR,d3		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w
	move.w	d0,d2
	tst.b	d0
	bpl	indexadr0
	bsr	calctmpexpr		;㑱̎̒lvZ
	tst.b	d0
	bmi	indexadr8		;萔łȂꍇ͍œKłȂ
	beq	indexadr6		;萔̏ꍇ
	cmp.b	(SECTION,a6),d0		;AhXl̏ꍇ
	bne	indexadr8		;ZNVႤ̂ōœKłȂ
	sub.l	a5,d1			;݂̃AhX̑Βl
	move.b	d1,d0
	ext.w	d0
	ext.l	d0
	cmp.l	d0,d1
	beq	indexadr5_s
	move.b	d2,d4
	and.b	#3,d4
	ext.w	d4
	moveq.l	#0,d0
	move.b	(indexpc_tbl1,pc,d4.w),d0
	cmp.l	d0,d1
	bcs	indexadr5_s		;$82Ȃ.w.s / $84Ȃ.l.s
	cmp.l	#-$8000,d1
	blt	indexadr5_l
	add.w	d4,d4
	move.w	(indexpc_tbl2,pc,d4.w),d0
	cmp.l	d0,d1
	blt	indexadr5_w		;$7FFEȂ.s.w / $8002Ȃ.l.w
	bra	indexadr5_l

indexpc_tbl1:	.dc.b	-1,$82,$84,$80
indexpc_tbl2:	.dc.w	-1,$8002,$8000,$7FFE

;----------------------------------------------------------------
odisp:					;0Bxx AE^fBXv[Xg
	moveq.l	#$0003,d5
	bra	bdodadr

;----------------------------------------------------------------
bdadr:					;09xx AhXWX^Ԑڃx[XfBXv[Xg
	moveq.l	#$0030,d5
bdodadr:
	GETFPTR	TEMPFILPTR,d3		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w
	move.w	d0,d2
	tst.b	d0
	bmi	bdodadr5		;œKΏۃR[h̏ꍇ
	beq	skipexpr1		;(fBXv[Xg̓TvXĂ)
	bsr	skipexpr1		;œKΏۂłȂ̂Ō㑱̎ǂݔ΂
bdodadr1:
	cmpi.b	#SZ_WORD,d2
	bne	bdodadr2
	addq.l	#2,a5			;fBXv[XgTCY.w̏ꍇ
	rts

bdodadr2:
	addq.l	#4,a5			;			     .l̏ꍇ
bdodadr9:
	rts

bdodadr8:				;œKłȂꍇ
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	bra	bdodadr1

bdodadr5:				;œKΏۃR[h
	bsr	calctmpexpr		;㑱̎̒lvZ
	tst.b	d0
	beq	bdodadr6
	cmp.b	#SECT_RDATA,d0
	bcc	bdodadr8		;萔łȂꍇ͍œKłȂ
	bra	bdodadr5_l

bdodadr6:				;萔̏ꍇ
	move.l	d1,d0			;(tst.l d1 & move.w d1,d0)
	beq	bdodadr5_nul
	ext.l	d0
	cmp.l	d0,d1
	beq	bdodadr5_w
bdodadr5_l:
	addq.l	#4,a5
	cmp.b	#SZ_LONG|ESZ_OPT,d2
	beq	bdodadr9		;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	subq.l	#2,a4			;(.w.l̂)
	move.w	d2,d0
	move.b	(OPTMOREFLG,a6),d0	;(ŏ̂ESZ_OPT)
	move.l	d3,d1
	bsr	fmodify
	move.w	(OPTEXTCODE,a6),d0	;g[h̕ύXs
	move.l	(OPTEXTPOS,a6),d1
	move.w	#EXW_BDL|EXW_ODL,d2
	and.w	d5,d2
	not.w	d5
	and.w	d5,d0
	or.w	d2,d0
	move.w	d0,(OPTEXTCODE,a6)
	bra	fmodify

bdodadr5_w:
	addq.l	#2,a5
	moveq.l	#SZ_WORD|ESZ_OPT,d0
	cmp.b	d0,d2
	beq	bdodadr9		;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#2,a4			;(.l.ŵ)
	move.b	d0,d2			;(ŐLтꍇ)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	move.w	(OPTEXTCODE,a6),d0	;g[h̕ύXs
	move.l	(OPTEXTPOS,a6),d1
	move.w	#EXW_BDW|EXW_ODW,d2
	and.w	d5,d2
	not.w	d5
	and.w	d5,d0
	or.w	d2,d0
	move.w	d0,(OPTEXTCODE,a6)
	bra	fmodify

bdodadr5_nul:
	tst.b	(NONULDISP,a6)
	bne	bdodadr5_w
	st.b	(OPTFLAG,a6)		;œKsꂽ
	move.b	d2,d0
	bsr	getdtsize
	add.l	d0,a4
	move.w	d2,d0
	clr.b	d0			;fBXv[XgTvXm
	move.l	d3,d1
	bsr	fmodify
	move.w	(OPTEXTCODE,a6),d0	;g[h̕ύXs
	move.l	(OPTEXTPOS,a6),d1
	move.w	#EXW_BDNUL|EXW_ODNUL,d2
	and.w	d5,d2
	not.w	d5
	and.w	d5,d0
	or.w	d2,d0
	move.w	d0,(OPTEXTCODE,a6)
	bra	fmodify

;----------------------------------------------------------------
bdpc:					;0Axx PCԐڃx[XfBXv[Xg
	moveq.l	#$0030,d5
	GETFPTR	TEMPFILPTR,d3		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w
	move.w	d0,d2
	tst.b	d0
	bmi	bdpc5			;œKΏۃR[h̏ꍇ
	beq	skipexpr1		;(x[XfBXv[Xg̓TvXĂ)
	bsr	skipexpr1		;œKΏۂłȂ̂Ō㑱̎ǂݔ΂
	bra	bdodadr1

bdpc5:					;œKΏۃR[h
	bsr	calctmpexpr		;㑱̎̒lvZ
	tst.b	d0
	bmi	bdodadr8		;萔łȂꍇ͍œKłȂ
	beq	bdodadr6		;萔̏ꍇ
	cmp.b	(SECTION,a6),d0		;AhXl̏ꍇ
	bne	bdodadr8		;ZNVႤ̂ōœKłȂ
	sub.l	a5,d1			;݂̃AhX̑Βl
	addq.l	#2,d1
	move.w	d1,d0
	ext.l	d0
	cmp.l	d0,d1
	beq	bdodadr5_w
	cmp.b	#SZ_WORD|ESZ_OPT,d2
	beq	bdodadr5_l		;$8000ȏȂ.w.l
	cmp.l	#$8002,d1
	bcs	bdodadr5_w		;$8002Ȃ.l.w
	addq.l	#4,a5
	rts

;----------------------------------------------------------------
linkcmd:				;33xx link.w/.l
	addq.l	#2,a5
	GETFPTR	TEMPFILPTR,d3		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w
	move.w	d0,d2
	tst.b	d0
	bmi	linkcmd5		;œKΏۃR[h̏ꍇ
	bsr	skipexpr1		;œKΏۂłȂ̂Ō㑱̎ǂݔ΂
linkcmd1:
	cmpi.b	#SZ_WORD,d2
	beq	linkcmd2
	addq.l	#2,a5			;fBXv[XgTCY.l̏ꍇ
linkcmd2:
	addq.l	#2,a5			;			     .w̏ꍇ
linkcmd9:
	rts

linkcmd8:				;œKłȂꍇ
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	bra	linkcmd1

linkcmd5:				;œKΏۃR[h
	bsr	calctmpexpr		;㑱̎̒lvZ
	tst.b	d0
	beq	linkcmd6
	cmp.b	#SECT_RDATA,d0
	bcc	linkcmd8		;萔łȂꍇ͍œKłȂ
	bra	linkcmd5_l

linkcmd6:
	move.l	d1,d0
	ext.l	d0
	cmp.l	d0,d1
	beq	linkcmd5_w
linkcmd5_l:
	addq.l	#4,a5
	cmp.b	#SZ_LONG|ESZ_OPT,d2
	beq	linkcmd9		;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	subq.l	#2,a4			;(.w.l̂)
	move.w	d2,d0
	move.b	(OPTMOREFLG,a6),d0	;(ŏ̂ESZ_OPT)
	move.l	d3,d1
	bra	fmodify

linkcmd5_w:
	addq.l	#2,a5
	moveq.l	#SZ_WORD|ESZ_OPT,d0
	cmp.b	d0,d2
	beq	linkcmd9		;œKÕTCYƓȂ̂ŉȂ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#2,a4			;(.l.ŵ)
	move.b	d0,d2			;(ŐLтꍇ)
	move.w	d2,d0
	move.l	d3,d1
	bra	fmodify

;----------------------------------------------------------------
bracmd:					;0Cxx bra/bsr/b<cc>.s/.w/.l
	bsr	tmpreadd0w		;߃R[h
bracmd0:
	move.w	d0,d5
	GETFPTR	TEMPFILPTR,d3		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w
	move.w	d0,d2
	tst.b	d0
	bmi	bracmd5			;œKΏۃR[h̏ꍇ
	bsr	skipexpr1		;œKΏۂłȂ̂Ō㑱̎ǂݔ΂
	and.b	#3,d2			;$40
bracmd1:
	ext.w	d2
	move.b	(bracmd_tbl,pc,d2.w),d2
	adda.w	d2,a5
	rts

bracmd_tbl:	.dc.b	0,4,6,2

bracmd8:				;œKłȂꍇ
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	bra	bracmd1

bracmd5:				;œKΏۃR[h
	bsr	calctmpexpr		;㑱̎̒lvZ
	tst.b	d0
	ble	bracmd8			;lAhXlłȂ̂ōœKłȂ
	cmp.b	(SECTION,a6),d0		;AhXl̏ꍇ
	bne	bracmd8			;ZNVႤ̂ōœKłȂ
	sub.l	a5,d1			;݂̃AhX̑Βl
	subq.l	#2,d1			;(߃R[h̕)
	cmp.b	#SZ_WORD|ESZ_OPT,d2
	beq	bracmd5_w
bracmd6:
	cmp.b	#SZ_SHORT|ESZ_OPT,d2
	beq	bracmd5_s
	cmp.b	#ESZ_OPT,d2
	beq	bracmd5_nul

bracmd5_l:				;.lc
	moveq.l	#4,d0
	cmp.l	d0,d1
	beq	bracmd7_nul		;̖߂ւ̃u`̏ꍇ
	move.b	#SZ_SHORT|ESZ_OPT,d2
	moveq.l	#4,d4
	move.w	d1,d0
	ext.w	d0
	ext.l	d0
	cmp.l	d0,d1
	beq	bracmd7_s
	cmp.l	#$84,d1
	bcs	bracmd7_s		;$84Ȃ.l.s
	move.b	#SZ_WORD|ESZ_OPT,d2
	moveq.l	#2,d4
	move.w	d1,d0
	ext.l	d0
	cmp.l	d0,d1
	beq	bracmd7_w
	cmp.l	#$8002,d1
	bcs	bracmd7_w		;$8002Ȃ.l.w
	addq.l	#6,a5			;TCYωȂ
	rts

bracmd5_w:				;.wc
	moveq.l	#2,d0
	cmp.l	d0,d1
	beq	bracmd7_nul		;̖߂ւ̃u`̏ꍇ
	move.b	#SZ_SHORT|ESZ_OPT,d2
	moveq.l	#2,d4
	move.w	d1,d0
	ext.w	d0
	ext.l	d0
	cmp.l	d0,d1
	beq	bracmd7_s
	cmp.l	#$82,d1
	bcs	bracmd7_s		;$82Ȃ.w.s

	move.w	d1,d0
	ext.l	d0
	cmp.l	d0,d1
	bne	bracmd7_l		;.w.l
	addq.l	#4,a5			;TCYωȂ
	rts

bracmd5_s:				;.sc
	tst.l	d1
	beq	bracmd7_nul		;̖߂ւ̃u`̏ꍇ
	move.b	#SZ_WORD,d2
	moveq.l	#-2,d4
	move.b	d1,d0
	ext.w	d0
	cmp.w	d0,d1
	bne	bracmd7_w		;.s.w(.s.l͂肦Ȃ)
	addq.l	#2,a5			;TCYωȂ
bracmd9:
	rts

bracmd5_nul:				;0c
	moveq.l	#-2,d0
	cmp.l	d0,d1
	beq	bracmd9			;TCYωȂ
	tst.l	d1
	beq	bracmd7_w0		;̖߂ւ̃u`
	move.b	#SZ_SHORT,d2		;TCYLт炻Ŋm肷
	moveq.l	#-2,d4			;(0.l/0.w͂肦Ȃ)
bracmd7_s:				;.s
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#2,a5
	add.l	d4,a4
	move.w	d2,d0
	move.l	d3,d1
	bra	fmodify

bracmd7_w0:				;̖߂ւ̃u`̏ꍇ(0.w)
	moveq.l	#-2,d1
bracmd7_w1:				;̖߂ւ̃u`TvXȂꍇ
	move.l	d1,d4
	subq.l	#2,d4			;.s:-2/.w:0/.l:2bytesk
	move.b	#SZ_WORD,d2
bracmd7_w:				;.w
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#4,a5
	add.l	d4,a4
	move.w	d2,d0
	move.l	d3,d1
	bra	fmodify

bracmd7_l:				;.w.l
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#6,a5
	subq.l	#2,a4
	move.w	d2,d0
	move.b	(OPTMOREFLG,a6),d0	;(ŏ̂ESZ_OPT)
	move.l	d3,d1
	bra	fmodify

;ւbra/bcc/bsr
bracmd7_nul:
	addq.l	#2,d1
;d1.l:̃TCY(.s=2,.w=4,bra.l=6,jbra.l=8)
	cmp.w	#$6100,d5
	beq	bracmd7_nul_bsr
	tst.b	(NOBRACUT,a6)
	bne	bracmd7_nul_bcc
;ւbcc/bra폜Ƃ
	st.b	(OPTFLAG,a6)		;œKsꂽ
	adda.l	d1,a4			;nul
					;߂ȂȂ̂a5(P[VJE^)͑₳Ȃ
	move.w	d2,d0
	move.b	#ESZ_OPT,d0		;KœKΏۂƂ
	move.l	d3,d1
	bra	fmodify

;ւbsrȂ̂.wɂpeaɕϊƂ
bracmd7_nul_bsr:
	move.b	#SZ_WORD|$40,d2		;$40͒ւbsr
	bra	bracmd7_nul_b

;ւbra/bccNOBRACUT=trueȂ̂.wŏo͂Ƃ
bracmd7_nul_bcc:
	move.b	#SZ_WORD,d2		;bsrł͂Ȃ̂$40ZbgȂ
					;(objgen$40𒼌ւbsrƔf)
bracmd7_nul_b:
	subq.l	#4,d1			;.s=-2,.w=0,bra.l=2,jbra.l=4
	beq	bracmd7_nul_b_w
	st.b	(OPTFLAG,a6)		;.w.ŵƂ̓TCYωȂ
bracmd7_nul_b_w:
	adda.l	d1,a4			;.w
	addq.l	#4,a5			;.wŒ
	move.w	d2,d0
	move.l	d3,d1
	bra	fmodify

;----------------------------------------------------------------
jbracmd:				;31xx jbra/jbsr/jb<cc>
	bsr	tmpreadd0w		;߃R[h
	cmp.w	#$6100,d0
	bls	bracmd0			;jbra/jbsrbra/bsrƓ
	move.w	d0,d5
	GETFPTR	TEMPFILPTR,d3		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w
	move.w	d0,d2
	tst.b	d0
	bmi	jbracmd5		;œKΏۃR[h̏ꍇ
	bsr	skipexpr1		;œKΏۂłȂ̂Ō㑱̎ǂݔ΂
jbracmd1:
	ext.w	d2
	move.b	(jbracmd_tbl,pc,d2.w),d2
	adda.w	d2,a5
	rts

jbracmd_tbl:	.dc.b	0,4,8,2

jbracmd8:				;œKłȂꍇ
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	bra	jbracmd1

jbracmd5:				;œKΏۃR[h
	bsr	calctmpexpr		;㑱̎̒lvZ
	tst.b	d0
	ble	jbracmd8		;lAhXlłȂ̂ōœKłȂ
	cmp.b	(SECTION,a6),d0		;AhXl̏ꍇ
	bne	jbracmd8		;ZNVႤ̂ōœKłȂ
	sub.l	a5,d1			;݂̃AhX̑Βl
	subq.l	#2,d1			;(߃R[h̕)
	cmp.b	#SZ_WORD|ESZ_OPT,d2
	beq	jbracmd5_w
	cmp.b	#SZ_LONG|ESZ_OPT,d2
	bne	bracmd6			;.w/.lȊOb<cc>Ɠ

jbracmd5_l:				;.lc
	moveq.l	#6,d0			;+2
	cmp.l	d0,d1
	beq	bracmd7_nul		;̖߂ւ̃u`̏ꍇ
	move.b	#SZ_SHORT|ESZ_OPT,d2
	moveq.l	#6,d4			;+2
	move.w	d1,d0
	ext.w	d0
	ext.l	d0
	cmp.l	d0,d1
	beq	bracmd7_s
	cmp.l	#$86,d1
	bcs	bracmd7_s		;+2 $86Ȃ.l.s
	move.b	#SZ_WORD|ESZ_OPT,d2
	moveq.l	#4,d4			;+2
	move.w	d1,d0
	ext.l	d0
	cmp.l	d0,d1
	beq	bracmd7_w
	cmp.l	#$8004,d1
	bcs	bracmd7_w		;+2 $8004Ȃ.l.w
	addq.l	#8,a5			;+2 TCYωȂ
	rts

jbracmd5_w:				;.wc
	moveq.l	#2,d0
	cmp.l	d0,d1
	beq	bracmd7_nul		;̖߂ւ̃u`̏ꍇ
	move.b	#SZ_SHORT|ESZ_OPT,d2
	moveq.l	#2,d4
	move.w	d1,d0
	ext.w	d0
	ext.l	d0
	cmp.l	d0,d1
	beq	bracmd7_s
	cmp.l	#$82,d1
	bcs	bracmd7_s		;$82Ȃ.w.s

	move.w	d1,d0
	ext.l	d0
	cmp.l	d0,d1
	bne	jbracmd7_l		;.w.l
	addq.l	#4,a5			;TCYωȂ
	rts

jbracmd7_l:				;.w.l
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#8,a5			;+2
	subq.l	#2,a4
	move.w	d2,d0
	move.b	(OPTMOREFLG,a6),d0	;(ŏ̂ESZ_OPT)
	move.l	d3,d1
	bra	fmodify

;----------------------------------------------------------------
cpbracmd:				;0Dxx cpb<cc>.w/.l
	bsr	tmpreadd0w		;߃R[h͓ǂݔ΂(pass 3ŕύX)
	GETFPTR	TEMPFILPTR,d3		;݂̃t@C|C^ʒu𓾂
	bsr	tmpreadd0w
	move.w	d0,d2
	tst.b	d0
	bmi	cpbracmd5		;œKΏۃR[h̏ꍇ
	bsr	skipexpr1		;œKΏۂłȂ̂Ō㑱̎ǂݔ΂
cpbracmd1:				;(߃TvXŊm肷邱Ƃ͂Ȃ)
	cmpi.b	#SZ_WORD,d2
	bne	cpbracmd2
	addq.l	#4,a5			;fBXv[XgTCY.w̏ꍇ
	rts

cpbracmd2:
	addq.l	#6,a5			;			     .l̏ꍇ
	rts

cpbracmd8:				;œKłȂꍇ
	and.b	#3,d2			;(ESZ_OPTrbgNA)
	move.w	d2,d0
	move.l	d3,d1
	bsr	fmodify
	bra	cpbracmd1

cpbracmd5:				;œKΏۃR[h
	bsr	calctmpexpr		;㑱̎̒lvZ
	tst.b	d0
	ble	cpbracmd8		;lAhXlłȂ̂ōœKłȂ
	cmp.b	(SECTION,a6),d0		;AhXl̏ꍇ
	bne	cpbracmd8		;ZNVႤ̂ōœKłȂ
	sub.l	a5,d1			;݂̃AhX̑Βl
	subq.l	#2,d1			;(߃R[h̕)
	cmp.b	#SZ_WORD|ESZ_OPT,d2
	beq	cpbracmd5_w
	cmp.b	#ESZ_OPT,d2
	beq	cpbracmd5_nul
cpbracmd5_l:				;.lc
	moveq.l	#4,d0
	cmp.l	d0,d1
	beq	cpbracmd7_nul		;̖߂ւ̃u`
	move.b	#SZ_WORD|ESZ_OPT,d2
	moveq.l	#2,d4			;kޏꍇɌނoCg
	move.w	d1,d0
	ext.l	d0
	cmp.l	d0,d1
	beq	cpbracmd7_w
	cmp.l	#$8002,d1
	bcs	cpbracmd7_w		;$8002Ȃ.l.w
	addq.l	#6,a5			;TCYωȂ
	rts

cpbracmd5_w:				;.wc
	moveq.l	#2,d0
	cmp.l	d0,d1
	beq	cpbracmd7_nul		;̖߂ւ̃u`
	move.w	d1,d0
	ext.l	d0
	cmp.l	d0,d1
	bne	cpbracmd7_l
	addq.l	#4,a5			;TCYωȂ
cpbracmd9:
	rts

cpbracmd5_nul:				;0c
	moveq.l	#-2,d0
	cmp.l	d0,d1
	beq	cpbracmd9		;TCYωȂ
	move.b	#SZ_WORD,d2		;TCYLт炻Ŋm肷
	moveq.l	#-4,d4			;(0.l͂肦Ȃ)
cpbracmd7_w:				;.w
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#4,a5
	add.l	d4,a4
	move.w	d2,d0
	move.l	d3,d1
	bra	fmodify

cpbracmd7_l:				;.w.l
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#6,a5
	subq.l	#2,a4
	move.w	d2,d0
	move.b	(OPTMOREFLG,a6),d0	;(ŏ̂ESZ_OPT)
	move.l	d3,d1
	bra	fmodify

cpbracmd7_nul:				;0(u`߂TvXꍇ)
	tst.b	(NOBRACUT,a6)
	beq	cpbracmd7_nul1
	move.l	d1,d4
	subq.l	#2,d4
	move.b	#SZ_WORD,d2
	bra	cpbracmd7_w

cpbracmd7_nul1:
	st.b	(OPTFLAG,a6)		;œKsꂽ
	addq.l	#2,d1
	add.l	d1,a4
	move.w	d2,d0
	move.b	#ESZ_OPT,d0		;KœKΏۂƂ
	move.l	d3,d1
	bra	fmodify


;----------------------------------------------------------------
;	Tu[`
;----------------------------------------------------------------

;----------------------------------------------------------------
;	e|t@CV{ԍEǂݍ݁A̒l𓾂
;	in :d0.w=V{l/\킷e|t@CR[h
;	out:d0.w=ʂ̑(0:萔/1`4:AhXl(ZNVԍ)/
;			    $FFFF:/$01FF:ItZbgtOQ/$02FF:OQƒl)
;	    d1.l=ʂ̒l
calctmpexpr:
	move.l	a1,-(sp)
	and.w	#$FF00,d0
	cmp.w	#T_SYMBOL,d0
	bne	calctmpexpr5

	bsr	tmpreadd0l		;V{lꍇ
	movea.l	d0,a1
	cmpi.b	#ST_LOCAL,(SYM_TYPE,a1)	;(ST_VALUE or ST_LOCAL)
	bhi	calctmpexpr9		;lV{łȂ
	cmpi.b	#SA_DEFINE,(SYM_ATTRIB,a1)
	blo	calctmpexpr9		;`V{

	clr.w	d0
	move.b	(SYM_SECTION,a1),d0
	beq	calctmpexpr2
	cmp.b	(SECTION,a6),d0
	bne	calctmpexpr2
	move.b	(SYM_ORGNUM,a1),d1
	cmp.b	(ORGNUM,a6),d1
	bne	calctmpexpr2
	move.b	(SYM_OPTCOUNT,a1),d1
	cmp.b	(OPTCOUNT,a6),d1
	beq	calctmpexpr2
	move.l	(SYM_VALUE,a1),d1
	sub.l	a4,d1
	movea.l	(sp)+,a1
	rts

calctmpexpr2:
	move.l	(SYM_VALUE,a1),d1
	movea.l	(sp)+,a1
	rts

calctmpexpr5:
	move.l	a5,(LOCATION,a6)
	move.l	a4,(LOCOFFSET,a6)
	bsr	tmpreadd0w		;ꍇ
	move.w	d0,d1			;t|[h̒
	lea.l	(OPRBUF,a6),a1
calctmpexpr6:
	bsr	tmpreadd0w		;{̂ǂݍ
	move.w	d0,(a1)+
	dbra	d1,calctmpexpr6
	clr.w	(a1)+			;(GhR[h)
	lea.l	(OPRBUF,a6),a1
	bsr	calcrpn			;ǂݍ񂾎vZ
	movea.l	(sp)+,a1
	rts

calctmpexpr9:
	moveq.l	#-1,d0			;l
	movea.l	(sp)+,a1
	rts


;----------------------------------------------------------------
	.end

;----------------------------------------------------------------
;	$Log: optimize.s,v $
;	Revision 2.5  1999  3/ 2(Tue) 17:04:08 M.Kamada
;	+82 G[bZ[W{ꉻ
;	+82 T_ERROR$FF00ʏ̃R[hɕύX
;
;	Revision 2.4  1999  2/27(Sat) 23:44:02 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 2.3  1999  2/24(Wed) 22:03:04 M.Kamada
;	+80 ColdFireΉ
;	+80 .offsym <l>,<V{>
;
;	Revision 2.2  1998 10/10(Sat) 01:53:40 M.Kamada
;	+77 -p̂Ƃ.INSERT1x256oCgȏǂݏoƌ듮삷
;
;	Revision 2.1  1997 10/13(Mon) 15:36:35 M.Kamada
;	+51 ւbsrpea
;	+52 jmp/jsrœK
;
;	Revision 2.0  1997 10/12(Sun) 18:50:14 M.Kamada
;	+50 fadd.d (sp),fp0;bra @f;nop;@@:braœKȂoOC
;	+51 bra @f;.rept 30;fadd.x fp0,fp0;.endm;@@:braœKȂoOC
;
;	Revision 1.9  1997  9/14(Sun) 16:30:23 M.Kamada
;	+46 error.s𕪗
;
;	Revision 1.8  1997  6/25(Wed) 13:37:15 M.Kamada
;	+33 vft@CV{CPUɑΉ
;	+34 vft@CV{ɑΉ
;
;	Revision 1.7  1997  2/ 1(Sat) 23:31:32 M.Kamada
;	+13 bdpc̍œK̃oOC
;
;	Revision 1.6  1996 12/15(Sun) 01:30:51 M.Kamada
;	+07 F43G΍
;		폜ׂNOP̏ǉ
;
;	Revision 1.5  1994/07/12  14:58:40  nakamura
;	link߂ɑ΂œKǉ
;
;	Revision 1.4  1994/03/06  11:31:16  nakamura
;	jbra,jbsr,jbccopcɑ΂œK̒ǉ
;
;	Revision 1.3  1994/02/24  12:13:12  nakamura
;	32KBȏւ̃u`̍œKɎŝCB
;
;	Revision 1.2  1994/02/20  13:52:18  nakamura
;	̖߂ւbsr̍œKɎsoOCB
;
;	Revision 1.1  1994/02/16  15:33:32  nakamura
;	Initial revision
;
;
