;----------------------------------------------------------------
;	X68k High-speed Assembler
;		^߂̃AZu
;		< pseudo.s >
;
;	$Id: pseudo.s,v 1.21  1999 10/ 8(Fri) 21:00:37 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;			  1996-99  by M.Kamada
;----------------------------------------------------------------

	.include	has.equ
	.include	doscall.mac
	.include	cputype.equ
	.include	register.equ
	.include	tmpcode.equ
	.include	symbol.equ

	.cpu	68000
	.text


;----------------------------------------------------------------
;	^߂̃AZu
;----------------------------------------------------------------
dopseudo::
	movea.l	(LINEPTR,a6),a0
	move.l	(SYM_FUNC,a1),a2
	jmp	(a2)			;[`փWv

;----------------------------------------------------------------
;	Iyh̒lvZ
calcopr:
	lea.l	(OPRBUF,a6),a0
	lea.l	(RPNBUF,a6),a1
	bsr	convrpn
	tst.w	d0
	bmi	exprerr			;ϊɎs
	bra	calcrpn

;----------------------------------------------------------------
;	Iyh̒lvZ(萔łȂ΃G[)
calcconst::
	bsr	encodeopr
	bsr	calcopr
	tst.w	d0
	bne	iloprerr		;<>萔łȂ
	rts

;----------------------------------------------------------------
;	if̏̒l𓾂
ifcond:
	bsr	encodeopr
	lea.l	(OPRBUF,a6),a0
	lea.l	(RPNBUF,a6),a1
	bsr	convrpn
	tst.w	d0
	bmi	exprerr			;ϊɎs
	bsr	calcrpn
	tst.w	d0
	bne	iloprerr		;<>萔łȂ
pseudo_tail_check:
	tst.w	(a0)
	bne	iloprerr_pseudo_tail
	rts

;----------------------------------------------------------------
iloprerr_pseudo_tail:
	cmpi.w	#','|OT_CHAR,(a0)	;sIĂȂ
	beq	iloprerr_pseudo_many
	bra	iloprerr

;----------------------------------------------------------------
;	.align	<>[,<pfBOl>]
~~align::
	tst.b	(OFFSYMMOD,a6)
	bgt	offsymalignerr		;.offsymŃV{w肪ƂACgłȂ
	bsr	calcconst
	move.l	d1,d2
	moveq.l	#2,d0
	cmp.l	d0,d2
	bcs	ilvalueerr		;<>01ȂG[
	move.w	#T_ALIGN|$FF,d0
~~align1:
	addq.b	#1,d0
	lsr.l	#1,d2
	bcc	~~align1
	bne	ilvalueerr		;2̗ݏłȂ̂ŃG[
	cmp.b	#8,d0
	bhi	ilvalueerr		;2^8(=256)ȏȂG[
	move.w	(a0)+,d2
	beq	~~align4		;pfBOl̎w肪Ȃ
	cmp.w	#','|OT_CHAR,d2
	bne	iloprerr
	movem.l	d0-d1,-(sp)
	lea.l	(RPNBUF,a6),a1
	bsr	convrpn
	tst.w	d0
	bmi	exprerr			;ϊɎs
	bsr	calcrpn
	tst.w	d0
	bne	iloprerr		;<>萔łȂ
	moveq.l	#SZ_WORD,d2
	bsr	chkdtsize		;̒l[hׂ͈͓̔
	tst.w	(a0)
	bne	iloprerr_pseudo_tail
	move.l	d1,d3
	movem.l	(sp)+,d0-d1
	bra	~~align5

~~align4:
	moveq.l	#0,d3			;pfBOl
	cmpi.b	#SECT_TEXT,(SECTION,a6)
	bne	~~align5
	move.w	#$4E71,d3		;.textZNVł͋EnopŖ߂
~~align5:
	tst.b	(SECTION,a6)
	beq	~~align6
	st.b	(MAKEALIGN,a6)		;IuWFNgt@CɃACgo͂
	cmp.b	(MAXALIGN,a6),d0
	bls	~~align6
	move.b	d0,(MAXALIGN,a6)	;\[Xōő̃ACl̏ꍇ
~~align6:
	bsr	wrtobjd0w
	move.w	d3,d0
	bsr	wrtd0w			;pfBOl
	subq.l	#1,d1
	move.l	(LOCATION,a6),d0
	move.l	d0,d2
	add.l	d1,d0
	not.l	d1
	and.l	d1,d0
	move.l	d0,(LOCATION,a6)
	move.l	d0,(LTOPLOC,a6)
	sub.l	d2,d0			;pfBO
	bra	wrtd0w			;(ő255bytesȂ̂Ń[hOk)

;----------------------------------------------------------------
;	.quad
~~quad::
	tst.b	(OFFSYMMOD,a6)
	bgt	offsymalignerr		;.offsymŃV{w肪ƂACgłȂ
	move.w	#T_ALIGN|2,d0		;.quad = .align 4(=2^2)
	moveq.l	#4,d1
	bra	~~align4

;----------------------------------------------------------------
;	.even
~~even::
	tst.b	(OFFSYMMOD,a6)
	bgt	offsymalignerr		;.offsymŃV{w肪ƂACgłȂ
	btst.b	#0,(LOCATION+3,a6)
	beq	~~even1
	moveq.l	#0,d0
	bsr	wrt1bobj		;$00o͂ċEɍ킹
	addq.l	#1,(LTOPLOC,a6)
~~even1:
	rts

;----------------------------------------------------------------
f43gcut::
	tst.b	(F43GTEST,a6)
	beq	f43gcut1
	move.l	a0,-(sp)
	movea.l	(F43GPTR,a6),a0
	movea.l	(a0),a0			;̃R[h
	move.l	a0,(F43GPTR,a6)
;	clr.l	(8,a0)
	clr.w	(12,a0)
	movea.l	(sp)+,a0
f43gcut1:
	rts

;----------------------------------------------------------------
;	.dc[.<TCY>]	<>[,<>,c]
~~dc::
	bsr	f43gcut
	bsr	encodeopr
	move.b	(CMDOPSIZE,a6),d0
	bmi	~~dc0
	cmp.b	#SZ_SINGLE,d0
	bcc	dodcreal		;_.dc
	tst.b	d0
	bne	~~dc1
	move.b	#SZ_SHORT,(CMDOPSIZE,a6)	;.b.s
	bra	~~dc2

~~dc0:
	move.b	#SZ_WORD,(CMDOPSIZE,a6)
~~dc1:
~~dc2:
	lea.l	(OPRBUF,a6),a0
~~dc3:
	bsr	dodcparam		;p[^1ɂď
	move.w	(a0)+,d0
	beq	~~dc9
	cmp.w	#','|OT_CHAR,d0
	beq	~~dc3
	bra	iloprerr

~~dc9:
	rts

;----------------------------------------------------------------
;	.dc̃p[^1̏
dodcparam:
	move.w	(a0),d0
	beq	iloprerr		;p[^Ȃ
	cmp.w	#','|OT_CHAR,d0
	beq	dodcparam9		;','̂
	and.w	#$FF00,d0
	cmp.w	#OT_STR,d0		;
	bne	dodcnum
dodcparam01:
	movea.l	a0,a1
	moveq.l	#0,d0
	move.b	(1,a0),d0		;
	addq.l	#3,d0
	bclr.l	#0,d0
	adda.l	d0,a1			;̏IAhX
	move.w	(a1),d0
	beq	dodcstr			;݂̂̏ꍇ
	cmp.w	#','|OT_CHAR,d0
	beq	dodcstr
	and.w	#$FF00,d0
	cmp.w	#OT_STR,d0
	bne	dodcnum
	bsr	dodcstr			;Ƃ肠1Ԗڂ̕Ă
	bra	dodcparam01

dodcnumpat:
	cmpi.b	#SZ_SHORT,(CMDOPSIZE,a6)
	bne	convrpn

	clr.b	(CMDOPSIZE,a6)		;.s.b
	bsr	convrpn
	addq.b	#SZ_SHORT,(CMDOPSIZE,a6)	;.b.s
	rts

dodcnum:				;p[^
	lea.l	(RPNBUF,a6),a1
	bsr	dodcnumpat
	tst.w	d0
	bmi	exprerr			;ϊłȂ
	move.w	d1,d2
	bsr	calcrpn
	move.w	d0,d3
	move.b	(EXPRSIZE,a6),d0	;̃TCY
	bpl	dodcnum11
	cmpi.b	#OT_SIZE>>8,(a0)
	bne	dodcnum1		;Ɍ㑱TCYw肪Ȃ
	move.w	(a0)+,d0		;Ɍ㑱TCY
dodcnum11:
	tst.b	d0			;cmp.b #SZ_BYTE,d0
	bne	dodcnum0
	move.b	#SZ_SHORT,d0		;.b.s
	bra	dodcnum3

dodcnum0:
	cmp.b	#SZ_SINGLE,d0
	bcc	ilsizeerr		;͎󂯕tȂ(.b̈ӖɂȂĂ.ss)
	bra	dodcnum2		;TCYw肪

dodcnum1:
	move.b	(CMDOPSIZE,a6),d0	;TCYw肪Ȃ̂.dc̃TCYg
dodcnum2:
	cmp.b	#SZ_SHORT,d0
	beq	dodcnum3
	btst.b	#0,(LOCATION+3,a6)
	beq	dodcnum3
	bsr	alignwarn		;EɍĂȂ̂Ń[jOo
dodcnum3:
	tst.w	d3
	beq	wrtimm			;萔Ȃt@Cɏo
	cmp.b	#SZ_SHORT,d0
	beq	dodcnumb
	cmp.b	#SZ_WORD,d0
	beq	dodcnumw
	add.l	#2,(LOCATION,a6)	;.l
dodcnumw:
	add.l	#1,(LOCATION,a6)
dodcnumb:
	add.l	#1,(LOCATION,a6)
	move.w	d2,d1			;̃[h
	bra	wrtrpn			;t@Cɏo

dodcstr:				;p[^
	move.w	(a0)+,d1		;d1.b=
	and.w	#$00FF,d1
	beq	dodcstrlw9		;kXgO
	move.b	(CMDOPSIZE,a6),d2
	cmp.b	#SZ_SHORT,d2
	beq	dodcstrb
	ext.w	d2			;.w/.lł̕񏑂
	add.w	d2,d2
	subq.w	#1,d2
dodcstrlw:
	moveq.l	#0,d0
	move.w	d2,d3
dodcstrlw1:
	lsl.l	#8,d0
	move.b	(a0)+,d0
	subq.b	#1,d1
	dbeq	d3,dodcstrlw1
	cmpi.b	#SZ_WORD,(CMDOPSIZE,a6)
	beq	dodcstrlw2
	bsr	wrt1lobj
	bra	dodcstrlw3

dodcstrlw2:
	bsr	wrt1wobj
dodcstrlw3:
	tst.b	d1
	bne	dodcstrlw
dodcstrlw9:
	move.l	a0,d0
	doeven	d0
	movea.l	d0,a0
dodcparam9
	rts

dodcstrb:				;.bł̕񏑂
	move.b	(a0)+,d0
	bsr	wrt1bobj
	subq.b	#1,d1
	bne	dodcstrb
	bra	dodcstrlw9

;----------------------------------------------------------------
;	_.dc
dodcreal:
	btst.b	#0,(LOCATION+3,a6)
	beq	dodcreal1
	bsr	alignwarn		;EɍĂȂ̂Ń[jOo
dodcreal1:
	lea.l	(OPRBUF,a6),a0
	tst.w	(a0)
	beq	iloprerr		;p[^Ȃ
dodcreal2:
	lea.l	(RPNBUFEX,a6),a3	;Iyhpobt@
	bsr	getdcreal		;_Iyh𓾂
dodcreal3:
	move.l	(a3)+,d0
	bsr	wrt1lobj		;ꂽf[^o͂
	dbra	d5,dodcreal3
	move.w	(a0)+,d0
	beq	dodcreal9
	cmp.w	#','|OT_CHAR,d0
	beq	dodcreal2
	bra	iloprerr

dodcreal9:
	rts

;----------------------------------------------------------------
;	_Iyh
getdcreal:
	movea.l	a3,a4
	move.b	(CMDOPSIZE,a6),d0
	bsr	getfplen		;f[^𓾂
	move.w	d0,d4
	move.w	d1,d3
	move.w	d1,d5
	lea.l	(RPNBUF,a6),a1
	bsr	convrpn
	tst.w	d0
	bpl	getdcreal6		;\`̒l𓾂
	bsr	calcfexpr		;_𓾂
	movem.l	d0-d2,(a3)
	rts

getdcreal5:
	cmpi.w	#','|OT_CHAR,(a0)+
	bne	iloprerr
	lea.l	(RPNBUF,a6),a1
	bsr	convrpn
	tst.w	d0
	bmi	iloprerr		;Ȃ
getdcreal6:
	bsr	calcrpn
	tst.w	d0
	bne	iloprerr_not_fixed	;萔łȂ
	move.l	d1,(a4)+
	dbra	d3,getdcreal5
	rts

;----------------------------------------------------------------
;	.dcb[.<TCY>]	<>,<>
~~dcb::
	bsr	encodeopr
	tst.b	(CMDOPSIZE,a6)
	beq	~~dcb1			;.b̏ꍇ
	btst.b	#0,(LOCATION+3,a6)
	beq	~~dcb1
	bsr	alignwarn		;EɍĂȂ̂Ń[jOo
~~dcb1:
	bsr	calcopr
	tst.w	d0
	bne	ilvalueerr		;<>萔łȂ
	subq.l	#1,d1
	bcs	~~dcb9			;<>0̏ꍇ͉Ȃ
	cmp.l	#$FFFF,d1
	bcc	ilvalueerr		;<>1`65535
	move.w	d1,-(sp)
	cmpi.w	#','|OT_CHAR,(a0)+
	bne	iloprerr		;,<>Ȃ
	cmpi.b	#SZ_SINGLE,(CMDOPSIZE,a6)
	bge	~~dcb10			;_.dcb
	lea.l	(RPNBUF,a6),a1
	bsr	convrpn
	tst.w	d0
	bmi	exprerr			;ϊɎs
	tst.w	(a0)
	bne	iloprerr_pseudo_tail	;sIĂȂ
	moveq.l	#0,d0
	move.w	(sp),d0			;<>-1
	addq.w	#1,d0
	move.b	(CMDOPSIZE,a6),d2
	bmi	~~dcb2
	bne	~~dcb3
	move.b	#SZ_SHORT,(CMDOPSIZE,a6)	;.b.s
	bra	~~dcb7

~~dcb2:
	move.b	#SZ_WORD,(CMDOPSIZE,a6)	;ȗ.w
	bra	~~dcb6

~~dcb3:
	cmp.b	#SZ_WORD,d2
	beq	~~dcb6
	add.l	d0,d0			;.l
~~dcb6:
	add.l	d0,d0			;.w
~~dcb7:
	add.l	d0,(LOCATION,a6)
	move.w	#T_DCB,d0
	bsr	wrtobjd0w
	move.w	(sp)+,d0
	bsr	wrtd0w			;-1
	move.b	(CMDOPSIZE,a6),d0
	bra	wrtrpn

~~dcb9:
	rts

~~dcb10:				;_.dcb
	lea.l	(RPNBUFEX,a6),a3	;Iyhpobt@
	bsr	getdcreal		;_Iyh𓾂
	move.w	d5,d4
	moveq.l	#0,d0
	move.w	(sp),d0			;<>-1
	addq.w	#1,d0
	add.l	d0,d0
	add.l	d0,d0
	moveq.l	#0,d1
~~dcb11:
	add.l	d1,d0
	dbra	d5,~~dcb11
	add.l	d1,(LOCATION,a6)
	move.w	#T_FDCB,d0
	move.b	d4,d0			;f[^-1
	bsr	wrtobjd0w
	move.w	(sp)+,d0
	bsr	wrtd0w			;-1
	moveq.l	#3-1,d1
~~dcb12:
	move.l	(a3)+,d0
	bsr	wrtd0l			;V{l
	dbra	d1,~~dcb12
	rts

;----------------------------------------------------------------
;	.ds[.<TCY>]	<>
~~ds::
	bsr	deflabel		;s̃x`
	move.w	#-1,(LABNAMELEN,a6)
	bsr	encodeopr
	bsr	calcopr
	tst.w	d0
	bne	ilvalueerr		;<>萔łȂ
	tst.w	(a0)
	bne	iloprerr_pseudo_tail	;sIĂȂ
	tst.l	d1
	bmi	ds_iloprerr_ds_negative
~~ds_0:
	move.b	(CMDOPSIZE,a6),d0
	bmi	~~ds_w
	tst.b	d0			;cmp.b #SZ_BYTE,d0
	beq	~~ds_b
	cmp.b	#SZ_WORD,d0
	beq	~~ds_w
	cmp.b	#SZ_LONG,d0
	beq	~~ds_l
	cmp.b	#SZ_SINGLE,d0
	beq	~~ds_s
	cmp.b	#SZ_DOUBLE,d0
	beq	~~ds_d
	move.l	d1,d2			;.x/.p	(12bytes)
	add.l	d2,d1
	add.l	d2,d1			;3~4=12{
	bra	~~ds_l

~~ds_d:					;.d	(8bytes)
	add.l	d1,d1
~~ds_l:					;.l/.s	(4bytes)
~~ds_s:
	add.l	d1,d1
~~ds_w:					;.w	(2bytes)
	add.l	d1,d1
	btst.b	#0,(LOCATION+3,a6)
	beq	~~ds_b
	bsr	alignwarn		;EɍĂȂ̂Ń[jOo
~~ds_b:					;.b	(1byte)
	add.l	d1,(LOCATION,a6)
	move.w	#T_DS,d0
	bsr	wrtobjd0w
	move.l	d1,d0
	bra	wrtd0l			;(oCgP)

ds_iloprerr_ds_negative:
	move.b	(SECTION,a6),d0
	subq.b	#SECT_TEXT,d0
	beq	iloprerr_ds_negative
	subq.b	#SECT_DATA-SECT_TEXT,d0
	beq	iloprerr_ds_negative
	bsr	ds_negative_warn
	bra	~~ds_0

;----------------------------------------------------------------
;	.fpid	<>	(0`7)
~~fpid::
	bsr	calcconst
	tst.l	d1
	bmi	~~fpid9
	cmp.l	#7,d1
	bhi	ilvalueerr
	ror.w	#7,d1			;RvZbTIDtB[hb9`11
	move.w	d1,(FPCPID,a6)
	rts

~~fpid9:				;̒lw肳ꂽFPP߂֎~
	andi.w	#CFPP.xor.$FFFF,(CPUTYPE,a6)
	rts

;----------------------------------------------------------------
;	.pragma	<œKwIyh>
~~pragma::
	rts

;----------------------------------------------------------------
;	<V{>	fset[.<TCY>]	<>
~~fset::
	moveq.l	#ST_REAL,d2
	bsr	defltopsym		;s̃V{`
	bra	~~fequ1

;----------------------------------------------------------------
;	<V{>	fequ[.<TCY>]	<>
~~fequ::
	moveq.l	#ST_REAL,d2
	bsr	defltopsym		;s̃V{`
	tst.w	d2
	bmi	pseudo_redeferr_a1	;łɒ`ς
~~fequ1:
	movea.l	a1,a2			;V{e[uւ̃|C^
	move.l	(TEMPPTR,a6),d0
	doquad	d0
	movea.l	d0,a3
	move.l	d0,(SYM_FVPTR,a2)	;V{lւ̃|C^
	addq.l	#8,d0
	addq.l	#4,d0			;(ő12bytes)
	move.l	d0,(TEMPPTR,a6)
	bsr	memcheck
	st.b	(SYM_FSIZE,a2)		;(move.b #-1,(SYM_FSIZE,a2))
	lea.l	(OPRBUF,a6),a0
	bsr	getdcreal		;_Iyh𓾂
	tst.w	(a0)
	bne	iloprerr_pseudo_tail	;sIĂȂ
	move.w	#T_FEQUSET,d0		;fequ/fset
	move.b	d4,(SYM_FSIZE,a2)	;TCY
	move.b	d4,d0
	bsr	wrtobjd0w
	move.l	a2,d0
	bsr	wrtd0l			;V{ւ̃|C^
	move.l	(SYM_FVPTR,a2),a1
	moveq.l	#3-1,d1
~~fequ6:
	move.l	(a1)+,d0
	bsr	wrtd0l			;V{l
	dbra	d1,~~fequ6
	rts

;----------------------------------------------------------------
;	s̃V{`
defltopsym:
	move.w	d2,-(sp)
	bsr	encodeopr
	move.w	(LABNAMELEN,a6),d1
	bmi	nosymerr_pseudo		;`ׂV{Ȃ
	move.w	#-1,(LABNAMELEN,a6)	;`̂Ńx
	movea.l	(LABNAMEPTR,a6),a0
	bsr	isdefdsym
	move.w	(sp)+,d2
	tst.w	d0
	bne	defsymbol		;o^ȂVo^
	cmp.b	(SYM_TYPE,a1),d2	;V{̃^Cv
	bne	defltopsym02		;^Cv̈قȂV{ƏdĂ
	tst.b	(SYM_TYPE,a1)		;cmpi.b #ST_VALUE,(SYM_TYPE,a1)
	bne	defltopsym99
	cmpi.b	#SA_PREDEFINE,(SYM_ATTRIB,a1)
	beq	defltopsym01		;vft@CV{Ē`悤Ƃ
defltopsym99:
	moveq.l	#-1,d2
	rts

defltopsym01:
	move.l	a1,(ERRMESSYM,a6)
	bra	redeferr_predefine

defltopsym02:
	tst.b	(SYM_TYPE,a1)		;cmpi.b #ST_VALUE,(SYM_TYPE,a1)
	bne	pseudo_ilsymerr_a1	;^Cv̈قȂV{ƏdĂ
	cmpi.b	#SA_UNDEF,(SYM_ATTRIB,a1)
	bne	pseudo_ilsymerr_a1	;^Cv̈قȂV{ƏdĂ
	move.l	a1,(ERRMESSYM,a6)
	bra	ilsymerr_lookfor	;V{̑OQƂ̏ƖĂ

;----------------------------------------------------------------
pseudo_ilsymerr_a1:
	move.l	a1,(ERRMESSYM,a6)
	move.b	(SYM_TYPE,a1),d0
	beq	ilsymerr_value		;ST_VALUE
	subq.b	#ST_REAL,d0
	bcs	ilsymerr_local		;ST_LOCAL
	beq	ilsymerr_real		;ST_REAL
	subq.b	#ST_REGSYM-ST_REAL,d0
	beq	ilsymerr_regsym		;ST_REGSYM
	bra	ilsymerr_register	;ST_REGISTER

;----------------------------------------------------------------
pseudo_redeferr_a0:
	move.l	a0,(ERRMESSYM,a6)
	bra	redeferr

;----------------------------------------------------------------
pseudo_redeferr_a1:
	move.l	a1,(ERRMESSYM,a6)
	bra	redeferr

;----------------------------------------------------------------
;	<V{>	set	<>
~~set::
	moveq.l	#ST_VALUE,d2
	bsr	defltopsym		;s̃V{`
	tst.b	(SYM_ATTRIB,a1)		;(cmpi.b #SA_UNDEF,(SYM_ATTRIB,a1))
	beq	~~set1			;`
	tst.b	(SYM_FIRST,a1)
	blt	~~set1			;setŒ`Ă
	move.l	a1,(ERRMESSYM,a6)
	tst.b	(OWSET,a6)
	bne	redeferr_set
	bsr	redefwarn_set
~~set1:
	st.b	(SYM_FIRST,a1)
	moveq.l	#-1,d2
	bra	~~equ1

;----------------------------------------------------------------
;	<V{>	equ	<>
~~equ::
	moveq.l	#ST_VALUE,d2
	bsr	defltopsym		;s̃V{`
	tst.b	(SYM_ATTRIB,a1)		;(cmpi.b #SA_UNDEF,(SYM_ATTRIB,a1))
	bne	pseudo_redeferr_a1	;`σV{ȂG[
	sf.b	(SYM_FIRST,a1)
	moveq.l	#0,d2
~~equ1:
	cmpi.b	#SECT_RLCOMM,(SYM_EXTATR,a1)
	bcc	pseudo_redeferr_a1	;.xref/.commV{
	movea.l	a1,a2			;V{e[uւ̃|C^
	lea.l	(OPRBUF,a6),a0
	lea.l	(RPNBUF,a6),a1
	bsr	convrpn
	tst.w	d0
	bne	exprerr			;l݂̂ł͂Ȃ̂ŃG[
	move.w	d1,d3			;̃[h
	bsr	calcrpn
	tst.w	(a0)
	bne	iloprerr_pseudo_tail	;sIĂȂ
	movea.l	a2,a1
	tst.b	d0
	bne	~~equ2			;萔łȂ
	clr.w	(SYM_SECTION,a1)	;(SYM_ORGNUM)
	move.b	#SA_DEFINE,(SYM_ATTRIB,a1)	;`σV{
	move.l	d1,(SYM_VALUE,a1)	;V{l
	move.w	#T_EQUCONST,d0		;萔equ/set
	bsr	wrtobjd0w
	move.l	a1,d0
	bsr	wrtd0l			;V{ւ̃|C^
	move.l	d1,d0
	bsr	wrtd0l			;V{l
	bra	~~equ3

~~equ2:
	move.b	#SA_NODET,(SYM_ATTRIB,a1)	;l̃V{
	move.w	#T_EQUEXPR,d0		;EAhXequ/set
	bsr	wrtobjd0w
	move.l	a1,d0
	bsr	wrtd0l			;V{ւ̃|C^
	lea.l	(RPNBUF,a6),a1
	move.w	d3,d1			;̃[h
	moveq.l	#SZ_LONG,d0
	bsr	wrtrpn			;o
~~equ3:
	tst.b	(LABXDEF,a6)
	beq	~~equ9			;O`͂Ȃ
	movea.l	a2,a1
	move.b	#SECT_XDEF,(SYM_EXTATR,a1)
~~equ9:
	rts

;----------------------------------------------------------------
;	<V{>	reg	<WX^Xg>
~~reg::
	moveq.l	#ST_REGSYM,d2
	bsr	defltopsym		;s̃V{`
	lea.l	(OPRBUF,a6),a2
	move.l	(TEMPPTR,a6),d0
	doeven	d0
	movea.l	d0,a0
	move.l	d0,(SYM_DEFINE,a1)	;`eւ̃|C^
	clr.w	d1
~~reg3:
	move.w	(a2)+,d0
	move.w	d0,(a0)+
	beq	~~reg9			;ԃR[hI
	addq.w	#1,d1
	move.b	d0,d2
	and.w	#$FF00,d0
	cmp.w	#OT_VALUEW,d0
	beq	~~reg5
	cmp.w	#OT_LOCALREF,d0
	beq	~~reg5
	cmp.w	#OT_VALUE,d0
	beq	~~reg6
	cmp.w	#OT_SYMBOL,d0
	beq	~~reg6
	cmp.w	#OT_VALUEQ,d0
	beq	~~reg8
	cmp.w	#OT_REAL,d0
	beq	~~reg7
	cmp.w	#OT_STR,d0
	bne	~~reg3
	tst.b	d2			;
	beq	~~reg3			;kXgO
~~reg4:
	move.w	(a2)+,(a0)+		;̓e]
	addq.w	#1,d1
	subq.b	#2,d2
	bhi	~~reg4
	bra	~~reg3

~~reg5:					;16bitl/[JxQ
	move.w	(a2)+,(a0)+
	addq.w	#1,d1
	bra	~~reg3

~~reg6:					;32bitl/V{
	move.l	(a2)+,(a0)+
	addq.w	#2,d1
	bra	~~reg3

~~reg7:					;_
	move.w	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	addq.w	#5,d1
	bra	~~reg3

~~reg8:					;64bitl
	move.l	(a2)+,(a0)+
	move.l	(a2)+,(a0)+
	addq.w	#4,d1
	bra	~~reg3

~~reg9:					;`eׂē]
	move.l	a0,(TEMPPTR,a6)
	move.w	d1,(SYM_DEFLEN,a1)	;ԃR[h̃[h
	bra	memcheck

;----------------------------------------------------------------
;	.xdef	<V{>[,<V{>,c]
~~xdef::
	moveq.l	#SECT_XDEF,d2
	bra	~~globl1

;---------------------------------------------------------------
;	.xref	<V{>[,<V{>,c]
~~xref::
	moveq.l	#SECT_XREF,d2
	bra	~~globl1

;---------------------------------------------------------------
;	.globl	<V{>[,<V{>,c]
~~globl::
	moveq.l	#SECT_GLOBL,d2
~~globl1:
	move.w	d2,-(sp)
	bsr	encodeopr
	move.w	(sp)+,d2
	lea.l	(OPRBUF,a6),a1
~~globl2:
	move.w	(a1)+,d0
	cmp.w	#OT_SYMBOL,d0
	bne	iloprerr		;V{ȊŐLq̓G[
	move.l	(a1)+,a0		;V{e[uւ̃|C^
	tst.b	(SYM_TYPE,a0)		;cmpi.b #ST_VALUE,(SYM_TYPE,a0)
	bne	iloprerr		;lV{łȂ̂ŃG[
	cmpi.b	#SA_PREDEFINE,(SYM_ATTRIB,a0)
	beq	~~globl00		;vft@CV{͊O錾łȂ
	move.b	(SYM_EXTATR,a0),d1
	beq	~~globl3
	cmp.b	#SECT_RLCOMM,d1
	bcs	pseudo_redeferr_a0
	cmp.b	#SECT_COMM,d1
	bhi	pseudo_redeferr_a0	;łɊO錾Ă(.commȊO)
~~globl3:
	tst.b	(SYM_ATTRIB,a0)
	beq	~~globl4		;`V{
	cmpi.b	#SECT_XREF,d2
	beq	pseudo_redeferr_a0	;`σV{ɑ΂.xref̓G[
~~globl4:
	move.b	d2,(SYM_EXTATR,a0)	;O錾Zbg
	cmpi.b	#SECT_XDEF,d2
	bne	~~globl5
	move.w	#T_XDEF,d0
	bsr	wrtobjd0w
	move.l	a0,d0			;V{ւ̃|C^
	bsr	wrtd0l
~~globl5:
	move.w	(a1)+,d0
	beq	~~globl9
	cmp.w	#','|OT_CHAR,d0
	beq	~~globl2		;܂V{
	bra	iloprerr

~~globl9:
	rts

~~globl00:
	move.l	a0,(ERRMESSYM,a6)
	cmp.b	#SECT_XDEF,d2
	beq	ilsymerr_predefxdef
	cmp.b	#SECT_XREF,d2
	beq	ilsymerr_predefxref
	cmp.b	#SECT_GLOBL,d2
	bra	ilsymerr_predefglobl

;---------------------------------------------------------------
;	.rcomm/.rlcomm
~~rcomm::
	move.w	#SECT_RCOMM,d2
	bra	~~comm1

~~rlcomm::
	move.w	#SECT_RLCOMM,d2
	bra	~~comm1

;---------------------------------------------------------------
;	.comm	<V{>,<>
~~comm::
	move.w	#SECT_COMM,d2
~~comm1:
	move.w	d2,-(sp)
	bsr	encodeopr
	move.w	(sp)+,d2
	lea.l	(OPRBUF,a6),a1
	move.w	(a1)+,d0
	cmp.w	#OT_SYMBOL,d0
	bne	iloprerr		;V{ȊŐLq̓G[
	move.l	(a1)+,a0		;V{e[uւ̃|C^
	tst.b	(SYM_TYPE,a0)		;cmpi.b #ST_VALUE,(SYM_TYPE,a0)
	bne	iloprerr		;lV{łȂ̂ŃG[
	tst.b	(SYM_ATTRIB,a0)
	bne	pseudo_redeferr_a0	;`σV{ȂG[
;vft@CV{͏Œêł̂܂܂ł悢
	move.b	d2,(SYM_EXTATR,a0)
	cmpi.w	#','|OT_CHAR,(a1)+
	bne	iloprerr		;,<>Ȃ
	move.l	a0,-(sp)
	movea.l	a1,a0
	lea.l	(RPNBUF,a6),a1
	bsr	convrpn
	tst.w	d0
	bmi	exprerr			;ϊɎs
	tst.b	(EXPRISSTR,a6)
	bne	iloprerr		;ɕ܂ł
	bsr	calcrpn
	tst.w	d0
	bne	iloprerr		;萔łȂ
	tst.l	d1
	ble	ilvalueerr		;0
	tst.w	(a0)
	bne	iloprerr_pseudo_tail	;sIĂȂ
	movea.l	(sp)+,a0
	move.l	d1,(SYM_VALUE,a0)	;RGATCYZbg
	rts

;---------------------------------------------------------------
;	.text
~~text::
	moveq.l	#SECT_TEXT,d0
~~text1:
;offsym̏I̓ZNV̕ύXĂs
;d0=ZNV
	move.b	(OFFSYMMOD,a6),-(sp)
	sf.b	(OFFSYMMOD,a6)
	bsr	chgsection
	or.w	#T_SECT,d0		;ZNVύX
	bsr	wrtobjd0w
	tst.b	(sp)+
	bgt	offsymtailchk1
	rts

;---------------------------------------------------------------
;	.data
~~data::
	moveq.l	#SECT_DATA,d0
	bra	~~text1

;---------------------------------------------------------------
;	.bss
~~bss::
	moveq.l	#SECT_BSS,d0
	bra	~~text1

;---------------------------------------------------------------
;	.stack
~~stack::
	moveq.l	#SECT_STACK,d0
	bra	~~text1

;---------------------------------------------------------------
~~rdata::
	moveq.l	#SECT_RDATA,d0
~~rdata1:
	st.b	(MAKERSECT,a6)
	bra	~~text1

~~rbss::
	moveq.l	#SECT_RBSS,d0
	bra	~~rdata1

~~rstack::
	moveq.l	#SECT_RSTACK,d0
	bra	~~rdata1

~~rldata::
	moveq.l	#SECT_RLDATA,d0
	bra	~~rdata1

~~rlbss::
	moveq.l	#SECT_RLBSS,d0
	bra	~~rdata1

~~rlstack::
	moveq.l	#SECT_RLSTACK,d0
	bra	~~rdata1

;---------------------------------------------------------------
;	.offsym	<l>,<V{>
~~offsym::
	move.b	(OFFSYMMOD,a6),-(sp)
	move.l	(OFFSYMTMP,a6),-(sp)
	st.b	(OFFSYMMOD,a6)		;offsymŃV{Ȃ
	bsr	calcconst		;d1=l
	cmpi.w	#','|OT_CHAR,(a0)
	bne	~~offsym1
	addq.l	#2,a0
	move.l	d1,(OFFSYMVAL,a6)	;l
	cmpi.w	#OT_SYMBOL,(a0)+
	bne	iloprerr
	movea.l	(a0)+,a1
	tst.w	(a0)
	bne	iloprerr_pseudo_tail	;sIĂȂ
;l^V{̏ԂmF
;`ς݂łG[ɂȂ
	tst.b	(SYM_TYPE,a1)		;cmpi.b #ST_VALUE,(SYM_TYPE,a1)
	bne	pseudo_ilsymerr_a1	;^Cv̈قȂV{ƏdĂ
	cmpi.b	#SA_PREDEFINE,(SYM_ATTRIB,a1)
	beq	pseudo_redeferr_a1
	cmpi.b	#SECT_RLCOMM,(SYM_EXTATR,a1)
	bcc	pseudo_redeferr_a1	;.xref/.commV{
	move.l	a1,(OFFSYMSYM,a6)	;l^V{
;̃V{pӂ
	move.l	#(SYMHASHSIZE-1)<<16,d1	;ʃ[h[JV{ԍƈvȂ
					;SYMHASHSIZE*65536ȏɂ
					;isdefdlocsymŃI[o[t[̂Œ
	move.w	(OFFSYMNUM,a6),d1	;nbV֐l𕪎U邽߂̃JE^
	addq.w	#1,(OFFSYMNUM,a6)
	bsr	isdefdlocsym		;nbV`FČ
					;̃V{Ƃ͐΂ɈvȂ
	bsr	deflocsymbol		;[JV{o^
	move.l	a1,(OFFSYMTMP,a6)	;l^V{̈ʒu
					;P[VJE^i[鉼̃V{
	move.b	#SA_NODET,(SYM_ATTRIB,a1)	;`ꂽl܂ĂȂ
					;ł͎lo͂Ȃ
	moveq.l	#SECT_ABS,d0
	bsr	chgsection
	clr.l	(LOCATION,a6)
	clr.l	(LTOPLOC,a6)
	move.w	#T_OFFSYM,d0
	bsr	wrtobjd0w
	move.l	(OFFSYMVAL,a6),d0	;l
	bsr	wrtd0l
	move.l	(OFFSYMSYM,a6),d0	;V{
	bsr	wrtd0l
	move.l	a1,d0			;V{
	bsr	wrtd0l
	move.b	#1,(OFFSYMMOD,a6)	;lV{ɗ^
	bra	~~offsym2

~~offsym1:
;d1=l
	bsr	~~offset1		;V{Ȃ.offsetƓ
~~offsym2:
	movea.l	(sp)+,a1		;OFFSYMTMP(a6)
	tst.b	(sp)+
	bgt	offsymtailchk2		;.offsym̏I
	rts

;offsymɏIĂ邩ǂmF
;a1j󂷂
offsymtailchk::
	tst.b	(OFFSYMMOD,a6)
	ble	offsymtailchk9		;offsymłȂ,V{Ȃ
offsymtailchk1:
	movea.l	(OFFSYMTMP,a6),a1
;a1=ZNVύXỎ̃V{
offsymtailchk2:
	cmpi.b	#SA_NODET,(SYM_ATTRIB,a1)
	beq	offsymtailchk01		;l܂ĂȂ΃G[
;V{ST_LOCALȂ̂objgen.sŃG[bZ[Wo邱Ƃ͂Ȃ
offsymtailchk9:
	rts

offsymtailchk01:
	move.l	(OFFSYMSYM,a6),(ERRMESSYM,a6)
	bra	undefsymerr

;---------------------------------------------------------------
;	.offset	<>
~~offset::
	move.b	(OFFSYMMOD,a6),-(sp)
	sf.b	(OFFSYMMOD,a6)
	bsr	calcconst
	tst.w	(a0)
	bne	iloprerr_pseudo_tail	;sIĂȂ
	bsr	~~offset1
	tst.b	(sp)+
	bgt	offsymtailchk1
	rts

;d1=̒l
~~offset1:
	moveq.l	#SECT_ABS,d0
	bsr	chgsection
	move.l	d1,(LOCATION,a6)
	move.l	d1,(LTOPLOC,a6)
	move.w	#T_OFFSET,d0
	bsr	wrtobjd0w
	move.l	d1,d0			;ItZbgl
	bra	wrtd0l

;---------------------------------------------------------------
;	.if	<>
~~if::
	bsr	ifcond
	tst.l	d1
	seq.b	d0			;Ȃd0.b=0
~~if1:
	addq.w	#1,(IFNEST,a6)
	tst.b	d0
	beq	~~if9			;d0.b=0Ȃ
~~if2:
	bsr	skipfault		;s̃\[Xǂݔ΂
	cmp.w	#2,d0
	bne	~~if9			;else/endif̏ꍇ
	bsr	ifcond			;elseif̏ꍇ
	tst.l	d1
	seq.b	d0
	tst.b	d0
	bne	~~if2			;ĂѕsɂȂ
~~if9:
	rts

;---------------------------------------------------------------
;	.iff	<>
~~iff::
	bsr	ifcond
	tst.l	d1
	sne.b	d0			;Ȃd0.b=0
	bra	~~if1

;---------------------------------------------------------------
;	.ifdef	<V{>
~~ifdef::
	bsr	symdefchk		;V{o^ςȂd0.b=0
	bra	~~if1

;---------------------------------------------------------------
;	.ifndef	<V{>
~~ifndef::
	bsr	symdefchk
	not.b	d0			;V{o^Ȃd0.b=0
	bra	~~if1

;---------------------------------------------------------------
;	V{o^ςǂ𒲂ׂ
symdefchk:
	bsr	getword
	tst.w	d2
	bmi	iloprerr		;V{Ȃ
	move.b	(a1)+,d0
	beq	symdefchk2
	cmp.b	#',',d0
	beq	iloprerr_pseudo_many	;
	cmp.b	#' ',d0
	bhi	iloprerr		;V{ȊO̕qĂ
symdefchk1:
	move.b	(a1)+,d0
	beq	symdefchk2
	cmp.b	#' ',d0
	bls	symdefchk1
	cmp.b	#',',d0			;V{̌̋󔒂̐̐擪̕
	beq	iloprerr_pseudo_many	;
symdefchk2:
	subq.l	#1,a1
	move.l	a1,(LINEPTR,a6)
	bra	isdefdsym

;---------------------------------------------------------------
;	.if̏s̃\[Xǂݔ΂
skipfault:
	bsr	deflabel		;sɃx`Ă
	clr.w	(IFSKIPNEST,a6)
	st.b	(ISIFSKIP,a6)		;G[`FbN͂Ȃ
skipfault1:
	bsr	getline			;1sǂݍ
	tst.w	d0
	bmi	skipfault9		;ǂݔ΂Ƀ\[XIĂ܂
	or.w	#T_LINE,d0		;1sJn
	bsr	wrtobjd0w
	bsr	encodeline		;x̏Ɩ߂̃R[h
	tst.b	(ISMACRO,a6)
	bne	skipfault1		;}N
	move.l	(CMDTBLPTR,a6),d0
	beq	skipfault1		;߂Ȃ
	movea.l	d0,a1
	move.l	(SYM_FUNC,a1),a1
	lea.l	(~~if,pc),a2
	cmpa.l	a1,a2
	beq	skipfif
	lea.l	(~~iff,pc),a2
	cmpa.l	a1,a2
	beq	skipfif
	lea.l	(~~ifdef,pc),a2
	cmpa.l	a1,a2
	beq	skipfif
	lea.l	(~~ifndef,pc),a2
	cmpa.l	a1,a2
	beq	skipfif
	lea.l	(~~else,pc),a2
	cmpa.l	a1,a2
	beq	skipfelse
	lea.l	(~~elseif,pc),a2
	cmpa.l	a1,a2
	beq	skipfelif
	lea.l	(~~endif,pc),a2
	cmpa.l	a1,a2
	beq	skipfendif
	bra	skipfault1

skipfault9:
	st.b	(ISASMEND,a6)		;I
	clr.w	(IFNEST,a6)
	sf.b	(ISIFSKIP,a6)
	bra	misiferr_eof

skipfif:				;if/iff/ifdef/ifndef
	addq.w	#1,(IFSKIPNEST,a6)
	bra	skipfault1

skipfelse:				;else
	tst.w	(IFSKIPNEST,a6)
	bne	skipfault1
	moveq.l	#1,d0
	bra	skipfend

skipfelif:				;elseif
	tst.w	(IFSKIPNEST,a6)
	bne	skipfault1
	moveq.l	#2,d0
	bra	skipfend

skipfendif:				;endif
	tst.w	(IFSKIPNEST,a6)
	beq	skipfendif1
	subq.w	#1,(IFSKIPNEST,a6)
	bra	skipfault1

skipfendif1:
	subq.w	#1,(IFNEST,a6)
	moveq.l	#0,d0
skipfend:
	sf.b	(ISIFSKIP,a6)
	move.w	#-1,(LABNAMELEN,a6)
	rts

;---------------------------------------------------------------
;	.else
~~else::
	tst.w	(IFNEST,a6)
	beq	misiferr_else
	bsr	skipfault
	cmp.w	#2,d0
	beq	misiferr_else_elseif	;elsěelseif
	rts

;---------------------------------------------------------------
;	.elseif	<>
~~elseif::
	tst.w	(IFNEST,a6)
	beq	misiferr_elseif
	bsr	skipfault
	subq.w	#1,d0
	beq	~~else
	bcc	~~elseif
	rts

;---------------------------------------------------------------
;	.endif
~~endif::
	tst.w	(IFNEST,a6)
	beq	misiferr_endif
	subq.w	#1,(IFNEST,a6)
	rts

;---------------------------------------------------------------
;	.end	[<x>]
~~end::
	st.b	(ISASMEND,a6)
	move.b	(a0),d0
	cmp.b	#'*',d0
	beq	~~end9
	cmp.b	#';',d0
	beq	~~end9
	bsr	encodeopr
	lea.l	(OPRBUF,a6),a0
	lea.l	(RPNBUF,a6),a1
	tst.w	(a0)
	beq	~~end9			;JnAhXw肪Ȃ
	bsr	convrpn
	tst.w	d0
	bmi	exprerr			;ϊɎs
	move.w	d1,d2
	tst.b	(EXPRISSTR,a6)
	bne	iloprerr		;ɕ܂ł
	bsr	calcrpn
	tst.w	d0
	beq	iloprerr		;<>AhXłȂ
	tst.w	(a0)
	bne	iloprerr_pseudo_tail	;sIĂȂ
	move.w	#T_END,d0
	bsr	wrtobjd0w
	moveq.l	#SZ_LONG,d0
	move.w	d2,d1
	bra	wrtrpn			;̏o

~~end9:
	rts

;---------------------------------------------------------------
;	.insert	<t@C>[,<ItZbg>,<TCY>]
~~insert::
	tst.b	(a0)
	beq	iloprerr		;t@C̎w肪Ȃ
	lea.l	(OPRBUF,a6),a1
~~insert1:
	move.b	(a0)+,d0
	move.b	d0,(a1)+
	cmp.b	#',',d0
	beq	~~insert2
	cmp.b	#' ',d0
	bhi	~~insert1
~~insert2:
	subq.l	#1,a0
	clr.b	(-1,a1)

	clr.w	-(sp)
	pea.l	(OPRBUF,a6)
	DOS	_OPEN
	addq.l	#6,sp
	move.l	d0,d3			;d3=t@Cnh
	bmi	nofileerr		;t@CȂ

	move.l	d3,-(sp)
	bsr	encodeopr
	move.l	(sp)+,d3

	tst.b	(ISOBJOUT,a6)
	bne	~~insert2_1
	bsr	flushobj		;IuWFNgobt@tbV
~~insert2_1:

	moveq.l	#0,d2			;ItZbg
	moveq.l	#-1,d1			;TCY

	lea.l	(OPRBUF,a6),a0
	cmpi.w	#','|OT_CHAR,(a0)
	bne	~~insert4
~~insert_param_loop:
	bsr	~~insert_calcopr
	move.l	d1,d2			;d2=ItZbg

	moveq.l	#-1,d1			;TCY

	cmpi.w	#','|OT_CHAR,(a0)
	bne	~~insert4
	bsr	~~insert_calcopr
					;d1=c̃TCY
~~insert4:
	tst.l	d1
	beq	~~insert8
	movea.l	d1,a1			;a1=w肳ꂽTCY

	clr.w	-(sp)
	move.l	d2,-(sp)		;ItZbg
	move.w	d3,-(sp)
	DOS	_SEEK
	addq.l	#8,sp
	tst.l	d0
	bmi	~~insert_seek_error	;w肳ꂽʒu܂ŃV[NłȂ

~~insert_read_loop:
	movea.w	#256,a2			;]TCY
	cmp.l	a2,d1
	bcc	~~insert6
	move.l	d1,a2			;d1>=256łȂd1]
~~insert6:
	move.l	a2,-(sp)		;̃TCY
	pea.l	(OBJCONBUF,a6)		;IuWFNgobt@ɒړǂݏo
	move.w	d3,-(sp)
	DOS	_READ
	addq.l	#10-4,sp
	move.l	d0,(sp)+
	bmi	~~insert_size_error	;w肳ꂽTCYǂݏoȂ
	cmp.l	a2,d0
	beq	~~insert7		;̃TCYǂݏo
	cmpa.w	#-1,a1
	bne	~~insert_size_error	;TCYw肳ꂽ̂,
					;̃TCYǂݏoȂ.
					;܂,w肳ꂽTCYǂݏoȂ
	movea.l	d0,a2			;TCYw肳ĂȂ̂,
	move.l	a2,d1			;ŏIɂ
~~insert7:
	add.l	d0,(LOCATION,a6)	;P[VJE^XV

	tst.b	(ISOBJOUT,a6)
	bne	~~insert7_1
	move.w	d0,(OBJCONCTR,a6)	;IuWFNg̃TCYw肷(0`256)
	bsr	flushobj		;IuWFNgo͂
	tst.b	(MAKEPRN,a6)
	beq	~~insert7_0
	move.w	#T_PRNADV,d0
	bsr	wrtobjd0w
~~insert7_0:
~~insert7_1:

	sub.l	a2,d1			;c̃TCY
	bne	~~insert_read_loop
~~insert8:
	cmpi.w	#','|OT_CHAR,(a0)
	beq	~~insert_param_loop

~~insert_close:
	move.w	d3,-(sp)
	DOS	_CLOSE
	addq.l	#2,sp
	rts

~~insert_calcopr:
	addq.l	#2,a0
	lea.l	(RPNBUF,a6),a1
	bsr	convrpn
	tst.w	d0
	bmi	exprerr			;ϊɎs
	bsr	calcrpn
	tst.w	d0
	bne	ilvalueerr		;萔łȂ
	rts

~~insert_seek_error:
~~insert_size_error:
	bsr	~~insert_close
	bra	ilvalueerr

;---------------------------------------------------------------
;	.include	<t@C>
~~include::
	tst.b	(a0)
	beq	iloprerr		;t@C̎w肪Ȃ
	lea.l	(OPRBUF,a6),a1
~~include1:
	move.b	(a0)+,d0
	move.b	d0,(a1)+
	cmp.b	#' ',d0
	bhi	~~include1
	clr.b	(-1,a1)
	lea.l	(OPRBUF,a6),a0
	bsr	srchincld		;CN[ht@C
	tst.w	d0
	bmi	nofileerr
	bsr	openincld
	tst.w	d0
	bmi	nofileerr
	move.w	#T_INCLD,d0
	bsr	wrtobjd0w
	move.l	a0,d0
	bra	wrtd0l			;t@Cւ̃|C^

;---------------------------------------------------------------
;	.request	<t@C>[,<t@C>,c]
~~request::
	tst.b	(a0)
	beq	iloprerr		;t@C̎w肪Ȃ
~~request1:
	move.l	(TEMPPTR,a6),d0
	doeven	d0
	movea.l	(REQFILEND,a6),a1
	move.l	d0,(a1)
	move.l	d0,(REQFILEND,a6)
	movea.l	d0,a1
	clr.l	(a1)+
	bsr	getpara
	move.l	a1,(TEMPPTR,a6)
	tst.w	d0
	bne	~~request1
	move.l	a0,(LINEPTR,a6)
	bra	memcheck

;---------------------------------------------------------------
;	.list
~~list::
	moveq.l	#1,d0
~~list1:
	or.w	#T_LIST,d0
	bra	wrtobjd0w

;---------------------------------------------------------------
;	.nlist
~~nlist::
	moveq.l	#2,d0
	bra	~~list1

;---------------------------------------------------------------
;	.sall
~~sall::
	moveq.l	#3,d0
	bra	~~list1

;---------------------------------------------------------------
;	.lall
~~lall::
	moveq.l	#4,d0
	bra	~~list1

;---------------------------------------------------------------
;	.width	<>
~~width::
	bsr	calcconst		;<>̒l80`255
	cmp.l	#256,d1
	bcc	ilvalueerr
	cmp.w	#80,d1
	bcs	ilvalueerr
	and.w	#$FFF8,d1
	move.w	d1,(PRNWIDTH,a6)
	rts

;---------------------------------------------------------------
;	.page	[+/<>]
~~page::
	bsr	encodeopr
	lea.l	(OPRBUF,a6),a0
	lea.l	(RPNBUF,a6),a1
	bsr	convrpn
	tst.w	d0
	bmi	~~page2			;ϊɎs
	tst.b	(EXPRISSTR,a6)
	bne	iloprerr		;ɕ܂ł
	bsr	calcrpn
	tst.w	d0
	bne	iloprerr		;<>萔łȂ
	tst.l	d1
	bmi	~~page1
	cmp.l	#256,d1
	bcc	ilvalueerr
	cmp.w	#10,d1
	bcs	ilvalueerr
	move.w	d1,(PRNPAGEL,a6)	;<>̒l10`255
	rts

~~page1:
	move.w	#-1,(PRNPAGEL,a6)
	rts

~~page2:
	moveq.l	#0,d0
	movea.l	(LINEPTR,a6),a0
	cmpi.b	#'+',(a0)
	bne	~~page3
	moveq.l	#1,d0			;.page +
~~page3:
	or.w	#T_PAGE,d0
	bra	wrtobjd0w

;---------------------------------------------------------------
;	.title	<>
~~title::
	movea.l	(TEMPPTR,a6),a1
	move.l	a1,(PRNTITLE,a6)
~~title1:				;^Cg𓾂
	move.b	(a0)+,(a1)+
	bne	~~title1
	move.l	a1,(TEMPPTR,a6)
	bra	memcheck

;---------------------------------------------------------------
;	.subttl	<>
~~subttl::
	movea.l	(TEMPPTR,a6),a1
	move.w	#T_SUBTTL,d0
	bsr	wrtobjd0w
	move.l	a1,d0
	bsr	wrtd0l
	bra	~~title1

;---------------------------------------------------------------
;	.comment	<>
~~comment::
	bsr	deflabel		;sɃx`Ă
	move.w	#-1,(LABNAMELEN,a6)
	lea.l	(OPRBUF,a6),a1
	tst.b	(a0)
	beq	~~comment85		;񂪂ȂΎ̈ŝ݂RgƂ
~~comment1:				;RgI𓾂
	move.b	(a0)+,d0
	cmp.b	#' ',d0
	bls	~~comment2
	move.b	d0,(a1)+
	bra	~~comment1

~~comment2:
	clr.b	(a1)
~~comment3:
	bsr	getline			;1sǂݍ
	tst.w	d0
	bmi	~~comment9		;ǂݔ΂Ƀ\[XIĂ܂
	or.w	#T_LINE,d0		;1sJn
	bsr	wrtobjd0w
	lea.l	(LINEBUF,a6),a0
~~comment4:
	bsr	skipspc
	tst.b	(a0)
	beq	~~comment3
	lea.l	(OPRBUF,a6),a1
~~comment5:
	move.b	(a1)+,d0
	beq	~~comment6
	cmp.b	(a0)+,d0
	beq	~~comment5
	bra	~~comment7

~~comment6
	cmpi.b	#' ',(a0)+
	bls	~~comment9
~~comment7:
	subq.l	#1,a0
~~comment8:
	cmpi.b	#' ',(a0)+
	bhi	~~comment8
	subq.l	#1,a0
	bra	~~comment4

~~comment85:				;1ŝ݂RgƂ
	bsr	getline			;1sǂݍ
	tst.w	d0
	bmi	~~comment9		;ǂݔ΂Ƀ\[XIĂ܂
	or.w	#T_LINE,d0		;1sJn
	bsr	wrtobjd0w
~~comment9:
	rts

;---------------------------------------------------------------
;	.fail	<>
~~fail::
	bsr	ifcond
	tst.l	d1
	bne	forcederr
	rts

;---------------------------------------------------------------
;	.cpu	<>
~~cpu::
	bsr	calcconst
	pea.l	(~~cpu9,pc)		;Ōɍs̏I`FbN
					;Ĉȍ~a0j󂵂Ă͂ȂȂ
	cmp.l	#68000,d1
	beq	~~cpu_68000_change
	cmp.l	#68010,d1
	beq	~~cpu_68010_change
	cmp.l	#68020,d1
	beq	~~cpu_68020_change
	cmp.l	#68030,d1
	beq	~~cpu_68030_change
	cmp.l	#68040,d1
	beq	~~cpu_68040_change
	cmp.l	#68060,d1
	beq	~~cpu_68060_change
	cmp.l	#5200,d1
	beq	~~cpu_5200_change
	cmp.l	#5300,d1
	beq	~~cpu_5300_change
	cmp.l	#5400,d1
	beq	~~cpu_5400_change
	bra	featureerr_cpu		;CPU͖T|[g

~~cpu_68000_change:
	bsr	~~cpu_changesymbol
~~cpu_68000::
	move.l	#68000,-(sp)
	bsr	~~cpu_setsymbol
	addq.l	#4,sp
	move.w	#C000,(CPUTYPE,a6)
	bra	~~cpu_word0

~~cpu_68010_change:
	bsr	~~cpu_changesymbol
~~cpu_68010::
	move.l	#68010,-(sp)
	bsr	~~cpu_setsymbol
	addq.l	#4,sp
	move.w	#C010,(CPUTYPE,a6)
~~cpu_word0:
;F43G΍̃V[PXJbg
	bsr	f43gcut
;F43G΍sȂ
	sf.b	(F43GTEST,a6)
~~cpu_word:				;fBXv[Xg̓[ĥ
	sf.b	(EXTSIZEFLG,a6)
	move.b	#SZ_WORD,(EXTSIZE,a6)
	move.l	#2,(EXTLEN,a6)
	rts

~~cpu_68020_change:
	bsr	~~cpu_changesymbol
~~cpu_68020::
	move.l	#68020,-(sp)
	bsr	~~cpu_setsymbol
	addq.l	#4,sp
	move.w	#C020|CFPP|CMMU,(CPUTYPE,a6)
	bra	~~cpu_long

~~cpu_68030_change:
	bsr	~~cpu_changesymbol
~~cpu_68030::
	move.l	#68030,-(sp)
	bsr	~~cpu_setsymbol
	addq.l	#4,sp
	move.w	#C030|CFPP,(CPUTYPE,a6)
	bra	~~cpu_long

~~cpu_68040_change:
	bsr	~~cpu_changesymbol
~~cpu_68040::
	move.l	#68040,-(sp)
	bsr	~~cpu_setsymbol
	addq.l	#4,sp
	move.w	#C040,(CPUTYPE,a6)
	bra	~~cpu_long0

~~cpu_68060_change:
	bsr	~~cpu_changesymbol
~~cpu_68060::
	move.l	#68060,-(sp)
	bsr	~~cpu_setsymbol
	addq.l	#4,sp
	move.w	#C060,(CPUTYPE,a6)
~~cpu_long0:
	move.w	#1<<9,(FPCPID,a6)	;68040FPU ID1̂
~~cpu_long:
	tst.b	(F43GTEST,a6)
	bne	~~cpu_f43gset
	tst.b	(IGNORE_ERRATA,a6)
	seq.b	(F43GTEST,a6)
;IGNORE_ERRATAONłR[h͏邱
;(-k1 -m68060 -k0̂Ƃ-k0ł̓R[hȂ)
;R[hĂȂΏ
	movem.l	d0/a0,-(sp)
	lea.l	(F43GREC,a6),a0
	move.l	a0,(F43GPTR,a6)
	moveq.l	#5-1,d0
~~cpu_f43gloop:
;	clr.l	(8,a0)
	clr.w	(12,a0)
	lea.l	(-16,a0),a0
	move.l	a0,(16+4,a0)
	lea.l	(16*2,a0),a0
	move.l	a0,(-16,a0)
	dbra	d0,~~cpu_f43gloop
	lea.l	(F43GREC,a6),a0
	move.l	a0,(16*4,a0)
	lea.l	(F43GREC+16*4,a6),a0
	move.l	a0,(-16*4+4,a0)
	movem.l	(sp)+,d0/a0
~~cpu_f43gset:
	bra	~~cpu_long2

~~cpu_5200_change:
	bsr	~~cpu_changesymbol
~~cpu_5200::
	move.l	#5200,-(sp)
	bsr	~~cpu_setsymbol
	addq.l	#4,sp
	move.w	#C520,(CPUTYPE,a6)
	bra	~~cpu_long3

~~cpu_5300_change:
	bsr	~~cpu_changesymbol
~~cpu_5300::
	move.l	#5300,-(sp)
	bsr	~~cpu_setsymbol
	addq.l	#4,sp
	move.w	#C530,(CPUTYPE,a6)
	bra	~~cpu_long3

~~cpu_5400_change:
	bsr	~~cpu_changesymbol
~~cpu_5400::
	move.l	#5400,-(sp)
	bsr	~~cpu_setsymbol
	addq.l	#4,sp
	move.w	#C540,(CPUTYPE,a6)
~~cpu_long3:
	bsr	f43gcut			;F43G΍̃V[PXJbg
	sf.b	(F43GTEST,a6)		;F43G΍sȂ
~~cpu_long2:
	tst.b	(EXTSHORT,a6)
	beq	~~cpu_word		;OQƃftHg̓[h
	st.b	(EXTSIZEFLG,a6)
	move.b	#SZ_LONG,(EXTSIZE,a6)	;fBXv[XgO[hɂ
	move.l	#4,(EXTLEN,a6)
	rts

;---------------------------------------------------------------
;<d1.l:CPU
~~cpu_changesymbol:
	tst.l	(CPUSYMBOL,a6)
	beq	~~cpu_changesymbol9
	move.l	d0,-(sp)
	move.w	#T_EQUCONST,d0
	bsr	wrtobjd0w
	move.l	(CPUSYMBOL,a6),d0
	bsr	wrtd0l
	move.l	d1,d0
	bsr	wrtd0l
	move.l	(sp)+,d0
~~cpu_changesymbol9:
	rts

;---------------------------------------------------------------
;<4(sp).l:CPU
~~cpu_setsymbol:
	tst.l	(CPUSYMBOL,a6)
	beq	~~cpu_setsymbol9
	move.l	a1,-(sp)
	movea.l	(CPUSYMBOL,a6),a1
	move.l	(4+4,sp),(SYM_VALUE,a1)
	movea.l	(sp)+,a1
~~cpu_setsymbol9:
	rts

;---------------------------------------------------------------
~~cpu9:
	pea.l	(pseudo_tail_check,pc)
wrtcpu::
	move.w	#T_CPU,d0
	bsr	wrtobjd0w
	move.w	(CPUTYPE,a6),d0
	bra	wrtobjd0w

;---------------------------------------------------------------
;	.org	<>
~~org::
	bsr	calcconst
	move.l	d1,(LOCATION,a6)	;P[VJE^ύX
	addq.b	#1,(ORGNUM,a6)
	move.w	#T_ORG,d0
	bsr	wrtobjd0w
	move.l	d1,d0
	bra	wrtd0l			;JE^l


;---------------------------------------------------------------
;	SCDΉ^߂̃AZu
;---------------------------------------------------------------

;---------------------------------------------------------------
;	AZuV{bNfobOpɃt@C̏o͏
setsymdebfile::
	tst.b	(MAKESYMDEB,a6)
	beq	checksymdeb9		;'-g'XCb`͎w肳ĂȂ
	movea.l	(TEMPPTR,a6),a1
	movea.l	(SOURCEFILE,a6),a2	;\[Xt@Cւ̃|C^
	move.l	a2,(SCDFILE,a6)
	bra	~~file3

;---------------------------------------------------------------
;	e|ɃV{bNfobOR[ho͂邩`FbN
checksymdeb:
	tst.b	(MAKESCD,a6)
	beq	checksymdeb8		;SCDtOĂȂ
checksymdeb1:
	tst.b	(MAKESYMDEB,a6)
	beq	checksymdeb9
checksymdeb8:
	addq.l	#4,sp			;'-g'XCb`̂,SCD^߂͖
checksymdeb9:
	rts

;---------------------------------------------------------------
;	.file	"<t@C>"
~~file::
	bsr	checksymdeb1		;'-g'XCb`̃`FbN
	cmpi.b	#'"',(a0)+
	bne	iloprerr
	movea.l	(TEMPPTR,a6),a1
	movea.l	a1,a2			;t@Cobt@ɕۑ
	moveq.l	#0,d1			;t@C
~~file1:
	move.b	(a0)+,d0
	cmp.b	#'"',d0
	beq	~~file2
	cmp.b	#' ',d0
	bls	iloprerr
	move.b	d0,(a1)+
	addq.w	#1,d1
	bra	~~file1

~~file2:
	clr.b	(a1)+
	move.l	a1,(TEMPPTR,a6)
	st.b	(MAKESCD,a6)		;SCDtO𗧂Ă
	move.l	a2,(SCDFILE,a6)		;t@Cւ̃|C^
	clr.l	(SCDFILENUM,a6)		;V{e[u͎gpȂ
	cmpi.w	#14,d1
	bls	memcheck
~~file3:				;t@C14ȏ̏ꍇ
	movea.l	a2,a0
	move.l	a1,d0
	doeven	d0
	movea.l	d0,a4
	move.l	(EXNAMEPTR,a6),d0
	bne	~~file5
	move.l	a4,(EXNAMEPTR,a6)	;ŏ̉V{̏ꍇ
	lea.l	(10,a4),a2
	move.l	a2,(a4)+		;`FCȂ
	clr.l	(a4)+			;擪̃ItZbg
	clr.w	(a4)+			;{(kXgO)
	clr.l	(a4)+			;̉V{ւ̃|C^
	moveq.l	#2,d1
	move.l	d1,(a4)+		;ItZbg(=2)
	move.l	d1,(SCDFILENUM,a6)	;(ItZbg0͉e[ugpȂƂ
	bra	~~def35			;ӖȂ̂,_~[̃e[u쐬)

~~file5:
	movea.l	d0,a3
	move.l	(a3),d0
	bne	~~file3			;V{`FC̖T
	move.l	a4,(a3)			;`FCȂ
	clr.l	(a4)+			;̉V{ւ̃|C^
	move.l	(EXNAMELEN,a6),d1
	move.l	d1,(a4)+		;e[u擪̃ItZbg
	move.l	d1,(SCDFILENUM,a6)
	bra	~~def35			;{̂obt@Ɋi[

;---------------------------------------------------------------
;	.ln	<sԍ>[,<P[Vl>]
~~ln::
	bsr	checksymdeb		;'-g'XCb`̃`FbN
	bsr	calcconst
	move.w	d1,d3
	cmp.l	#$10000,d1
	bcc	ilvalueerr		;sԍ16bit
	lea.l	(RPNBUF,a6),a1
	move.w	(a0)+,d0
	beq	~~ln2			;P[Vlȗꂽ
	cmp.w	#',',d0
	bne	iloprerr
	bsr	convrpn			;P[Vl̎w肪ꍇ
	tst.w	d0
	bmi	exprerr			;ϊłȂ
	tst.b	(EXPRISSTR,a6)
	bne	iloprerr		;ɕ܂ł
~~ln1:
	addq.l	#1,(NUMOFLN,a6)
	move.w	#T_LN,d0
	bsr	wrtobjd0w
	move.w	d3,(SCDLN,a6)
	move.w	d3,d0
	bsr	wrtd0w
	moveq.l	#2,d0
	bra	wrtrpn			;̏o

~~ln2:
	move.w	#RPN_LOCATION,(a1)	;݂̃P[VJE^l
	moveq.l	#1,d1
	bra	~~ln1

;---------------------------------------------------------------
;	.def	<V{>
~~def::
	bsr	checksymdeb		;'-g'XCb`̃`FbN
	cmpi.b	#' ',(a0)
	bls	iloprerr		;IyhȂ
	lea.l	(SCDTEMP,a6),a1
	moveq.l	#9-1,d0
~~def1:
	clr.l	(a1)+			;gV{ꎞobt@NA
	dbra	d0,~~def1
	move.w	(SCDLN,a6),(SCD_SIZE+SCDTEMP,a6)	;????
	clr.w	(SCDLN,a6)
	movea.l	a0,a2
	lea.l	(SCD_NAME+SCDTEMP,a6),a1
	movea.l	a1,a3
	moveq.l	#8,d1
~~def2:
	move.b	(a2)+,d0
	cmp.b	#' ',d0
	bls	~~def4
	move.b	d0,(a3)+
	dbra	d1,~~def2
	clr.b	-(a3)			;V{8ȏ̏ꍇ
	clr.l	(a1)+
	lea.l	(EXNAMEPTR,a6),a3
~~def31:				;V{`FC1ǂ
	move.l	(a3),d0
	beq	~~def34
	movea.l	d0,a3
	lea.l	(8,a3),a4
	movea.l	a0,a2
~~def32:				;łɓ̃V{邩ǂ𒲂ׂ
	move.b	(a2)+,d0
	cmp.b	#' ',d0
	bls	~~def33
	cmp.b	(a4)+,d0
	beq	~~def32
	bra	~~def31

~~def33:
	tst.b	(a4)
	bne	~~def31
	move.l	(4,a3),(a1)		;̃V{݂
	rts

~~def34:				;̃V{Ȃ̂ŐVɓo^
	move.l	(TEMPPTR,a6),d0
	addq.l	#1,d0
	bclr.l	#0,d0
	movea.l	d0,a4
	move.l	a4,(a3)			;`FCȂ
	clr.l	(a4)+			;̉V{ւ̃|C^
	move.l	(EXNAMELEN,a6),d1
	move.l	d1,(a4)+		;e[u擪̃ItZbg
	move.l	d1,(a1)
~~def35:				;{̂i[
	move.b	(a0)+,d0
	move.b	d0,(a4)+
	addq.l	#1,d1
	cmp.b	#' ',d0
	bhi	~~def35
	clr.b	(-1,a4)
	move.l	a4,(TEMPPTR,a6)
	addq.l	#1,d1
	bclr.l	#0,d1
	move.l	d1,(EXNAMELEN,a6)
	bra	memcheck

~~def4:					;V{ǂ`FbN
	lea.l	(scdsp_name,pc),a1
~~def5:
	lea.l	(SCD_NAME+SCDTEMP,a6),a0
~~def6:
	move.b	(a1)+,d0
	cmp.b	(a0)+,d0
	bne	~~def8
	tst.b	d0
	bne	~~def6
	move.b	(a1),(SCDATTRIB,a6)	;V{R[h
	move.b	#1,(SCD_LEN+SCDTEMP,a6)	;e[u̓Of[^
	rts

~~def7:
	addq.l	#1,a1
~~def8:
	tst.b	(-1,a1)
	bne	~~def7
	addq.l	#1,a1
	tst.b	(a1)
	bne	~~def5
	rts				;V{łȂ

;---------------------------------------------------------------
;	.endef
~~endef::
	bsr	checksymdeb		;'-g'XCb`̃`FbN
	move.b	(SCDATTRIB,a6),d2
	move.b	d2,d0
	andi.b	#$0F,d0
	bne	~~endef1
	move.w	(SCD_TYPE+SCDTEMP,a6),d1
	andi.w	#$0030,d1
	cmpi.w	#$0020,d1		;֐
	beq	~~endef04
	move.b	(SCD_SCL+SCDTEMP,a6),d1
	moveq.l	#$11,d2			;^O`Jn
	cmpi.b	#10,d1			;struct^O
	beq	~~endef05
	cmpi.b	#12,d1			;union^O
	beq	~~endef05
	cmpi.b	#15,d1			;enum^O
	beq	~~endef05
	moveq.l	#$50,d2
	cmpi.b	#2,d1			;externϐ
	beq	~~endef1
	cmpi.b	#80,d1			;externϐ(SXhas remote)
	beq	~~endef1
	cmpi.b	#82,d1			;externϐ(SXhas relocate)
	beq	~~endef1
	move.b	(SCDATTRIB,a6),d2	;staticϐ/̑
	bne	~~endef1
	moveq.l	#$30,d2
	bra	~~endef1

~~endef04:
	moveq.l	#$21,d2			;֐`Jn
	addq.l	#1,(NUMOFLN,a6)
~~endef05:
	move.b	#1,(SCD_LEN+SCDTEMP,a6)	;e[u̓Of[^
	move.w	(SCDATTRIB,a6),d0
	move.b	d2,d0
	ror.w	#8,d0
	move.w	d0,(SCDATTRIB,a6)
~~endef1:
	cmp.b	#$2F,d2
	beq	~~endef5		;.scl -1 ̏ꍇf[^o͂͂Ȃ
	moveq.l	#T_ENDEFS>>8,d0
	moveq.l	#0,d3
	move.b	(SCD_LEN+SCDTEMP,a6),d3
	add.w	d3,d0
	lsl.w	#8,d0			;IuWFNgR[hT_ENDEFS/T_ENDEFL
	addq.l	#1,d3			;gpe[u
	move.b	d2,d0			;f[^^
	bsr	wrtobjd0w
	lea.l	(SCD_NAME+SCDTEMP,a6),a0
	moveq.l	#4-1,d1
~~endef2:
	move.w	(a0)+,d0
	bsr	wrtd0w			;V{o
	dbra	d1,~~endef2
	addq.l	#6,a0
	move.w	(a0)+,d0
	bsr	wrtd0w			;.type
	move.w	(a0)+,d0
	bsr	wrtd0w			;.scl
	tst.b	d0
	beq	~~endef4
	addq.l	#4,a0
	moveq.l	#6-1,d1
~~endef3:
	move.w	(a0)+,d0
	bsr	wrtd0w			;Of[^̏ꍇ.size/.line/.dimo
	dbra	d1,~~endef3
~~endef4:
	and.w	#$00F0,d2
	lsr.w	#2,d2
	lea.l	(NUMOFSCD,a6),a0
	add.l	d3,(a0)			;gpe[uJE^i߂
	add.l	d3,(a0,d2.w)
~~endef5:
	move.w	(SCDATTRIB,a6),d0
	move.w	#$F0FF,d1
	and.w	d0,d1
	andi.w	#$0F00,d0
	cmpi.w	#$0F00,d0
	bne	~~endef6
	lsl.w	#8,d1			;^O/֐`̏I
~~endef6:
	move.w	d1,(SCDATTRIB,a6)
	rts

;---------------------------------------------------------------
;	.val	<>
~~val::
	bsr	checksymdeb		;'-g'XCb`̃`FbN
	cmpi.b	#'.',(a0)
	bne	~~val1
	cmpi.b	#' ',(1,a0)
	bhi	~~val1
	move.b	#'*',(a0)		;.val .    .val *
~~val1:
	bsr	encodeopr
	lea.l	(OPRBUF,a6),a0
	lea.l	(RPNBUF,a6),a1
	bsr	convrpn
	tst.w	d0
	bmi	exprerr			;ϊłȂ
	move.w	#T_VAL,d0
	bsr	wrtobjd0w
	moveq.l	#2,d0
	bra	wrtrpn			;̏o

;---------------------------------------------------------------
;	.scl	<>
~~scl::
	bsr	checksymdeb		;'-g'XCb`̃`FbN
	bsr	calcconst
	cmp.l	#-1,d1
	beq	~~scl9
	cmp.l	#$100,d1
	bcc	ilvalueerr
	move.b	d1,(SCD_SCL+SCDTEMP,a6)
	rts

~~scl9:					;.scl -1 (֐`̏I)
	move.b	#$2F,(SCDATTRIB,a6)	;.endefł̏o͂͂Ȃ
	move.w	#T_SCL,d0
	bra	wrtobjd0w

;---------------------------------------------------------------
;	.type	<>
~~type::
	bsr	checksymdeb		;'-g'XCb`̃`FbN
	bsr	calcconst
	cmp.l	#$10000,d1
	bcc	ilvalueerr
	move.w	d1,(SCD_TYPE+SCDTEMP,a6)
	and.w	#$0030,d1
	cmp.w	#$0030,d1		;z
	beq	~~type8
	cmp.w	#$0020,d1		;֐
	bne	~~type9
~~type8:
	move.b	#1,(SCD_LEN+SCDTEMP,a6)	;e[u̓Of[^
~~type9:
	rts

;---------------------------------------------------------------
;	.tag	<^O>
~~tag::
	bsr	checksymdeb		;'-g'XCb`̃`FbN
	movea.l	(TEMPPTR,a6),a1
	move.w	#T_TAG,d0
	bsr	wrtobjd0w
	move.l	a1,d0			;^Oւ̃|C^
	bsr	wrtd0l
	move.b	#1,(SCD_LEN+SCDTEMP,a6)	;e[u̓Of[^
	bra	~~title1		;w肳ꂽ^OɊi[

;---------------------------------------------------------------
;	.line	<>
~~line::
	bsr	checksymdeb		;'-g'XCb`̃`FbN
	bsr	calcconst
	move.b	#1,(SCD_LEN+SCDTEMP,a6)	;e[u̓Of[^
	move.w	d1,(SCD_SIZE+SCDTEMP,a6)
	rts

;---------------------------------------------------------------
;	.size	<>
~~size::
	bsr	checksymdeb		;'-g'XCb`̃`FbN
	bsr	calcconst
	tst.l	d1
	beq	~~size9
	move.b	#1,(SCD_LEN+SCDTEMP,a6)	;e[u̓Of[^
	move.l	d1,(SCD_SIZE+SCDTEMP,a6)
~~size9:
	rts

;---------------------------------------------------------------
;	.dim	<1>[,<2>c]
~~dim::
	bsr	checksymdeb		;'-g'XCb`̃`FbN
	bsr	encodeopr
	move.b	#1,(SCD_LEN+SCDTEMP,a6)	;e[u̓Of[^
	moveq.l	#4-1,d2
	lea.l	(OPRBUF,a6),a0
	lea.l	(SCD_DIM+SCDTEMP,a6),a2
~~dim1:
	lea.l	(RPNBUF,a6),a1
	bsr	convrpn
	tst.w	d0
	bmi	exprerr			;ϊłȂ
	tst.b	(EXPRISSTR,a6)
	bne	iloprerr		;ɕ܂ł
	bsr	calcrpn
	tst.w	d0
	bne	iloprerr		;萔łȂ
	move.w	d1,(a2)+
	cmp.w	#',',(a0)+
	bne	~~dim2
	dbra	d2,~~dim1
~~dim2:
	tst.w	-(a0)
	bne	iloprerr
	rts

.ifdef	DO_CDTOR
;---------------------------------------------------------------
;	.doctor
~~doctor::
		st	(DOCTOR_FLAG,a6)
		rts

;---------------------------------------------------------------
;	.dodtor
~~dodtor::
		st	(DODTOR_FLAG,a6)
		rts

;---------------------------------------------------------------
;	.ctor	<x>[,<x>...]
~~ctor::
		bsr	encodeopr
		lea	(CTORSIZE,a6),a2
		move	#T_CTOR,-(sp)
		bra	@f

;---------------------------------------------------------------
;	.dtor	<x>[,<x>...]
~~dtor::
		bsr	encodeopr
		lea	(DTORSIZE,a6),a2
		move	#T_DTOR,-(sp)
@@:
		lea	(OPRBUF,a6),a0
~~ctordtor_loop:
		move	(a0),d0
		beq	iloprerr
		lea	(RPNBUF,a6),a1
		bsr	convrpn
		tst	d0
		bmi	exprerr
		move	(sp),d0
		bsr	wrtobjd0w
		move	d1,d2
		bsr	calcrpn
		moveq	#SZ_LONG,d0
		move	d2,d1
		bsr	wrtrpn
		addq.l	#4,(a2)
		move	(a0)+,d0
		beq	@f
		cmpi	#','|OT_CHAR,d0
		beq	~~ctordtor_loop
		bra	iloprerr
@@:		addq.l	#2,sp
		rts
.endif	/* DO_CDTOR */

;---------------------------------------------------------------
;	SCDpV{
scdsp_name:	.dc.b	'.eos',0,$1F,'.bb',0,$2B,'.eb',0,$2C,'.bf',0,$2D,'.ef',0,$2E,0
	.even


;---------------------------------------------------------------
	.end

;---------------------------------------------------------------
;	$Log: pseudo.s,v $
;	Revision 1.21  1999 10/ 8(Fri) 21:00:37 M.Kamada
;	+86 ilsymerrו
;	+86 '%s ɊOQƒl͎wł܂'
;	+86 foo fequ foõG[bZ[W
;
;	Revision 1.20  1999  6/ 9(Wed) 23:37:40 M.Kamada
;	+85 .offsymŃV{w肪Ƃ.even/.quad/.alignG[ɂ
;	+85 .ds̈̂Ƃ.text/.dataZNVł̓G[,̑̓[jO
;
;	Revision 1.19  1999  3/15(Mon) 18:20:37 M.Kamada
;	+83 ^߂̃p[^ԈĂƂɑƕ\邱Ƃ
;	+83 .cpüԈĂƂق̃G[D悵Ă
;
;	Revision 1.18  1999  3/ 3(Wed) 15:04:45 M.Kamada
;	+82 G[bZ[W{ꉻ
;	+82 ^߂̃p[^ꍇ̃G[`FbN
;	+82 doevendoquad
;	+82 F43GREC̃TCY1416oCg
;
;	Revision 1.17  1999  2/27(Sat) 23:44:21 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 1.16  1999  2/25(Thu) 05:50:36 M.Kamada
;	+80 ColdFireΉ
;	+80 .dcŕAċLqł
;	+80 .offsym <l>,<V{>
;	+80 setsetȊOŒ`ꂽV{̏㏑֎~
;	+80 +79.DC̃TCY̌ʎw̏Cs\
;
;	Revision 1.15  1999  2/11(Thu) 02:50:24 M.Kamada
;	+79 .dčʂ̃TCYw.w/.lȊOw肵Ƃ̋
;
;	Revision 1.14  1998 10/10(Sat) 01:50:32 M.Kamada
;	+77 -p̂Ƃ.INSERT1x256oCgȏǂݏoƌ듮삷
;
;	Revision 1.13  1998  8/19(Wed) 00:19:52 M.Kamada
;	+73 .dc̃f[^ɌʂɃTCYwł
;
;	Revision 1.12  1998  7/29(Wed) 02:32:33 M.Kamada
;	+70 .INSERT̈10iȊO̐lw肵Ƃ̕sC
;
;	Revision 1.11  1998  7/14(Tue) 00:19:35 M.Kamada
;	+68 .insertǉ
;
;	Revision 1.10  1998  5/14(Thu) 15:59:24 M.Kamada
;	+65 .end̉Eɒ߂Ȃ
;
;	Revision 1.9  1998  4/13(Mon) 04:47:07 M.Kamada
;	+64 Gb^̑΍֎~XCb`ǉ
;
;	Revision 1.8  1998  3/27(Fri) 06:30:55 M.Kamada
;	+60 .OFFSETZNVDS̈ɍs̃V{gȂoO
;
;	Revision 1.7  1997 10/22(Wed) 02:52:55 M.Kamada
;	+52 PMOVE.D #imm,CRPAZułȂs
;
;	Revision 1.6  1997 10/12(Sun) 16:47:22 M.Kamada
;	+51 .align 1G[ɂȂȂoO
;	+51 .OFFSETZNV.ALIGNgꍇłőAClXVoO
;
;	Revision 1.5  1997  9/15(Mon) 16:36:55 M.Kamada
;	+46 ST_VALUE=0,SZ_BYTE=0ōœK
;
;	Revision 1.4  1997  6/25(Wed) 00:27:23 M.Kamada
;	+33 vft@CV{CPUɑΉ
;	+34 vft@CV{ɑΉ
;
;	Revision 1.3  1996 12/12(Thu) 16:59:39 M.Kamada
;	+02 68060Ή
;		cpu68060ǉ
;		68060ǉ
;	+03 dcb/dsȂǂ̃Iyh̎ɕ܂łĂ悢Ƃɂ
;
;	Revision 1.2  1994/03/06  02:54:56  nakamura
;	68000,68010[hł-eXCb`̈ύX
;
;	Revision 1.1  1994/02/13  13:33:28  nakamura
;	Initial revision
;
;
