;----------------------------------------------------------------
;	X68k High-speed Assembler
;		V{Ǘ
;		< symbol.s >
;
;	$Id: symbol.s,v 1.8  1999 10/ 8(Fri) 21:49:32 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;			  1999     by M.Kamada
;----------------------------------------------------------------

	.include	has.equ
	.include	symbol.equ
	.include	tmpcode.equ

	.cpu	68000
	.text


;----------------------------------------------------------------
;	}N`
;----------------------------------------------------------------

;----------------------------------------------------------------
;	nbV֐̌vZ
;	in :a2=ւ̃|C^/d2.w=-1
;	out:d0.l=nbV֐l		(d3j)
  .ifdef MASK_HASH
hashfnc	.macro	hashsize_minus_1
	moveq.l	#0,d0
@loop:
	moveq.l	#$20,d3			;(啶ËႢ͖)
	or.b	(a2)+,d3
	add.w	d3,d0
	ror.w	#3,d0
	sub.w	d3,d0
	dbra	d2,@loop
	and.l	hashsize_minus_1,d0	;d0.l=V{̃nbV֐l
	.endm
  .else
hashfnc	.macro	hashsize
	moveq.l	#0,d0
	moveq.l	#0,d3
@loop:
	move.b	(a2)+,d3
	ori.b	#$20,d3			;(啶ËႢ͖)
	sub.w	d3,d0			;mulu.w #7,d3
	lsl.w	#3,d3			;add.w d3,d0
	add.w	d3,d0			;
	dbra	d2,@loop
	divu.w	hashsize,d0		;nbVe[uTCY
	clr.w	d0
	swap.w	d0			;d0.w=V{̃nbV֐l
	.endm
  .endif


;----------------------------------------------------------------
;	\ς݃V{̏
;----------------------------------------------------------------
defressym::
	move.l	(TEMPPTR,a6),d0
	doquad	d0			;Ô
	movea.l	d0,a3
	lea.l	(reg_tbl,pc),a2		;WX^V{̏
  .ifdef MASK_HASH
	move.l	#SYMHASHSIZE-1,d5	;Oɂ邱
  .else
	move.w	#SYMHASHSIZE,d5
  .endif
	movea.l	(SYMHASHPTR,a6),a5
defressym1:
	movea.l	a2,a0
	moveq.l	#-2,d1
defressym2:
	addq.w	#1,d1
	tst.b	(a2)+
	bne	defressym2
	bsr	getsymchain
	move.l	a3,(a1)
	clr.l	(a3)+			;$00 SYM_NEXT
	move.l	a0,(a3)+		;$04 SYM_NAME
	move.w	#ST_REGISTER<<8,(a3)+	;$08 SYM_TYPE,$09 
;a2Ԓn̂Ƃ̂.wɂȂ
	move.b	(a2)+,(a3)+		;$0A SYM_ARCH
	move.b	(a2)+,(a3)+		;$0B SYM_ARCH2
	move.b	(a2)+,(a3)+		;$0C SYM_REGNO
	addq.l	#3,a3			;$10 O[hEɍ킹
	tst.b	(a2)
	bne	defressym1

	llea	opcode_tbl,a2		;ߖV{̏
	llea	opadr_tbl,a4
  .ifdef MASK_HASH
	move.l	#CMDHASHSIZE-1,d5	;Oɂ邱
  .else
	move.w	#CMDHASHSIZE,d5
  .endif
	movea.l	(CMDHASHPTR,a6),a5
defressym3:
	movea.l	a2,a0
	moveq.l	#-2,d1
defressym4:
	addq.w	#1,d1
	tst.b	(a2)+
	bne	defressym4
	bsr	getsymchain
	move.l	a3,(a1)
	clr.l	(a3)+			;$00 SYM_NEXT
	move.l	a0,(a3)+		;$04 SYM_NAME
	move.b	#ST_OPCODE,(a3)+	;$08 SYM_TYPE
	move.b	(a2)+,(a3)+		;$09 SYM_NOOPR
;a2Ԓn̂Ƃ̂.w.lɂȂ
	move.b	(a2)+,(a3)+		;$0A SYM_ARCH
	move.b	(a2)+,(a3)+		;$0B SYM_ARCH2
	move.b	(a2)+,(a3)+		;$0C SYM_SIZE
	move.b	(a2)+,(a3)+		;$0D SYM_SIZE2
	move.w	(a4)+,(a3)+		;$0E SYM_OPCODE
	move.l	(a4)+,d0
	lea.l	(-4,a4,d0.l),a0
	move.l	a0,(a3)+		;$10 SYM_FUNC
					;$14
	tst.b	(a2)
	bne	defressym3

	move.l	a3,(TEMPPTR,a6)
	bsr	memcheck
	rts

;----------------------------------------------------------------
;	V{e[u`FC̖𓾂
getsymchain:
	move.l	a2,-(sp)
	move.w	d1,d2			;-1
	movea.l	a0,a2			;ւ̃|C^
	hashfnc	d5			;V{nbV֐lvZ
	lsl.l	#2,d0
	add.l	a5,d0			;V{nbVe[uAhX
	movea.l	d0,a1
getsymchain1:
	tst.l	(a1)			;(SYM_NEXT(a1))
	beq	getsymchain2
	movea.l	(a1),a1
	bra	getsymchain1

getsymchain2:
	movea.l	(sp)+,a2
	rts


;----------------------------------------------------------------
;	V{e[ǔ
;----------------------------------------------------------------

;----------------------------------------------------------------
;	OV{Ƃēo^ςǂׂ
;	in :a0=ւ̃|C^/d1.w=-1
;	out:d0.l=o^ςȂ0 /a1=V{e[uւ̃|C^
;		 o^Ȃ-1/a1=nbVe[ugpւ̃|C^
;	    d1.w=/8w肳Ă當񒷂C
isdefdsym::
	movem.l	d2-d3/a2-a3,-(sp)
	tst.b	(SYMLEN8,a6)
	beq	isdefdsym1
	cmp.w	#8-1,d1
	bls	isdefdsym1
	moveq.l	#8-1,d1			;/8w肳Ăꍇ8ڈȍ~͖
isdefdsym1:
	move.w	d1,d2			;-1
	movea.l	a0,a2			;ւ̃|C^
  .ifdef MASK_HASH
	hashfnc	#SYMHASHSIZE-1		;V{nbV֐lvZ
  .else
	hashfnc	#SYMHASHSIZE		;V{nbV֐lvZ
  .endif
	lsl.l	#2,d0
	add.l	(SYMHASHPTR,a6),d0	;V{nbVe[uAhX
	movea.l	d0,a1
isdefdsym3:
	move.l	(a1),d0			;(SYM_NEXT(a1))
	beq	isdefdsym9		;o^
	movea.l	d0,a1
	move.b	(SYM_TYPE,a1),d3	;V{^Cv
	bpl	isdefdsym5		;[U[`V{
	move.w	(SYM_ARCH,a1),d3	;\V{(/WX^)̏ꍇ
	beq	isdefdsym35		;^߂̏ꍇ
	and.w	(CPUTYPE,a6),d3
	beq	isdefdsym3		;݂CPU^CvƍvȂ̂Ŗ
isdefdsym35:
	move.w	d1,d2			;-1
	movea.l	a0,a2			;ւ̃|C^
	movea.l	(SYM_NAME,a1),a3
isdefdsym4:
	move.b	(a2)+,d0
;	tolower	d0			;\V{͑啶EʂȂ
	ori.w	#$20,d0			;(0`9,A`ZȊO͍̕lȂĂ悢)
	cmp.b	(a3)+,d0
	dbne	d2,isdefdsym4
	bne	isdefdsym3		;V{vȂ
	tst.b	(a3)
	bne	isdefdsym3		;	V
	moveq.l	#0,d0			;vꍇ
	movem.l	(sp)+,d2-d3/a2-a3
	rts

isdefdsym5:				;[U[`V{
	cmpi.b	#ST_LOCAL,d3
	beq	isdefdsym3		;[JxȂ疳
	move.w	d1,d2			;-1
	movea.l	a0,a2			;ւ̃|C^
	movea.l	(SYM_NAME,a1),a3
isdefdsym6:
	cmpm.b	(a2)+,(a3)+
	dbne	d2,isdefdsym6
	bne	isdefdsym3		;V{vȂ
	tst.b	(a3)
	bne	isdefdsym3		;	V
	moveq.l	#0,d0			;vꍇ
	movem.l	(sp)+,d2-d3/a2-a3
	rts

isdefdsym9:				;o^ꍇ
	moveq.l	#-1,d0
	movem.l	(sp)+,d2-d3/a2-a3
	rts

;----------------------------------------------------------------
;	O}NƂēo^ςǂׂ
;	in :a0=}Nւ̃|C^/d1.w=}N-1
;	out:d0.l=o^ςȂ0 /a1=V{e[uւ̃|C^
;		 o^Ȃ-1/a1=VV{e[uւ̃|C^
;	    d1.w=/8w肳Ă當񒷂C
isdefdmac::
	tst.b	(SYMLEN8,a6)
	beq	isdefdmac1
	cmp.w	#8-1,d1
	bls	isdefdmac1
	moveq.l	#8-1,d1			;/8w肳Ăꍇ8ڈȍ~͖
isdefdmac1:
	move.w	d1,d2			;-1
	movea.l	a0,a2			;ւ̃|C^
  .ifdef MASK_HASH
	hashfnc	#CMDHASHSIZE-1		;߃nbV֐lvZ
  .else
	hashfnc	#CMDHASHSIZE		;߃nbV֐lvZ
  .endif
	lsl.l	#2,d0
	add.l	(CMDHASHPTR,a6),d0	;߃nbVe[uAhX
	movea.l	d0,a1
	movea.l	d0,a4			;V{e[u`FC̐擪
isdefdmac3:
	move.l	(a1),d0			;(SYM_NEXT(a1))
	beq	isdefdmac9		;o^
	movea.l	d0,a1
	cmpi.b	#ST_MACRO,(SYM_TYPE,a1)	;V{^Cv
	bne	isdefdmac3		;}NłȂ	(isdefdmac9)
	move.w	d1,d2			;-1
	movea.l	a0,a2			;ւ̃|C^
	movea.l	(SYM_NAME,a1),a3
isdefdmac4:
	move.b	(a2)+,d0
	bmi	isdefdmac10		;pJ^Ji/2oCg
	tolower	d0			;}N͑啶EʂȂ
isdefdmac5:
	cmp.b	(a3)+,d0
	dbne	d2,isdefdmac4
	bne	isdefdmac3		;V{vȂ
isdefdmac6:
	tst.b	(a3)
	bne	isdefdmac3		;	V
	moveq.l	#0,d0			;vꍇ
	rts

isdefdmac9:				;o^ꍇ
	movea.l	a4,a1			;V{e[u̓|C^`FC̐擪ɍ쐬
	moveq.l	#-1,d0
	rts

isdefdmac10:
  .if EUCSRC=0
	cmp.b	#$E0,d0
	bcc	isdefdmac11
	cmp.b	#$A0,d0
	bcc	isdefdmac5		;pJ^Ji
  .else
	bra	isdefdmac5		;EUC
  .endif
isdefdmac11:				;2oCg
	cmp.b	(a3)+,d0
	bne	isdefdmac3
	subq.w	#1,d2
	bcs	isdefdmac6
	move.b	(a2)+,d0		;2oCg2oCg
	bra	isdefdmac5

;----------------------------------------------------------------
;	[Jxo^ςǂׂ
;	in :d1.l=[Jxԍ
;	out:d0.l=o^ςȂ0 /a1=V{e[uւ̃|C^
;		 o^Ȃ-1/a1=nbVe[ugpւ̃|C^
isdefdlocsym::
  .ifdef MASK_HASH
	move.l	d1,d0
	swap.w	d0
	lsl.w	#5,d0
	eor.w	d1,d0
	and.l	#SYMHASHSIZE-1,d0	;Oɂ邱
  .else
	moveq.l	#0,d0
	move.w	d1,d0
	divu.w	#SYMHASHSIZE,d0
	clr.w	d0
	swap.w	d0			;d0.w=V{̃nbV֐l
  .endif
	lsl.l	#2,d0
	add.l	(SYMHASHPTR,a6),d0	;V{̃nbVe[uAhX
	movea.l	d0,a1
isdefdlocsym1:
	move.l	(a1),d0			;(SYM_NEXT(a1))
	beq	isdefdlocsym9		;o^
	movea.l	d0,a1
	cmpi.b	#ST_LOCAL,(SYM_TYPE,a1)	;V{^Cv
	bne	isdefdlocsym1		;[JxłȂ
	cmp.l	(SYM_NAME,a1),d1
	bne	isdefdlocsym1		;ԍႤ
	moveq.l	#0,d0			;vꍇ
	rts

isdefdlocsym9:				;o^ꍇ
	moveq.l	#-1,d0
	rts


;----------------------------------------------------------------
;	߁E}Ň
;----------------------------------------------------------------

;----------------------------------------------------------------
;	񂪖,}Nǂ𒲂ׂ(}ND)
;	in :a0=ւ̃|C^/d1.w=-1
;	out:d0.w=,}NȂ0
getmaccmd::
	movem.l	d2-d4/a1-a3,-(sp)
	moveq.l	#0,d0
	move.b	(a0),d2
	beq	getmaccmd99
	cmp.b	#'*',d2
	beq	getmaccmd99
	cmp.b	#';',d2			;g[h̃Rg
	beq	getmaccmd99
getmaccmd0:
	cmp.b	#'=',d2
	bne	getmaccmd1
	lea.l	(getmacset,pc),a0	;'='  'set'
	moveq.l	#3-1,d1
getmaccmd1:
	move.w	d1,d4
	tst.b	(SYMLEN8,a6)
	beq	getmaccmd2
	cmp.w	#8-1,d4
	bls	getmaccmd2
	moveq.l	#8-1,d4			;/8w肳Ăꍇ}N8ڈȍ~𖳎
getmaccmd2:
	move.w	d4,d2			;-1(8ڂ܂)
	movea.l	a0,a2			;ւ̃|C^
  .ifdef MASK_HASH
	hashfnc	#CMDHASHSIZE-1		;߃nbV֐lvZ
  .else
	hashfnc	#CMDHASHSIZE		;߃nbV֐lvZ
  .endif
	lsl.l	#2,d0
	add.l	(CMDHASHPTR,a6),d0	;߃nbVe[uAhX
	movea.l	d0,a1
getmaccmd5:
	move.l	(a1),d0			;(SYM_NEXT(a1))
	beq	getmaccmd80		;V{Ȃ
	movea.l	d0,a1
	tst.b	(SYM_TYPE,a1)		;V{^Cv
	bmi	getmaccmd21		;\V{()
	move.w	d4,d2			;(/8w肳Ă8ڂ܂łrȂ)
	movea.l	a0,a2			;ւ̃|C^
	movea.l	(SYM_NAME,a1),a3
getmaccmd6:
	move.b	(a2)+,d0
	bmi	getmaccmd10		;pJ^Ji/2oCg
	tolower	d0			;}N͑啶EʂȂ
getmaccmd7:
	cmp.b	(a3)+,d0
	dbne	d2,getmaccmd6
	bne	getmaccmd5		;V{vȂ
getmaccmd8:
	tst.b	(a3)
	bne	getmaccmd5		;	V
getmaccmd70:				;}N
	move.l	a1,(CMDTBLPTR,a6)	;V{e[uւ̃|C^
	st.b	(ISMACRO,a6)
	moveq.l	#0,d0
	movem.l	(sp)+,d2-d4/a1-a3
	rts

getmaccmd10:
  .if EUCSRC=0
	cmp.b	#$E0,d0
	bcc	getmaccmd11
	cmp.b	#$A0,d0
	bcc	getmaccmd7		;pJ^Ji
  .else
	bra	getmaccmd7		;EUC
  .endif
getmaccmd11:				;2oCg
	cmp.b	(a3)+,d0
	bne	getmaccmd5
	subq.w	#1,d2
	bcs	getmaccmd8
	move.b	(a2)+,d0		;2oCg2oCg
	bra	getmaccmd7

getmaccmd20:				;e[u`FC疽߂
	move.l	(a1),d0			;(SYM_NEXT(a1))
	beq	getmaccmd80		;V{Ȃ
	movea.l	d0,a1
getmaccmd21:
	move.w	(SYM_ARCH,a1),d3	;\V{(/WX^)̏ꍇ
	beq	getmaccmd215		;^߂̏ꍇ
	and.w	(CPUTYPE,a6),d3
	beq	getmaccmd20		;݂CPU^CvƍvȂ̂Ŗ
getmaccmd215:
	move.w	d1,d2			;(/8̎wɊւ炸Sr)
	movea.l	a0,a2			;ւ̃|C^
	movea.l	(SYM_NAME,a1),a3
getmaccmd22:
	move.b	(a2)+,d0
;	tolower	d0			;\V{͑啶EʂȂ
	ori.w	#$20,d0			;(0`9,A`ZȊO͍̕lȂĂ悢)
	cmp.b	(a3)+,d0
	dbne	d2,getmaccmd22
	bne	getmaccmd20		;V{Ⴄ
	tst.b	(a3)
	bne	getmaccmd20		;	V
getmaccmd90:
	move.l	a1,(CMDTBLPTR,a6)	;V{e[uւ̃|C^
	sf.b	(ISMACRO,a6)
	moveq.l	#0,d0
	movem.l	(sp)+,d2-d4/a1-a3
	rts

getmaccmd99:				;߁E}Nw肳ĂȂ
	clr.l	(CMDTBLPTR,a6)
	moveq.l	#0,d0
	movem.l	(sp)+,d2-d4/a1-a3
	rts

getmaccmd80:				;Y閽߁E}NȂ
	clr.l	(CMDTBLPTR,a6)
	moveq.l	#-1,d0
	movem.l	(sp)+,d2-d4/a1-a3
	rts

getmacset:	.dc.b	'set'
		.even

;----------------------------------------------------------------
;	񂪖,}Nǂ𒲂ׂ(ߗD)
;	in :a0=ւ̃|C^/d1.w=-1
;	out:d0.w=,}NȂ0
getcmdmac::
	movem.l	d2-d4/a1-a3,-(sp)
	moveq.l	#0,d0
	move.b	(a0),d2
	beq	getmaccmd99
	cmp.b	#'*',d2
	beq	getmaccmd99
	cmp.b	#';',d2			;g[h̃Rg
	beq	getmaccmd99
getcmdmac0:
	cmp.b	#'=',d2
	bne	getcmdmac1
	lea.l	(getmacset,pc),a0	;'='  'set'
	moveq.l	#3-1,d1
getcmdmac1:
	move.w	d1,d4
	tst.b	(SYMLEN8,a6)
	beq	getcmdmac2
	cmp.w	#8-1,d4
	bls	getcmdmac2
	moveq.l	#8-1,d4			;/8w肳Ăꍇ}N8ڈȍ~𖳎
getcmdmac2:
	move.w	d4,d2			;-1(8ڂ܂)
	movea.l	a0,a2			;ւ̃|C^
  .ifdef MASK_HASH
	hashfnc	#CMDHASHSIZE-1		;߃nbV֐lvZ
  .else
	hashfnc	#CMDHASHSIZE		;߃nbV֐lvZ
  .endif
	lsl.l	#2,d0
	add.l	(CMDHASHPTR,a6),d0	;߃nbVe[uAhX
	movea.l	d0,a1
	movea.l	d0,a5
getcmdmac5:				;e[u`FC疽߂
	move.l	(a1),d0			;(SYM_NEXT(a1))
	beq	getmaccmd80		;V{Ȃ
	movea.l	d0,a1
	tst.b	(SYM_TYPE,a1)		;V{^Cv
	bpl	getcmdmac5		;}N͖
	bra	getcmdmac7

getcmdmac6:
	move.l	(a1),d0			;(SYM_NEXT(a1))
	beq	getcmdmac9		;V{Ȃ}NƂčČ
	movea.l	d0,a1
getcmdmac7:
	move.w	(SYM_ARCH,a1),d3	;\V{(/WX^)̏ꍇ
	beq	getcmdmac75		;^߂̏ꍇ
	and.w	(CPUTYPE,a6),d3
	beq	getcmdmac6		;݂CPU^CvƍvȂ̂Ŗ
getcmdmac75:
	move.w	d1,d2			;(/8̎wɊւ炸Sr)
	movea.l	a0,a2			;ւ̃|C^
	movea.l	(SYM_NAME,a1),a3
getcmdmac8:
	move.b	(a2)+,d0
;	tolower	d0			;\V{͑啶EʂȂ
	ori.w	#$20,d0			;(0`9,A`ZȊO͍̕lȂĂ悢)
	cmp.b	(a3)+,d0
	dbne	d2,getcmdmac8
	bne	getcmdmac6		;V{Ⴄ
	tst.b	(a3)
	bne	getcmdmac6		;	V
	bra	getmaccmd90		;߂

getcmdmac9:				;}NƂčČ
	movea.l	a5,a1
	bra	getmaccmd5


;----------------------------------------------------------------
;	V{e[u̍쐬
;----------------------------------------------------------------

;----------------------------------------------------------------
;	̖ÕV{e[u쐬
;	in :a0=ւ̃|C^/d1.w=-1
;	    a1=nbVe[ugpւ̃|C^
;	    d2.b=V{e[u^Cv
;	out:a1=V{e[uւ̃|C^
defsymbol::
	movem.l	a2-a3,-(sp)
	movea.l	(TEMPPTR,a6),a2
	movea.l	a2,a3			;V{ւ̃|C^
defsymbol1:
	move.b	(a0)+,(a3)+		;V{[NɃRs[
	dbra	d1,defsymbol1
	clr.b	(a3)+
	move.l	a3,(TEMPPTR,a6)
	bsr	getsymtbl
	move.l	a0,(a1)			;nbV`FCȂ
	movea.l	a0,a1
	move.b	d2,(SYM_TYPE,a1)
	move.l	a2,(SYM_NAME,a1)
	movem.l	(sp)+,a2-a3
	bra	memcheck

;----------------------------------------------------------------
;	V{e[ũAhX𓾂
getsymtbl:
	subq.w	#1,(SYMTBLCOUNT,a6)
	bmi	getsymtbl1		;݂̃V{e[uubNgs
	movea.l	(SYMTBLPTR,a6),a0
	lea.l	(SYM_TBLLEN,a0),a0	;e[uubN̎̃AhX𓾂
	move.l	a0,(SYMTBLPTR,a6)
	rts

getsymtbl1:				;V{e[uubNg
	move.l	(TEMPPTR,a6),d0
	doquad	d0
	movea.l	(SYMTBLCURBGN,a6),a0
	move.l	d0,(a0)			;V{e[uubÑ`FCȂ
	move.l	d0,(SYMTBLCURBGN,a6)
	movea.l	d0,a0
	add.l	#SYM_TBLLEN*SYMEXTCOUNT+4,d0
	move.l	d0,(TEMPPTR,a6)
	bsr	memcheck
	move.l	d1,-(sp)
	moveq.l	#0,d1
	move.w	#SYM_TBLLEN*SYMEXTCOUNT/16,d0
getsymtbl2:
  .rept 16/4
	move.l	d1,(a0)+		;gubNNA
  .endm
	dbra	d0,getsymtbl2
	move.l	(sp)+,d1
	move.w	#SYMEXTCOUNT-1,(SYMTBLCOUNT,a6)
	movea.l	(SYMTBLCURBGN,a6),a0
	addq.l	#4,a0
	move.l	a0,(SYMTBLPTR,a6)
	rts

;----------------------------------------------------------------
;	̖Õ}NV{e[u쐬
;	in :a0=ւ̃|C^/d1.w=-1
;	    a1=nbVe[ugpւ̃|C^(|C^`FC̐擪)
;	out:a1=V{e[uւ̃|C^
defmacsymbol::
	movem.l	a2-a3,-(sp)
	movea.l	(TEMPPTR,a6),a2
	movea.l	a2,a3			;V{ւ̃|C^
defmacsymbol1:
	move.b	(a0)+,d0
	bmi	defmacsymbol5
	tolower	d0
defmacsymbol2:
	move.b	d0,(a3)+
	dbra	d1,defmacsymbol1
defmacsymbol3:
	clr.b	(a3)+
	move.l	a3,(TEMPPTR,a6)
	bsr	getsymtbl
	move.l	(a1),d0
	move.l	a0,(a1)			;|C^`FC̐擪ɂȂ
	move.l	a0,a1
	move.l	d0,(a1)			;(SYM_NEXT(a1))
	move.b	#ST_MACRO,(SYM_TYPE,a1)
	move.l	a2,(SYM_NAME,a1)
	movem.l	(sp)+,a2-a3
	bra	memcheck

defmacsymbol5:
  .if EUCSRC=0
	cmp.b	#$E0,d0
	bcc	defmacsymbol6
	cmp.b	#$A0,d0
	bcc	defmacsymbol2		;pJ^Ji
  .else
	bra	defmacsymbol2		;EUC
  .endif
defmacsymbol6:				;2oCg
	move.b	d0,(a3)+
	subq.w	#1,d1
	bmi	defmacsymbol3
	move.b	(a0)+,d0
	bra	defmacsymbol2

;----------------------------------------------------------------
;	[Jx̃V{e[u쐬
;	in :d1.l=[Jxԍ
;	   :a1=nbVe[ugpւ̃|C^
;	out:a1=V{e[uւ̃|C^
deflocsymbol::
	bsr	getsymtbl
	move.l	a0,(a1)
	movea.l	a0,a1
	move.b	#ST_LOCAL,(SYM_TYPE,a1)
	move.l	d1,(SYM_LOCALNO,a1)	;[JV{ԍ
	rts

;----------------------------------------------------------------
;	^ꂽV{Ƃēo^
;	in :a0=ւ̃|C^(asciz)
;	    d2.b=V{e[u^Cv
;	out:a1=V{e[uւ̃|C^
defstrsymbol::
	movea.l	a0,a2
	moveq.l	#-2,d1			;̒߂
defstrsymbol1:
	addq.w	#1,d1
	tst.b	(a2)+
	bne	defstrsymbol1
	movea.l	a0,a2
	bsr	isdefdsym
	tst.w	d0
	beq	defstrsymbol9		;łɓo^ς
	clr.b	(1,a2,d1.w)		;(/8w肳ꂽꍇ̂)
	bsr	getsymtbl
	move.l	a0,(a1)
	movea.l	a0,a1
	move.b	d2,(SYM_TYPE,a1)
	move.l	a2,(SYM_NAME,a1)
defstrsymbol9:
	rts


;----------------------------------------------------------------
	.end

;----------------------------------------------------------------
;	$Log: symbol.s,v $
;	Revision 1.8  1999 10/ 8(Fri) 21:49:32 M.Kamada
;	+86 EUCΉ
;
;	Revision 1.7  1999  3/16(Tue) 03:40:18 M.Kamada
;	+83 [Jx4܂őΉ
;
;	Revision 1.6  1999  3/ 3(Wed) 17:36:25 M.Kamada
;	+82 WX^V{Ԓnn܂Ă̂ŏC
;	+82 nbVe[ũTCY2ׂ̂ɂdivu
;	+82 doevendoquad
;
;	Revision 1.5  1999  2/27(Sat) 23:45:36 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 1.4  1999  2/20(Sat) 17:37:32 M.Kamada
;	+80 ColdFireΉ
;
;	Revision 1.3  1994/07/10  12:46:16  nakamura
;	IyhȂ߂ւ̑Ή̕ύX
;
;	Revision 1.2  1994/04/05  13:07:20  nakamura
;	}N2oCggp}N̓WJłȂoOCB
;
;	Revision 1.1  1994/02/13  14:18:06  nakamura
;	Initial revision
;
;
