;----------------------------------------------------------------
;	X68k High-speed Assembler
;		t@Co
;		< file.s >
;
;	$Id: file.s,v 1.4  1999  2/27(Sat) 23:41:32 M.Kamada Exp $
;
;		Copyright 1990-94  by Y.Nakamura
;			  1996-99  by M.Kamada
;----------------------------------------------------------------

	.include	doscall.mac
	.include	has.equ
	.include	tmpcode.equ
	.include	error2.equ

	.cpu	68000
	.text


;----------------------------------------------------------------
;	t@CǗ[`
;----------------------------------------------------------------

;----------------------------------------------------------------
;	t@Cǂݍ݃[hŃI[v
;	in :a0=t@Cւ̃|C^ /INPFILPTR=̓t@C|C^ւ̃|C^
;	out:d0.w=I[vt@Cnh(G[Ȃ畉̐)
readopen::
	move.l	a0,(INPFILE,a6)
	move.l	a1,-(sp)
	movea.l	(INPFILPTR,a6),a1
	clr.w	-(sp)			;'r'
	pea.l	(a0)
	DOS	_OPEN
	addq.l	#6,sp
	move.w	d0,(F_HANDLE,a1)
	move.l	a0,(F_NAMEPTR,a1)
	clr.l	(F_TOPOFST,a1)
	clr.l	(F_DATALEN,a1)
	clr.l	(F_PTROFST,a1)
	move.l	(sp)+,a1
	rts

;----------------------------------------------------------------
;	t@CVɍ쐬(ۂɂ͏邾)
;	in :a0=t@Cւ̃|C^ /OUTFILPTR=o̓t@C|C^ւ̃|C^
;	out:---
createopen::
	move.l	a1,-(sp)
	movea.l	(OUTFILPTR,a6),a1
	move.l	a0,(F_NAMEPTR,a1)
	clr.l	(F_TOPOFST,a1)
	clr.l	(F_DATALEN,a1)
	clr.l	(F_PTROFST,a1)
	move.w	#-1,(F_HANDLE,a1)	;t@C͂܂ۂɍĂȂ
	move.l	(sp)+,a1
	rts

;----------------------------------------------------------------
;	o̓t@C(PRNt@CȂ)I[v
;	in :a0=t@Cւ̃|C^
;	out:d0.w=I[vt@Cnh(G[Ȃ畉̐)
prnopen::
	move.w	#$20,-(sp)		;t@C(Archive)
	pea.l	(a0)
	DOS	_CREATE			;t@C쐬
	addq.l	#6,sp
	tst.l	d0
	bpl	prnopen9
	move.w	#1,-(sp)		;݃[h
	pea.l	(a0)
	DOS	_OPEN			;(_CREATECONȂǂ̃I[vłȂ)
	addq.l	#6,sp
	tst.l	d0
	bmi	filopenabort		;t@CI[vɎs
	move.w	d0,-(sp)
	clr.w	-(sp)
	DOS	_IOCTRL
	addq.l	#2,sp
	btst.l	#1,d0
	beq	prnopen8
	st.b	(ISPRNSTDOUT,a6)	;I[vt@C͕Wo
	st.b	(NOPAGEFF,a6)
	DOS	_CLOSE
	move.w	#STDOUT,(sp)
prnopen8:
	move.w	(sp)+,d0
prnopen9:
	rts

;----------------------------------------------------------------
;	̓t@CN[Y
;	in :---
;	out:---
inpclose::
	move.l	a1,-(sp)
	movea.l	(INPFILPTR,a6),a1
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_CLOSE
	addq.l	#2,sp
	move.l	(sp)+,a1
	rts

;----------------------------------------------------------------
;	o̓t@CN[Y
;	in :---
;	out:---
outclose::
	move.l	a1,-(sp)
	movea.l	(OUTFILPTR,a6),a1
	bsr	writebuf		;t@Cobt@tbV
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_CLOSE
	addq.l	#2,sp
	move.l	(sp)+,a1
	rts

;----------------------------------------------------------------
;	CN[ht@CI[v
;	in :a0=t@Cւ̃|C^
;	out:d0.w=I[vł0
openincld::
	cmpi.w	#INCLDMAXNEST,(INCLDNEST,a6)
	bcc	tooinclderr		;lXeBO[
	movem.l	a0-a2,-(sp)
	lea.l	(INCLDPTR,a6),a1	;CN[ht@C|C^
	lea.l	(INCLDINF,a6),a2
	tst.w	(INCLDNEST,a6)
	beq	openincld1
	movea.l	(INCLDINFPTR,a6),a2	;2dȏ̃lXeBȌꍇ
	move.l	(F_TOPOFST,a1),d0
	add.l	(F_PTROFST,a1),d0	;t@C|C^ʒu𓾂
	move.l	d0,(a2)+
	move.l	(F_NAMEPTR,a1),(a2)+
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_CLOSE			;t@CN[Y
	addq.l	#2,sp
openincld1:
	move.l	(LINENUM,a6),(a2)+
	move.l	a2,(INCLDINFPTR,a6)
	move.l	a1,(INPFILPTR,a6)	;̓t@C؂ւ
	bsr	readopen
	clr.l	(LINENUM,a6)
	addq.w	#1,(INCLDNEST,a6)
	tst.w	d0
	bmi	openincld9
	moveq.l	#0,d0
	movem.l	(sp)+,a0-a2
	rts

openincld9:				;t@CI[vɎs
	bsr	closeincld
	moveq.l	#-1,d0
	movem.l	(sp)+,a0-a2
	rts

;----------------------------------------------------------------
;	CN[ht@CN[Y
;	in :---
;	out:---
closeincld::
	movem.l	d0/a0-a2,-(sp)
	lea.l	(INCLDPTR,a6),a1
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_CLOSE			;t@CN[Y
	addq.l	#2,sp
	movea.l	(INCLDINFPTR,a6),a2
	move.l	-(a2),(LINENUM,a6)
	subq.w	#1,(INCLDNEST,a6)
	beq	closeincld1		;̃\[Xt@Cɖ߂
	move.l	-(a2),a0
	bsr	readopen		;1ÕCN[ht@CI[v
	move.l	-(a2),(F_TOPOFST,a1)
	clr.w	-(sp)
	move.l	(a2),-(sp)
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_SEEK			;܂ł̓ǂݍ݈ʒu܂ŃV[N
	addq.l	#8,sp
	clr.l	(F_DATALEN,a1)
	bsr	readbuf			;t@Cobt@̓eƂɖ߂
	move.l	a2,(INCLDINFPTR,a6)
	movem.l	(sp)+,d0/a0-a2
	rts

closeincld1:				;̃\[Xt@Cɖ߂Ă
	move.l	a2,(INCLDINFPTR,a6)
	lea.l	(SOURCEPTR,a6),a0
	move.l	a0,(INPFILPTR,a6)
	move.l	(SOURCEFILE,a6),(INPFILE,a6)
	movem.l	(sp)+,d0/a0-a2
	rts

;----------------------------------------------------------------
;	w肳ꂽCN[ht@C
;	in :a0=t@Cւ̃|C^
;	out:d0.w=0Ȃt@C/a0=t@Cւ̃|C^(pXt)
srchincld::
	link	a5,#-128
	movem.l	a1-a3,-(sp)
	movea.l	a0,a2
	lea.l	(-128,a5),a0		;JgfBNgt@C
	bsr	srchinclds
	tst.l	d0
	beq	srchincld7
	lea.l	(INCLUDEPATH,a6),a3	;-i path t@C
srchincld1:
	move.l	(a3),d0
	beq	srchincld2
	movea.l	d0,a3
	lea.l	(4,a3),a1
	lea.l	(-128,a5),a0
	bsr	pathcpy
	bsr	srchinclds
	tst.l	d0
	beq	srchincld7
	bra	srchincld1		;'-i'pX

srchincld2:
	lea.l	(-128,a5),a0		;ϐ'include'̃pXt@C
	movea.l	a0,a1
	pea.l	(a0)
	clr.l	-(sp)
	pea.l	(env_incld,pc)
.ifdef	HUMAN_V3
	DOS	_GETENV
.else
	bsr	getenv			;DOS _GETENV
.endif
	addq.l	#12-4,sp
	move.l	d0,(sp)+
	bmi	srchincld6		;ϐݒ肳ĂȂ
	bsr	pathcpy
	bsr	srchinclds
	tst.l	d0
	beq	srchincld7
srchincld6:				;t@CȂ
	moveq.l	#-1,d0
	bra	srchincld9

srchincld7:				;t@C
	movea.l	(TEMPPTR,a6),a0
	movea.l	a0,a1
	lea.l	(-128,a5),a2
srchincld8:
	move.b	(a2)+,(a1)+
	bne	srchincld8
	move.l	a1,(TEMPPTR,a6)
	bsr	memcheck
	moveq.l	#0,d0
srchincld9:
	movem.l	(sp)+,a1-a3
	unlk	a5
	rts

srchinclds:				;t@C邩ǂ`FbN
	movea.l	a2,a1
	bsr	strcpy			;t@C]
	clr.w	-(sp)
	pea.l	(-128,a5)
	DOS	_OPEN			;I[vĂ݂
	addq.l	#6,sp
	tst.l	d0
	bmi	srchinclds2		;t@CȂ
	move.w	d0,-(sp)
	DOS	_CLOSE			;t@ĈŃN[Y
	addq.l	#2,sp
	moveq.l	#0,d0
srchinclds2:
	rts

;----------------------------------------------------------------
;	e|t@C쐬
;	in :---
;	out:a0=쐬t@Cւ̃|C^
maketmpname::
	move.l	a1,-(sp)
	movea.l	(TEMPPTR,a6),a0
	movem.l	d0-d2/a0,-(sp)
	movea.l	(TEMPPATH,a6),a1
	tst.b	(a1)
	bne	maketmpname2		;/t̎w肪ꍇ
	movea.l	a0,a1
	pea.l	(a0)
	clr.l	-(sp)
	pea.l	(env_temp,pc)
.ifdef	HUMAN_V3
	DOS	_GETENV
.else
	bsr	getenv			;DOS _GETENV
.endif					;ϐ'temp'̓eǂݏo
	addq.l	#12-4,sp
	move.l	d0,(sp)+
	bmi	maketmpname25		;ϐ'temp'`ĂȂ
maketmpname2:
	bsr	pathcpy
maketmpname25:
	lea.l	(temp_name,pc),a1
	bsr	strcpy			;e|t@C]
	addq.l	#1,a0
	move.l	a0,(TEMPPTR,a6)
	subq.l	#8,a0
	movea.l	a0,a1			;'000'̈ʒu
	moveq.l	#0,d2
maketmpname3:
	movea.l	a1,a0
	move.l	d2,d0
	moveq.l	#-3,d1			;(3Ń[TvXȂ)
	bsr	convdec
	clr.w	-(sp)
	move.l	(14,sp),-(sp)		;a0
	DOS	_OPEN			;I[vĂ݂
	addq.l	#6,sp
	tst.l	d0
	bmi	maketmpname9		;t@CȂ̂Ńe|t@CƂĎgp
	move.w	d0,-(sp)
	DOS	_CLOSE
	addq.l	#2,sp
	addq.w	#1,d2
	cmpi.w	#1000,d2
	bcs	maketmpname3		;̖O邩ǂT
	bra	tmpopenabort		;e|t@C쐬łȂ

maketmpname9:
	movem.l	(sp)+,d0-d2/a0-a1
	rts

env_incld:
	.dc.b	'include',0
env_temp:
	.dc.b	'temp',0
temp_name:
	.dc.b	'tmp000.$$$',0
	.even

;----------------------------------------------------------------
;	IuWFNgobt@1O[h̃f[^o͂
;	in :d0.l=݃f[^
;	out:---
wrt1lobj::
	swap.w	d0
	bsr	wrt1wobj
	swap.w	d0

;----------------------------------------------------------------
;	IuWFNgobt@1[h̃f[^o͂
;	in :d0.w=݃f[^
;	out:---
wrt1wobj::
	move.w	d0,-(sp)
	lsr.w	#8,d0
	bsr	wrt1bobj
	move.w	(sp)+,d0

;----------------------------------------------------------------
;	IuWFNgobt@1oCg̃f[^o͂
;	in :d0.b=݃f[^
;	out:---
wrt1bobj::
	addq.l	#1,(LOCATION,a6)
wrt1bobj0::				;(P[VJE^͕ύXȂ)
	tst.b	(ISOBJOUT,a6)
	bne	wrt1bobj9
	movem.l	d1/a0,-(sp)
	move.w	(OBJCONCTR,a6),d1
	cmp.w	#$0100,d1
	bcs	wrt1bobj1
	bsr	flushobj
	clr.w	d1
wrt1bobj1:
	lea.l	(OBJCONBUF,a6),a0
	move.b	d0,(a0,d1.w)
	addq.w	#1,(OBJCONCTR,a6)
	movem.l	(sp)+,d1/a0
wrt1bobj9:
	rts

;----------------------------------------------------------------
;	IuWFNgobt@tbVAKvȂo̓t@Cփf[^
;	in :d0.w=݃f[^
;	out:---
wrtobjd0w::
	tst.b	(ISOBJOUT,a6)
	bne	wrtobjd0w1
	bsr	flushobj
	bra	tmpwrtd0w

wrtobjd0w1:
	rts

;----------------------------------------------------------------
;	KvȂo̓t@Cփf[^
;	in :d0.l=݃f[^
;	out:---
wrtd0l::
	swap.w	d0
	bsr	wrtd0w
	swap.w	d0

;----------------------------------------------------------------
;	KvȂo̓t@Cփf[^
;	in :d0.w=݃f[^
;	out:---
wrtd0w::
	tst.b	(ISOBJOUT,a6)
	bne	wrtobjd0w1

;----------------------------------------------------------------
;	o̓t@Cփf[^
;	in :d0.w=݃f[^
;	out:---
tmpwrtd0w:
	movem.l	d0/a1,-(sp)
	movea.l	(OUTFILPTR,a6),a1
	move.l	(F_PTROFST,a1),d0
	cmp.l	(F_BUFLEN,a1),d0
	bcs	tmpwrtd0w1
	bsr	writebuf		;obt@ςɂȂ̂ŏo
	moveq.l	#0,d0			;(F_PTROFST,a1)
tmpwrtd0w1:
	add.l	(F_BUFPTR,a1),d0
	addq.l	#2,(F_PTROFST,a1)
	addq.l	#2,(F_DATALEN,a1)
	movea.l	d0,a1
	move.w	(2,sp),(a1)
	movem.l	(sp)+,d0/a1
	addq.l	#2,(OBJLENCTR,a6)	;IuWFNgt@C
	rts

;----------------------------------------------------------------
;	e|t@Cf[^ǂݍ
;	in :---
;	out:d0.l=ǂݍ݃f[^
tmpreadd0l::
	bsr	tmpreadd0w
	move.w	d0,-(sp)
	bsr	tmpreadd0w
	swap.w	d0
	move.w	(sp)+,d0
	swap.w	d0
	rts

;----------------------------------------------------------------
;	e|t@Cf[^ǂݍ
;	in :---
;	out:d0.w=ǂݍ݃f[^
tmpreadd0w::
	move.l	a1,-(sp)
	move.l	(F_PTROFST+TEMPFILPTR,a6),d0
	cmp.l	(F_DATALEN+TEMPFILPTR,a6),d0
	bcs	tmpreadd0w1
	lea.l	(TEMPFILPTR,a6),a1
	bsr	readbuf			;obt@Ȃ̂œǂݏo
	subq.l	#1,d0
	bmi	tmpreadd0w9		;G[/t@CI
	moveq.l	#0,d0			;(F_PTROFST,a1)
tmpreadd0w1:
	add.l	(F_BUFPTR+TEMPFILPTR,a6),d0
	addq.l	#2,(F_PTROFST+TEMPFILPTR,a6)
	movea.l	d0,a1
	move.w	(a1),d0
tmpreadd0w9:
	move.l	(sp)+,a1
	rts

;----------------------------------------------------------------
;	IuWFNgobt@tbV
;	in :---
;	out:---
flushobj::
	movem.l	d0-d1/a0,-(sp)
	move.w	(OBJCONCTR,a6),d0
	beq	flushobj2		;obt@
	move.w	d0,d1
	subq.w	#1,d0
	or.w	#T_CONST,d0
	bsr	tmpwrtd0w
	lea.l	(OBJCONBUF,a6),a0
flushobj1:
	move.w	(a0)+,d0
	bsr	tmpwrtd0w
	subq.w	#2,d1
	bhi	flushobj1
	clr.w	(OBJCONCTR,a6)
flushobj2:
	movem.l	(sp)+,d0-d1/a0
	rts

;----------------------------------------------------------------
;	t@Cobt@փf[^ǂݍ
;	in :a1=t@C|C^ւ̃|C^
;	out:d0.l=ۂɓǂݍ񂾃oCg(G[Ȃ畉̐)
readbuf:
	move.l	(F_DATALEN,a1),d0
	add.l	d0,(F_TOPOFST,a1)
	move.l	(F_BUFLEN,a1),-(sp)	;ǂݍ݃TCY
	move.l	(F_BUFPTR,a1),-(sp)	;t@Cobt@ւ̃|C^
	move.w	(F_HANDLE,a1),-(sp)	;t@Cnh
	DOS	_READ
	lea.l	(10,sp),sp
	move.l	d0,(F_DATALEN,a1)
	clr.l	(F_PTROFST,a1)
	rts

;----------------------------------------------------------------
;	t@Cobt@̃f[^
;	in :a1=t@C|C^ւ̃|C^
;	out:--- (G[ȂvO𒆒f)
writebuf::
	move.l	d0,-(sp)
	tst.l	(F_PTROFST,a1)
	beq	writebuf9		;t@Cobt@
	tst.w	(F_HANDLE,a1)
	bpl	writebuf8		;t@C͂łɍ쐬Ă
	move.w	#$20,-(sp)		;t@C(Archive)
	move.l	(F_NAMEPTR,a1),-(sp)
	DOS	_CREATE			;ŏ݂̏Ȃt@C쐬
	addq.l	#6,sp
	tst.l	d0
	bpl	writebuf1
	lea.l	(TEMPFILPTR,a6),a0
	cmpa.l	a0,a1			;t@CI[vɎs
	beq	tmpopenabort
	movea.l	(F_NAMEPTR,a1),a0
	bra	filopenabort

writebuf1:
	move.w	d0,(F_HANDLE,a1)
writebuf8:
	move.l	(F_PTROFST,a1),-(sp)	;obt@̗Lf[^
	move.l	(F_BUFPTR,a1),-(sp)	;t@Cobt@ւ̃|C^
	move.w	(F_HANDLE,a1),-(sp)	;t@Cnh
	DOS	_WRITE
	lea.l	(10,sp),sp
	cmp.l	(F_PTROFST,a1),d0
	bne	devfulabort		;݂Ɏs
	add.l	d0,(F_TOPOFST,a1)
	clr.l	(F_PTROFST,a1)
	clr.l	(F_DATALEN,a1)
writebuf9:
	move.l	(sp)+,d0
	rts

;----------------------------------------------------------------
;	e|t@C̃|C^i߂
;	in :d0.w=i߂oCg
;	out:---
tempskip::
	ext.l	d0
tempskip1:
	add.l	(F_PTROFST+TEMPFILPTR,a6),d0
	cmp.l	(F_DATALEN+TEMPFILPTR,a6),d0
	bcs	tempskip9
	sub.l	(F_DATALEN+TEMPFILPTR,a6),d0
	movem.l	d0/a1,-(sp)
	lea.l	(TEMPFILPTR,a6),a1
	bsr	readbuf			;i߂|C^obt@݂͂
	movem.l	(sp)+,d1/a1
	exg.l	d0,d1
	subq.l	#1,d1
	bpl	tempskip1
tempskip9:
	move.l	d0,(F_PTROFST+TEMPFILPTR,a6)
	rts

;----------------------------------------------------------------
;	t@CC(ݐp)
fmodifyw::
	cmp.l	(F_TOPOFST,a1),d1
	blo	fmodifyw1
;obt@ɎcĂƂ
	movem.l	d1/a1,-(sp)
	sub.l	(F_TOPOFST,a1),d1
	movea.l	(F_BUFPTR,a1),a1
	move.w	d0,(a1,d1.l)
	movem.l	(sp)+,d1/a1
	rts

;obt@ɎcĂȂƂ
fmodifyw1:
	move.l	d0,-(sp)

	clr.w	-(sp)
	move.l	d1,-(sp)
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_SEEK			;Cʒu܂ňړ
	addq.l	#8,sp

	pea.l	2.w
	pea.l	(6,sp)			;(Cf[^̈ʒu)
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_WRITE			;t@CC
	addq.l	#10-2,sp

	clr.w	(sp)
	move.l	(F_TOPOFST,a1),-(sp)
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_SEEK			;Ƃ̈ʒu܂Ŗ߂
	addq.l	#8,sp

	move.l	(sp)+,d0
	rts

;----------------------------------------------------------------
;	t@CC
;	in :a1=t@C|C^ւ̃|C^
;	    d0.w=Cf[^/d1.l=Ct@Cʒu
;	out:---
fmodify::
	tst.w	(F_HANDLE,a1)
	bpl	fmodify1
	move.l	a1,-(sp)
	movea.l	(F_BUFPTR,a1),a1	;t@CĂȂ̂Ńobt@C
	move.w	d0,(a1,d1.l)
	movea.l	(sp)+,a1
	rts

fmodify1:				;ۂ̃t@CC
	move.l	d0,-(sp)
	clr.w	-(sp)
	move.l	d1,-(sp)
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_SEEK			;Cʒu܂ňړ
	addq.l	#8,sp

	pea.l	2.w
	pea.l	(6,sp)			;(Cf[^̈ʒu)
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_WRITE			;t@CC
	addq.l	#10-2,sp

	clr.w	(sp)
	move.l	(F_TOPOFST,a1),d0
	add.l	(F_DATALEN,a1),d0
	move.l	d0,-(sp)
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_SEEK			;Ƃ̈ʒu܂Ŗ߂
	addq.l	#8,sp
	move.l	(sp)+,d0
	rts

;----------------------------------------------------------------
;	e|t@C폜
;	in :---
;	out:---
tempdelete::
	movem.l	d0/a1,-(sp)
	lea.l	(TEMPFILPTR,a6),a1
	tst.w	(F_HANDLE,a1)
	bmi	tempdelete9		;t@CĂȂ̂ō폜̕KvȂ
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_CLOSE			;e|t@CN[Y
	move.l	(F_NAMEPTR,a1),-(sp)
	DOS	_DELETE			;N[Yt@C폜
	addq.l	#2+4,sp
tempdelete9:
	movem.l	(sp)+,d0/a1
	rts

;----------------------------------------------------------------
;	t@Cobt@tbV
;	in :a1=t@C|C^ւ̃|C^
;	out:---
fflush::
	tst.w	(F_HANDLE,a1)
	bpl	writebuf		;t@Cobt@tbV
	rts				;t@CĂȂ̂ŃtbV̕KvȂ

;----------------------------------------------------------------
;	t@C̐擪ɃV[N
;	in :a1=t@C|C^ւ̃|C^
;	out:---
frewind::
	move.l	d0,-(sp)
	tst.w	(F_HANDLE,a1)
	bmi	frewind1		;t@C͎ۂɂ͍ĂȂ
	tst.l	(F_TOPOFST,a1)
	beq	frewind1		;ǂݍ݃t@Cobt@Ɏ܂Ă
	clr.w	-(sp)
	clr.l	-(sp)
	move.w	(F_HANDLE,a1),-(sp)
	DOS	_SEEK			;t@C擪ɃV[N
	addq.l	#8,sp
	clr.l	(F_DATALEN,a1)		;obt@̃f[^𖳌ɂ
frewind1:
	clr.l	(F_TOPOFST,a1)
	clr.l	(F_PTROFST,a1)
	move.l	(sp)+,d0
	rts

;----------------------------------------------------------------
;	\[Xs1sǂݍ
;	in :---
;	out:(LINEBUF`)=͍s
;	    d0.w=͍s 0:\[Xt@C/1:CN[ht@C/2:}NWJ
;		 (t@CI/G[Ȃ -1)
getline::
getline0:
	tst.b	(ISASMEND,a6)
	bne	getline9		;\[Xt@C͏I
	tst.w	(MACREPTNEST,a6)
	bne	getline2
	addq.l	#1,(LINENUM,a6)
	tst.w	(INCLDNEST,a6)
	beq	readline

	bsr	readline		;CN[ht@C̓ǂݍ
	tst.w	d0
	bmi	getline1
	moveq.l	#1,d0
	rts

getline1:				;CN[ht@CI
	bsr	closeincld
	cmpi.b	#1,(ASMPASS,a6)
	bne	getline0
	move.w	#T_INCLDEND,d0
	bsr	wrtobjd0w
	bra	getline0

getline2:				;}N`s/reptJԂ̓ǂݍ
	bsr	macexline
	tst.w	d0
	bmi	getline0
	moveq.l	#2,d0
	rts

getline9:
	moveq.l	#-1,d0
	rts

;----------------------------------------------------------------
;	t@C1sǂݍ
;	in :---
;	out:(LINEBUF`)=͍s /d0.l=G[Ȃ畉̐
readline:
	movem.l	d1-d3/a0-a2,-(sp)
	lea.l	(LINEBUF,a6),a0
	move.l	a0,(LINEPTR,a6)
	movea.l	(INPFILPTR,a6),a1
	movea.l	(F_BUFPTR,a1),a2
	move.l	(F_PTROFST,a1),d3
	move.l	(F_DATALEN,a1),d2
	adda.l	d3,a2
	move.l	d2,d1
	sub.l	d3,d1
	addq.l	#1,d1
	move.w	#MAXLINELEN-2,d3
readline1:
	subq.l	#1,d1
	bhi	readline2
	bsr	readbuf			;obt@Ȃ̂œǂݍ
	subq.l	#1,d0
	bmi	readline8
	move.l	(F_DATALEN,a1),d1
	move.l	d1,d2
	movea.l	(F_BUFPTR,a1),a2
readline2:
	move.b	(a2)+,d0
	cmp.b	#CR,d0
	beq	readline3		;CR͓ǂݔ΂
	cmp.b	#LF,d0
	beq	readline5
	cmp.b	#EOF,d0
	beq	readline4
	move.b	d0,(a0)+
readline3:
	dbra	d3,readline1
	bra	readline5		;1ső咷𒴂

readline4:				;EOF
	cmp.w	#MAXLINELEN-2,d3
	beq	readline8		;sEOFȂ炻Ńt@CI
readline5:				;LF
	clr.b	(a0)
	moveq.l	#0,d0
readline9:
	subq.l	#1,d1
	sub.l	d1,d2
	move.l	d2,(F_PTROFST,a1)
	movem.l	(sp)+,d1-d3/a0-a2
	rts

readline8:				;G[/t@C̏I
	moveq.l	#-1,d0
	bra	readline9


;----------------------------------------------------------------
	.end

;----------------------------------------------------------------
;	$Log: file.s,v $
;	Revision 1.4  1999  2/27(Sat) 23:41:32 M.Kamada
;	+81 \[XXg̃tH[}bgύX(st@C+80Ƃ܂)
;
;	Revision 1.3  1997  9/28(Sun) 19:19:13 M.Kamada
;	+49 includeJgXCb`ϐ̏ɕύX
;
;	Revision 1.2  1997  9/14(Sun) 16:28:23 M.Kamada
;	+46 error.s𕪗
;
;	Revision 1.1  1994/02/15  12:21:10  nakamura
;	Initial revision
;
;
